# LinearMaps

*A Julia package for defining and working with linear maps.*

Linear maps are also known as linear transformations or linear operators acting on vectors.
The only requirement for a `LinearMap` is that it can act on a vector (by multiplication) efficiently.

| **Documentation**                                                               | **Build Status**                                                                                |
|:-------------------------------------------------------------------------------:|:-----------------------------------------------------------------------------------------------:|
| [![stable docs][docs-stable-img]][docs-stable-url] [![dev docs][docs-dev-img]][docs-dev-url] | [![build status][build-img]][build-url] [![coverage][codecov-img]][codecov-url] [![Aqua QA][aqua-img]][aqua-url] [![license][license-img]][license-url] |

## Installation

The package can be installed with the Julia package manager.
From the Julia REPL, type `]` to enter the Pkg REPL mode and run:

```julia
pkg> add LinearMaps
```

Or, equivalently, via the `Pkg` API:

```julia
julia> import Pkg; Pkg.add("LinearMaps")
```

[docs-dev-img]: https://img.shields.io/badge/docs-dev-blue.svg
[docs-dev-url]: https://JuliaLinearAlgebra.github.io/LinearMaps.jl/dev

[docs-stable-img]: https://img.shields.io/badge/docs-stable-blue.svg
[docs-stable-url]: https://JuliaLinearAlgebra.github.io/LinearMaps.jl/stable

[build-img]: https://github.com/JuliaLinearAlgebra/LinearMaps.jl/workflows/CI/badge.svg?branch=master
[build-url]: https://github.com/JuliaLinearAlgebra/LinearMaps.jl/actions?query=workflow%3ACI+branch%3Amaster

[codecov-img]: http://codecov.io/github/JuliaLinearAlgebra/LinearMaps.jl/coverage.svg?branch=master
[codecov-url]: http://codecov.io/github/JuliaLinearAlgebra/LinearMaps.jl?branch=master

[license-img]: http://img.shields.io/badge/license-MIT-brightgreen.svg?style=flat
[license-url]: LICENSE.md

[aqua-img]: https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg
[aqua-url]: https://github.com/JuliaTesting/Aqua.jl

# left.jl
# "special cases" related left vector multiplication like x = y'*A
# The subtlety is that y' is a AdjointAbsVec or a TransposeAbsVec
# which is a subtype of AbstractMatrix but it is really "vector like"
# so we want handle it like a vector (Issue#99)
# So this is an exception to the left multiplication rule by a AbstractMatrix
# that usually makes a WrappedMap.

# x = y'*A ⇐⇒ x' = (A'*y)
"""
    *(x::LinearAlgebra.AdjointAbsVec, A::LinearMap)::AdjointAbsVec

Compute the right-action of the linear map `A` on the adjoint vector `x`
and return an adjoint vector.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A=LinearMap([1.0 2.0; 3.0 4.0]); x=[1.0, 1.0]; x'A
1×2 adjoint(::Vector{Float64}) with eltype Float64:
 4.0  6.0
```
"""
Base.:(*)(y::LinearAlgebra.AdjointAbsVec, A::LinearMap) = adjoint(A' * y')

"""
    *(x::LinearAlgebra.TransposeAbsVec, A::LinearMap)::TransposeAbsVec

Compute the right-action of the linear map `A` on the transpose vector `x`
and return a transpose vector.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A=LinearMap([1.0 2.0; 3.0 4.0]); x=[1.0, 1.0]; transpose(x)*A
1×2 transpose(::Vector{Float64}) with eltype Float64:
 4.0  6.0
```
"""
Base.:(*)(y::LinearAlgebra.TransposeAbsVec, A::LinearMap) = transpose(transpose(A) * transpose(y))

# multiplication with vector/matrix

# handles both y::AbstractMatrix and y::AdjointAbsVecOrMat
"""
    mul!(C::AbstractMatrix, A::AbstractMatrix, B::LinearMap) -> C

Calculates the matrix representation of `A*B` and stores the result in `C`,
overwriting the existing value of `C`. Note that `C` must not be aliased with
either `A` or `B`. The computation `C = A*B` is performed via `C' = B'A'`.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A=[1.0 1.0; 1.0 1.0]; B=LinearMap([1.0 2.0; 3.0 4.0]); C = similar(A); mul!(C, A, B);

julia> C
2×2 Matrix{Float64}:
 4.0  6.0
 4.0  6.0
```
"""
function mul!(X::AbstractMatrix, Y::AbstractMatrix, A::LinearMap)
    check_dim_mul(X, Y, A)
    _unsafe_mul!(X, Y, A)
    return X
end

function _unsafe_mul!(X, Y::AbstractMatrix, A::LinearMap)
    _unsafe_mul!(X', A', Y')
    return X
end
function _unsafe_mul!(X, Y::TransposeAbsVecOrMat, A::LinearMap)
    _unsafe_mul!(transpose(X), transpose(A), transpose(Y))
    return X
end
# unwrap WrappedMaps
_unsafe_mul!(X, Y::AbstractMatrix, A::WrappedMap) = _unsafe_mul!(X, Y, A.lmap)
# disambiguation
_unsafe_mul!(X, Y::TransposeAbsVecOrMat, A::WrappedMap) = _unsafe_mul!(X, Y, A.lmap)

"""
    mul!(C::AbstractMatrix, A::AbstractMatrix, B::LinearMap, α, β) -> C

Combined inplace multiply-add ``A B α + C β``. The result is stored in `C` by overwriting
it. Note that `C` must not be aliased with either `A` or `B`.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A=[1.0 1.0; 1.0 1.0]; B=LinearMap([1.0 2.0; 3.0 4.0]); C = copy(A);

julia> mul!(C, A, B, 1, 1)
2×2 Matrix{Float64}:
 5.0  7.0
 5.0  7.0
```
"""
function mul!(X::AbstractMatrix, Y::AbstractMatrix, A::LinearMap, α::Number, β::Number)
    check_dim_mul(X, Y, A)
    _unsafe_mul!(X, Y, A, α, β)
end

function _unsafe_mul!(X, Y::AbstractMatrix, A::LinearMap, α, β)
    if iszero(β)
        _unsafe_mul!(X', conj(α)*A', Y')
    else
        !isone(β) && rmul!(X, β)
        _unsafe_mul!(X', conj(α)*A', Y', true, true)
    end
    return X
end
# unwrap WrappedMaps
_unsafe_mul!(X, Y::AbstractMatrix, A::WrappedMap, α, β) = _unsafe_mul!(X, Y, A.lmap, α, β)
# disambiguation
_unsafe_mul!(X, Y::TransposeAbsVecOrMat, A::WrappedMap, α, β) =
    _unsafe_mul!(X, Y, A.lmap, α, β)

"""
Lazy representation of a scaled map `λ * A = A * λ` with real or complex map
`A <: LinearMap{RealOrComplex}` and real or complex scaling factor
`λ <: RealOrComplex`.
"""
struct ScaledMap{T, S<:RealOrComplex, L<:LinearMap} <: LinearMap{T}
    λ::S
    lmap::L
    function ScaledMap{T}(λ::S, A::L) where {T, S <: RealOrComplex, L <: LinearMap{<:RealOrComplex}}
        @assert Base.promote_op(*, S, eltype(A)) == T "target type $T cannot hold products of $S and $(eltype(A)) objects"
        new{T,S,L}(λ, A)
    end
end

# constructor
ScaledMap(λ::RealOrComplex, lmap::LinearMap{<:RealOrComplex}) =
    ScaledMap{Base.promote_op(*, typeof(λ), eltype(lmap))}(λ, lmap)

# basic methods
Base.size(A::ScaledMap) = size(A.lmap)
Base.axes(A::ScaledMap) = axes(A.lmap)
Base.isreal(A::ScaledMap) = isreal(A.λ) && isreal(A.lmap)
LinearAlgebra.issymmetric(A::ScaledMap) = issymmetric(A.lmap)
LinearAlgebra.ishermitian(A::ScaledMap) = isreal(A.λ) && ishermitian(A.lmap)
LinearAlgebra.isposdef(A::ScaledMap) = isposdef(A.λ) && isposdef(A.lmap)

MulStyle(A::ScaledMap) = MulStyle(A.lmap)

Base.transpose(A::ScaledMap) = A.λ * transpose(A.lmap)
Base.adjoint(A::ScaledMap) = conj(A.λ) * adjoint(A.lmap)

# comparison (sufficient, not necessary)
Base.:(==)(A::ScaledMap, B::ScaledMap) =
    eltype(A) == eltype(B) && A.lmap == B.lmap && A.λ == B.λ

# scalar multiplication and division
Base.:(*)(α::RealOrComplex, A::LinearMap{<:RealOrComplex}) = ScaledMap(α, A)
Base.:(*)(A::LinearMap{<:RealOrComplex}, α::RealOrComplex) = ScaledMap(α, A)

Base.:(*)(α::Number, A::ScaledMap) = (α * A.λ) * A.lmap
Base.:(*)(A::ScaledMap, α::Number) = A.lmap * (A.λ * α)
# needed for disambiguation
Base.:(*)(α::RealOrComplex, A::ScaledMap) = (α * A.λ) * A.lmap
Base.:(*)(A::ScaledMap, α::RealOrComplex) = (A.λ * α) * A.lmap
Base.:(-)(A::LinearMap) = -1 * A

# composition (not essential, but might save multiple scaling operations)
Base.:(*)(A::ScaledMap, B::ScaledMap) = (A.λ * B.λ) * (A.lmap * B.lmap)
Base.:(*)(A::ScaledMap, B::LinearMap) = A.λ * (A.lmap * B)
Base.:(*)(A::LinearMap, B::ScaledMap) = (A * B.lmap) * B.λ

# multiplication with vectors/matrices
for In in (AbstractVector, AbstractMatrix)
    @eval begin
        # commutative case
        _unsafe_mul!(y, A::ScaledMap, x::$In{<:RealOrComplex}) =
            _unsafe_mul!(y, A.lmap, x, A.λ, false)
        _unsafe_mul!(y, A::ScaledMap, x::$In{<:RealOrComplex}, α, β) =
            _unsafe_mul!(y, A.lmap, x, A.λ * α, β)
        # non-commutative case
        _unsafe_mul!(y, A::ScaledMap, x::$In) = lmul!(A.λ, _unsafe_mul!(y, A.lmap, x))
    end
end

_unsafe_mul!(Y, X::ScaledMap, c::Number) = _unsafe_mul!(Y, X.lmap, X.λ*c)
_unsafe_mul!(Y, X::ScaledMap, c::Number, α, β) = _unsafe_mul!(Y, X.lmap, X.λ*c, α, β)

using LinearAlgebra, LinearMaps, Test
using LinearMaps: VecOrMatMap, ScaledMap
# using BenchmarkTools

function test_getindex(A::LinearMap, M::AbstractMatrix)
    @assert size(A) == size(M)
    mask = rand(Bool, size(A))
    imask = rand(Bool, size(A, 1))
    jmask = rand(Bool, size(A, 2))
    @test A[1,:] == M[1,:]
    @test A[:,1] == M[:,1]
    @test A[1:lastindex(A,1)-2,:] == M[1:lastindex(A,1)-2,:]
    @test A[:,1:4] == M[:,1:4]
    @test A[[2,1],:] == M[[2,1],:]
    @test A[:,[2,1]] == M[:,[2,1]]
    @test A[:,:] == M
    @test (lastindex(A, 1), lastindex(A, 2)) == size(A)
    if A isa VecOrMatMap || A isa ScaledMap{<:Any,<:Any,<:VecOrMatMap}
        @test A[:] == M[:]
        @test A[1,1] == M[1,1]
        @test A[1,1:3] == M[1,1:3]
        @test A[1:3,1] == M[1:3,1]
        @test A[2:end,1] == M[2:end,1]
        @test A[1:2,1:3] == M[1:2,1:3]
        @test A[[2,1],1:3] == M[[2,1],1:3]
        @test A[7] == M[7]
        @test A[3:7] == M[3:7]
        @test A[mask] == M[mask]
        @test A[findall(mask)] == M[findall(mask)]
        @test A[CartesianIndex(1,1)] == M[CartesianIndex(1,1)]
        @test A[imask, 1] == M[imask, 1]
        @test A[1, jmask] == M[1, jmask]
        @test A[imask, jmask] == M[imask, jmask]
    else
        @test_throws ErrorException A[:]
        @test_throws ErrorException A[1,1]
        @test_throws ErrorException A[1,1:3]
        @test_throws ErrorException A[1:3,1]
        @test_throws ErrorException A[2:end,1]
        @test_throws ErrorException A[1:2,1:3]
        @test_throws ErrorException A[[2,1],1:3]
        @test_throws ErrorException A[7]
        @test_throws ErrorException A[3:7]
        @test_throws ErrorException A[mask]
        @test_throws ErrorException A[findall(mask)]
        @test_throws ErrorException A[CartesianIndex(1,1)]
        @test_throws ErrorException A[imask, 1]
        @test_throws ErrorException A[1, jmask]
        @test_throws ErrorException A[imask, jmask]
    end
    @test_throws BoundsError A[lastindex(A,1)+1,1]
    @test_throws BoundsError A[1,lastindex(A,2)+1]
    @test_throws BoundsError A[2,1:lastindex(A,2)+1]
    @test_throws BoundsError A[1:lastindex(A,1)+1,2]
    @test_throws BoundsError A[ones(Bool, 2, 2)]
    @test_throws BoundsError A[[true, true], 1]
    @test_throws BoundsError A[1, [true, true]]
    return nothing
end

@testset "getindex" begin
    M = rand(4,6)
    A = LinearMap(M)
    test_getindex(A, M)
    test_getindex(2A, 2M)
    # @btime getindex($M, i) setup=(i = rand(1:24));
    # @btime getindex($A, i) setup=(i = rand(1:24));
    # @btime (getindex($M, i, j)) setup=(i = rand(1:4); j = rand(1:6));
    # @btime (getindex($A, i, j)) setup=(i = rand(1:4); j = rand(1:6));

    struct TwoMap <: LinearMaps.LinearMap{Float64} end
    Base.size(::TwoMap) = (5,5)
    LinearMaps._unsafe_mul!(y::AbstractVector, ::TwoMap, x::AbstractVector) = fill!(y, 2.0*sum(x))
    T = TwoMap()
    @test_throws ErrorException T[1,:]

    Base.transpose(A::TwoMap) = A
    test_getindex(TwoMap(), fill(2.0, size(T)))

    MA = rand(ComplexF64, 5, 5)
    FA = LinearMap{ComplexF64}((y, x) -> mul!(y, MA, x), (y, x) -> mul!(y, MA', x), 5, 5)
    F = LinearMap{ComplexF64}(x -> MA*x, y -> MA'y, 5, 5)
    test_getindex(FA, MA)
    test_getindex([FA FA], [MA MA])
    test_getindex([FA; FA], [MA; MA])
    test_getindex(F, MA)
    test_getindex(3FA, 3MA)
    test_getindex(FA + FA, 2MA)
    test_getindex(transpose(FA), transpose(MA))
    test_getindex(transpose(3FA), transpose(3MA))
    test_getindex(3transpose(FA), transpose(3MA))
    test_getindex(adjoint(FA), adjoint(MA))
    test_getindex(adjoint(3FA), adjoint(3MA))
    test_getindex(3adjoint(FA), adjoint(3MA))

    test_getindex(FillMap(0.5, (5, 5)), fill(0.5, (5, 5)))
    test_getindex(LinearMap(0.5I, 5), Matrix(0.5I, 5, 5))
end

# summary
Base.summary(io::IO, A::LinearMap) = print(io, map_summary(A))
function map_summary(A::LinearMap)
    Base.dims2string(size(A)) * ' ' * _show_typeof(A)
end

# show
Base.show(io::IO, A::LinearMap) = print(io, map_show(io, A, 0))

map_show(io::IO, A::LinearMap, i) = ' '^i * map_summary(A) * _show(io, A, i)
map_show(io::IO, A::AbstractVecOrMatOrQ, i) = ' '^i * summary(A)
_show(io::IO, ::LinearMap, _) = ""
function _show(io::IO, A::FunctionMap{T,F,Nothing}, _) where {T,F}
    "($(A.f); issymmetric=$(A._issymmetric), ishermitian=$(A._ishermitian), isposdef=$(A._isposdef))"
end
function _show(io::IO, A::FunctionMap, _)
    "($(A.f), $(A.fc); issymmetric=$(A._issymmetric), ishermitian=$(A._ishermitian), isposdef=$(A._isposdef))"
end
function _show(io::IO, A::Union{CompositeMap,LinearCombination,KroneckerMap,KroneckerSumMap}, i)
    n = length(A.maps)
    " with $n map" * (n>1 ? "s" : "") * ":\n" * print_maps(io, A.maps, i+2)
end
function _show(io::IO, A::Union{AdjointMap,TransposeMap,WrappedMap}, i)
    " of\n" * map_show(io, A.lmap, i+2)
end
function _show(io::IO, A::BlockMap, i)
    nrows = length(A.rows)
    n = length(A.maps)
    " with $n block map" * (n>1 ? "s" : "") *
        " in $nrows block row" * (nrows>1 ? "s" : "") * '\n' * print_maps(io, A.maps, i+2)
end
function _show(io::IO, A::BlockDiagonalMap, i)
    n = length(A.maps)
    " with $n diagonal block map" * (n>1 ? "s" : "") * ":\n" * print_maps(io, A.maps, i+2)
end
function _show(io::IO, J::UniformScalingMap, _)
    " with scaling factor: $(J.λ)"
end
function _show(io::IO, A::ScaledMap{T}, i) where {T}
    " with scale: $(A.λ) of\n" * map_show(io, A.lmap, i+2)
end
function _show(io::IO, A::FillMap{T}, _) where {T}
    " with fill value: $(A.λ)"
end

# helper functions
function _show_typeof(A::LinearMap{T}) where {T}
    split(string(typeof(A)), '{')[1] * '{' * string(T) * '}'
end
function _show_typeof(A::FunctionMap{T,<:Any,<:Any,iip}) where {T,iip}
    split(string(typeof(A)), '{')[1] * '{' * string(T) * ',' * string(iip) * '}'
end

function print_maps(io::IO, maps, k)
    n = length(maps)
    str = ""
    if get(io, :limit, true) && n > 10
        s = 1:5
        e = n-5:n
        if e[1] - s[end] > 1
            for i in s
                str *= map_show(io, maps[i], k) * '\n'
            end
            str *= ' '^k * '⋮'
            for i in e
                str *= '\n' * map_show(io, maps[i], k)
            end
        else
            for i in 1:n-1
                str *= map_show(io, maps[i], k) * '\n'
            end
            str *= map_show(io, last(maps), k)
        end
    else
        for i in 1:n-1
            str *= map_show(io, maps[i], k) * '\n'
        end
        str *= map_show(io, last(maps), k)
    end
    return str
end

# Matrix: create matrix representation of LinearMap
function Base.Matrix{T}(A::LinearMap) where {T}
    mat = Matrix{T}(undef, size(A))
    _unsafe_mul!(mat, A, true)
end

function Base.AbstractMatrix{T}(A::LinearMap) where {T}
    mat = similar(Array{T}, axes(A))
    _unsafe_mul!(mat, A, true)
end

Base.Matrix(A::LinearMap{T}) where {T} = Matrix{T}(A)
Base.AbstractMatrix(A::LinearMap{T}) where {T} = AbstractMatrix{T}(A)

Base.Array(A::LinearMap) = Matrix(A)
Base.convert(::Type{T}, A::LinearMap) where {T<:Matrix} = T(A)
Base.convert(::Type{Array}, A::LinearMap) = convert(Matrix, A)
# Base.convert(::Type{AbstractMatrix}, A::LinearMap) = convert(Matrix, A)
Base.convert(::Type{AbstractMatrix}, A::LinearMap) = AbstractMatrix(A)
Base.convert(::Type{AbstractArray}, A::LinearMap) = convert(AbstractMatrix, A)

# special cases

# UniformScalingMap
Base.convert(::Type{AbstractMatrix}, J::UniformScalingMap) = Diagonal(fill(J.λ, J.M))

# WrappedMap
Base.Matrix{T}(A::WrappedMap) where {T} = Matrix{T}(A.lmap)
Base.convert(::Type{T}, A::WrappedMap) where {T<:Matrix} = convert(T, A.lmap)
Base.Matrix{T}(A::VectorMap) where {T} = copyto!(Matrix{eltype(T)}(undef, size(A)), A.lmap)
Base.convert(::Type{T}, A::VectorMap) where {T<:Matrix} = T(A)
Base.convert(::Type{AbstractMatrix}, A::WrappedMap) = convert(AbstractMatrix, A.lmap)

# TransposeMap & AdjointMap
for (T, t) in ((AdjointMap, adjoint), (TransposeMap, transpose))
    @eval Base.convert(::Type{AbstractMatrix}, A::$T) = $t(convert(AbstractMatrix, A.lmap))
end

# CompositeMap
function Base.Matrix{T}(AB::CompositeMap{<:Any, <:Tuple{VecOrMatMap, LinearMap}}) where {T}
    B, A = AB.maps
    require_one_based_indexing(B)
    Y = Matrix{T}(undef, size(AB))
    for (yi, bi) in zip(eachcol(Y), eachcol(B.lmap))
        _unsafe_mul!(yi, A, bi)
    end
    return Y
end
for ((TA, fieldA), (TB, fieldB)) in (((VecOrMatMap, :lmap), (VecOrMatMap, :lmap)),
                                     ((VecOrMatMap, :lmap), (UniformScalingMap, :λ)),
                                     ((UniformScalingMap, :λ), (VecOrMatMap, :lmap)))
    @eval function Base.convert(::Type{AbstractMatrix},
                                AB::CompositeMap{<:Any,<:Tuple{$TB,$TA}})
        B, A = AB.maps
        return A.$fieldA*B.$fieldB
    end
end
function Base.Matrix{T}(AB::CompositeMap{<:Any, <:Tuple{VecOrMatMap, VecOrMatMap}}) where {T}
    B, A = AB.maps
    return mul!(Matrix{T}(undef, size(AB)), A.lmap, B.lmap)
end
function Base.Matrix{T}(λA::CompositeMap{<:Any, <:Tuple{VecOrMatMap, UniformScalingMap}}) where {T}
    A, J = λA.maps
    return mul!(Matrix{T}(undef, size(λA)), J.λ, A.lmap)
end
function Base.Matrix{T}(Aλ::CompositeMap{<:Any, <:Tuple{UniformScalingMap, VecOrMatMap}}) where {T}
    J, A = Aλ.maps
    return mul!(Matrix{T}(undef, size(Aλ)), A.lmap, J.λ)
end

# KroneckerMap & KroneckerSumMap
Base.Matrix{T}(A::KroneckerMap) where {T} = kron(convert.(Matrix{T}, A.maps)...)
Base.convert(::Type{AbstractMatrix}, A::KroneckerMap) =
    kron(convert.(AbstractMatrix, A.maps)...)

function Base.Matrix{T}(L::KroneckerSumMap) where {T}
    A, B = L.maps
    IA = Diagonal(ones(Bool, size(A, 1)))
    IB = Diagonal(ones(Bool, size(B, 1)))
    return kron(Matrix{T}(A), IB) + kron(IA, Matrix{T}(B))
end
function Base.convert(::Type{AbstractMatrix}, L::KroneckerSumMap)
    A, B = L.maps
    IA = Diagonal(ones(Bool, size(A, 1)))
    IB = Diagonal(ones(Bool, size(B, 1)))
    return kron(convert(AbstractMatrix, A), IB) + kron(IA, convert(AbstractMatrix, B))
end

# FillMap
Base.Matrix{T}(A::FillMap) where {T} = fill(T(A.λ), size(A))

struct FunctionMap{T, F1, F2, iip} <: LinearMap{T}
    f::F1
    fc::F2
    M::Int
    N::Int
    _issymmetric::Bool
    _ishermitian::Bool
    _isposdef::Bool
end

"""
    FunctionMap{T,iip}(f, [fc,], M, N = M; kwargs...)

Construct a `FunctionMap` object from a function or callable object `f` that represents a
linear map of size `(M, N)`, where `N` can be omitted for square operators of size `(M,M)`.
Furthermore, the `eltype` `T` of the corresponding matrix representation needs to be
specified, i.e., whether the action of `f` on a vector will be similar to, e.g., multiplying
by numbers of type `T`. Optionally, a second function `fc` can be specified that implements
the adjoint (or transpose in the real case) of `f`.

Accepted keyword arguments and their default values are as in the [`LinearMap`](@ref)
constructor.

# Examples
```jldoctest
julia> F = FunctionMap{Int64,false}(cumsum, 2)
2×2 FunctionMap{Int64,false}(cumsum; issymmetric=false, ishermitian=false, isposdef=false)

julia> F * ones(Int64, 2)
2-element Vector{Int64}:
 1
 2

julia> Matrix(F)
2×2 Matrix{Int64}:
 1  0
 1  1
"""
function FunctionMap{T,iip}(f::F1, fc::F2, M::Int, N::Int;
    issymmetric::Bool = false,
    ishermitian::Bool = (T<:Real && issymmetric),
    isposdef::Bool    = false) where {T, F1, F2, iip}
    FunctionMap{T, F1, F2, iip}(f, fc, M, N, issymmetric, ishermitian, isposdef)
end

# additional constructors
FunctionMap{T,iip}(f, M::Int, N::Int=M; kwargs...) where {T, iip} =
    FunctionMap{T,iip}(f, nothing, M, N; kwargs...)
FunctionMap{T,iip}(f, fc, M::Int; kwargs...) where {T, iip} =
    FunctionMap{T,iip}(f, fc, M, M; kwargs...)

FunctionMap{T}(f, fc, M::Int, N::Int; ismutating::Bool = _ismutating(f), kwargs...) where {T} =
    FunctionMap{T, ismutating}(f, fc, M, N; kwargs...)
FunctionMap{T}(f, M::Int; ismutating::Bool = _ismutating(f), kwargs...) where {T} =
    FunctionMap{T, ismutating}(f, nothing, M, M; kwargs...)
FunctionMap{T}(f, M::Int, N::Int; ismutating::Bool = _ismutating(f), kwargs...) where {T} =
    FunctionMap{T, ismutating}(f, nothing, M, N; kwargs...)
FunctionMap{T}(f, fc, M::Int; ismutating::Bool = _ismutating(f), kwargs...) where {T} =
    FunctionMap{T, ismutating}(f, fc, M, M; kwargs...)

const OOPFunctionMap{T,F1,F2} = FunctionMap{T,F1,F2,false}
const IIPFunctionMap{T,F1,F2} = FunctionMap{T,F1,F2,true}

# properties
Base.size(A::FunctionMap) = (A.M, A.N)
LinearAlgebra.issymmetric(A::FunctionMap) = A._issymmetric
LinearAlgebra.ishermitian(A::FunctionMap) = A._ishermitian
LinearAlgebra.isposdef(A::FunctionMap)    = A._isposdef
MulStyle(::OOPFunctionMap) = TwoArg()
MulStyle(::IIPFunctionMap) = ThreeArg()
@deprecate ismutating(A::FunctionMap) (a -> (MulStyle(a) === ThreeArg()))(A) false
_ismutating(f) = first(methods(f)).nargs == 3

# multiplication with vector
const TransposeFunctionMap = TransposeMap{<:Any, <:FunctionMap}
const AdjointFunctionMap = AdjointMap{<:Any, <:FunctionMap}

@inline function _apply_fun(::MulStyle, f!, x, m, T)
    y = similar(x, T, m)
    f!(y, x)
    return y
end
@inline function _apply_fun(::TwoArg, f, x, m, _)
    y = f(x)
    length(y) == m || throw(DimensionMismatch())
    return y
end

function Base.:(*)(A::FunctionMap, x::AbstractVector)
    length(x) == size(A, 2) || throw(DimensionMismatch())
    T = promote_type(eltype(A), eltype(x))
    return _apply_fun(MulStyle(A), A.f, x, size(A, 1), T)
end
function Base.:(*)(A::AdjointFunctionMap, x::AbstractVector)
    Afun = A.lmap
    ishermitian(Afun) && return Afun*x
    length(x) == size(A, 2) || throw(DimensionMismatch())
    T = promote_type(eltype(A), eltype(x))
    if Afun.fc !== nothing
        return _apply_fun(MulStyle(Afun), Afun.fc, x, size(A, 1), T)
    elseif issymmetric(Afun) # but !isreal(A), Afun.f can be used
        y = _apply_fun(MulStyle(Afun), Afun.f, conj(x), size(A, 1), T)
        conj!(y)
        return y
    else
        error("adjoint not implemented for $(A.lmap)")
    end
end
function Base.:(*)(A::TransposeFunctionMap, x::AbstractVector)
    Afun = A.lmap
    (issymmetric(Afun) || (isreal(A) && ishermitian(Afun))) && return Afun*x
    length(x) == size(A, 2) || throw(DimensionMismatch())
    T = promote_type(eltype(A), eltype(x))
    if Afun.fc !== nothing
        z = !isreal(A) ? conj(x) : x
        y = _apply_fun(MulStyle(Afun), Afun.fc, z, size(A, 1), T)
        !isreal(A) && conj!(y)
    elseif ishermitian(Afun) # but !isreal(A), Afun.f can be used
        y = _apply_fun(MulStyle(Afun), Afun.f, conj(x), size(A, 1), T)
        conj!(y)
    else
        error("transpose not implemented for $(A.lmap)")
    end
    return y
end

_unsafe_mul!(y, A::OOPFunctionMap, x::AbstractVector) = copyto!(y, A.f(x))
_unsafe_mul!(y, A::IIPFunctionMap, x::AbstractVector) = (A.f(y, x); return y)

function _unsafe_mul!(y, At::TransposeFunctionMap, x::AbstractVector)
    A = At.lmap
    (issymmetric(A) || (isreal(A) && ishermitian(A))) && return _unsafe_mul!(y, A, x)
    if A.fc !== nothing
        if !isreal(A)
            x = conj(x)
        end
        MulStyle(A) === TwoArg() ? copyto!(y, A.fc(x)) : A.fc(y, x)
        if !isreal(A)
            conj!(y)
        end
        return y
    elseif ishermitian(A) # but !isreal(A)
        _unsafe_mul!(y, A, conj(x))
        conj!(y)
        return y
    else
        error("transpose not implemented for $A")
    end
end

function _unsafe_mul!(y, Ac::AdjointFunctionMap, x::AbstractVector)
    A = Ac.lmap
    ishermitian(A) && return _unsafe_mul!(y, A, x)
    if A.fc !== nothing
        MulStyle(A) === TwoArg() ? copyto!(y, A.fc(x)) : A.fc(y, x)
        return y
    elseif issymmetric(A) # but !isreal(A)
        _unsafe_mul!(y, A, conj(x))
        conj!(y)
        return y
    else
        error("adjoint not implemented for $A")
    end
end

using Test, LinearMaps, LinearAlgebra, SparseArrays
using LinearMaps: MulStyle, FiveArg, ThreeArg, TwoArg

@testset "basic functionality" begin
    A = 2 * rand(ComplexF64, (20, 10)) .- 1
    v = rand(ComplexF64, 10)
    u = rand(ComplexF64, 20, 1)
    V = rand(ComplexF64, 10, 3)
    W = rand(ComplexF64, 20, 3)
    α = rand()
    β = rand()
    M = @inferred LinearMap(A)
    N = @inferred LinearMap(M)

    @testset "LinearMaps.jl" begin
        @test eltype(M) == eltype(A)
        @test size(M) == size(A)
        @test size(N) == size(A)
        @test !isreal(M)
        @test ndims(M) == 2
        @test_throws ErrorException size(M, 3)
        @test length(M) == length(A)
        @test occursin(Base.dims2string(size(M)) * " LinearMaps.WrappedMap", summary(M))
    end

    @testset "dimension checking" begin
        w = vec(u)
        @test_throws DimensionMismatch M * similar(v, length(v) + 1)
        @test_throws DimensionMismatch mul!(similar(w, length(w) + 1), M, v)
        @test_throws DimensionMismatch similar(w, length(w) + 1)' * M
        @test_throws DimensionMismatch mul!(copy(v)', similar(w, length(w) + 1)', M)
        @test_throws DimensionMismatch mul!(similar(W, size(W).+(0,1)), M, V)
        @test_throws DimensionMismatch mul!(copy(W), M, similar(V, size(V).+(0,1)))
    end
end

@testset "new LinearMap type" begin
    # new type
    struct SimpleFunctionMap <: LinearMap{Float64}
        f::Function
        N::Int
    end
    struct SimpleComplexFunctionMap <: LinearMap{Complex{Float64}}
        f::Function
        N::Int
    end
    Base.size(A::Union{SimpleFunctionMap,SimpleComplexFunctionMap}) = (A.N, A.N)
    Base.:(*)(A::Union{SimpleFunctionMap,SimpleComplexFunctionMap}, v::AbstractVector) = A.f(v)
    LinearMaps.MulStyle(::Union{SimpleFunctionMap,SimpleComplexFunctionMap}) = LinearMaps.TwoArg()
    LinearAlgebra.mul!(y::AbstractVector, A::Union{SimpleFunctionMap,SimpleComplexFunctionMap}, x::AbstractVector) = copyto!(y, *(A, x))

    F = SimpleFunctionMap(cumsum, 10)
    FC = SimpleComplexFunctionMap(cumsum, 10)
    @test @inferred ndims(F) == 2
    @test @inferred size(F, 1) == 10
    @test @inferred length(F) == 100
    @test @inferred !issymmetric(F)
    @test @inferred !ishermitian(F)
    @test @inferred !ishermitian(FC)
    @test @inferred !isposdef(F)
    @test occursin("10×10 SimpleFunctionMap{$(eltype(F))}", sprint((t, s) -> show(t, "text/plain", s), F))
    @test occursin("10×10 SimpleComplexFunctionMap{$(eltype(FC))}", sprint((t, s) -> show(t, "text/plain", s), FC))
    α = rand(ComplexF64); β = rand(ComplexF64)
    v = rand(ComplexF64, 10); V = rand(ComplexF64, 10, 3)
    w = rand(ComplexF64, 10); W = rand(ComplexF64, 10, 3)
    F(v) == F*v
    @test mul!(w, F, v) === w == F * v
    @test_throws ErrorException("transpose not implemented for "*sprint((t, s) -> show(t, "text/plain", s), F)) F' * v
    @test_throws ErrorException transpose(F) * v
    @test_throws ErrorException("adjoint not implemented for "*sprint((t, s) -> show(t, "text/plain", s), FC)) mul!(w, adjoint(FC), v)
    @test_throws ErrorException mul!(w, transpose(F), v)
    FM = convert(AbstractMatrix, F)
    L = LowerTriangular(ones(10, 10))
    @test FM == L
    @test F * v ≈ L * v
    # generic 5-arg mul! and matrix-mul!
    @test mul!(copy(w), F, v, α, β) ≈ L*v*α + w*β
    @test mul!(copy(w), F, v, 0, β) ≈ w*β
    @test mul!(copy(W), F, V) ≈ L*V
    @test mul!(copy(W), F, V, α, β) ≈ L*V*α + W*β
    @test mul!(copy(W), F, V, 0, β) ≈ W*β
    @test mul!(copy(FM), F, 1, true, true) == 2FM

    Fs = sparse(F)
    @test SparseMatrixCSC(F) == Fs == L
    @test Fs isa SparseMatrixCSC
end

@testset "transpose of new LinearMap type" begin
    struct MyFillMap{T} <: LinearMaps.LinearMap{T}
        λ::T
        size::Dims{2}
        function MyFillMap(λ::T, dims::Dims{2}) where {T}
            all(d -> d >= 0, dims) || throw(ArgumentError("dims of MyFillMap must be non-negative"))
            promote_type(T, typeof(λ)) == T || throw(InexactError())
            return new{T}(λ, dims)
        end
    end
    Base.size(A::MyFillMap) = A.size
    function LinearAlgebra.mul!(y::AbstractVecOrMat, A::MyFillMap, x::AbstractVector)
        LinearMaps.check_dim_mul(y, A, x)
        return fill!(y, iszero(A.λ) ? zero(eltype(y)) : A.λ*sum(x))
    end
    function LinearAlgebra.mul!(y::AbstractVecOrMat, transA::LinearMaps.TransposeMap{<:Any,<:MyFillMap}, x::AbstractVector)
        LinearMaps.check_dim_mul(y, transA, x)
        λ = transA.lmap.λ
        return fill!(y, iszero(λ) ? zero(eltype(y)) : transpose(λ)*sum(x))
    end

    A = MyFillMap(5.0, (3, 3))
    x = ones(3)
    @test A * x == fill(15.0, 3)
    @test mul!(zeros(3), A, x) == mul!(zeros(3), A, x, 1, 0) == fill(15.0, 3)
    @test mul!(ones(3), A, x, 2, 2) == fill(32.0, 3)
    @test mul!(ones(3,3), A, reshape(collect(1:9), 3, 3), 2, 2)[:,1] == fill(62.0, 3)
    @test A'x == mul!(zeros(3), A', x)
    for α in (true, false, 0, 1, randn()), β in (true, false, 0, 1, randn())
        @test mul!(ones(3), A', x, α, β) == fill(β, 3) + fill(15α, 3)
        @test mul!(ones(3, 2), A', [x x], α, β) == fill(β, 3, 2) + fill(15α, 3, 2)
    end
    @test Matrix(A') == Matrix(A)'
end

@testset "MulStyle" begin
    A = LinearMap(zeros(2,2))
    Q = LinearMap(qr(randn(2,2)).Q)
    F = LinearMap(cumsum, 2)
    @test MulStyle(A, A) === FiveArg()
    @test MulStyle(Q, Q) === ThreeArg()
    @test MulStyle(F, F) === TwoArg()
    @test MulStyle(A, Q) === MulStyle(Q, A) === ThreeArg()
    @test MulStyle(A, F) === MulStyle(F, A) === TwoArg()
    @test MulStyle(Q, F) === MulStyle(F, Q) === ThreeArg()
end

using Test, LinearMaps, LinearAlgebra, BlockArrays

@testset "Non-traditional axes" begin

    A = rand(ComplexF64,2,4)
    B = PseudoBlockMatrix{ComplexF64}(undef, [2,3], [3,4])

    ax1 = axes(B)[1]
    ax2 = axes(B)[2]
    fill!(B,0)
    B[Block(1),Block(2)] .= A

    N = @inferred LinearMap(B)
    @test axes(N) == (ax1,ax2)
    @test axes(N, 1) == ax1
    @test axes(N, 2) == ax2
    @test_throws ErrorException axes(N, 3)

    @test eltype(N) == eltype(B)

    u = similar(Array{ComplexF64}, ax2)
    v = PseudoBlockVector{ComplexF64}(undef, [3,5])
    w = similar(Array{ComplexF64}, ax1)

    for i in eachindex(u) u[i] = rand(ComplexF64) end
    for i in eachindex(v) v[i] = rand(ComplexF64) end
    for i in eachindex(w) w[i] = rand(ComplexF64) end

    @test B*u == N*u
    @test_throws DimensionMismatch N*v

    # Lu = L*u
    Nu = N*u

    @test axes(Nu)[1] == axes(N)[1] == axes(B)[1]
    @test blocklengths(axes(Nu)[1]) == blocklengths(axes(N)[1]) == blocklengths(axes(B)[1]) == [2,3]

    for trans in (adjoint, transpose)
        Nt = trans(LinearMap(N))
        Bt = trans(B)
        Ntw = Nt*w
        Btw = Bt*w
        @test Ntw ≈ Btw
        @test axes(Ntw)[1] == axes(Nt)[1] == axes(Bt)[1]
        @test blocklengths(axes(Ntw)[1]) == blocklengths(axes(Nt)[1]) == blocklengths(axes(Bt)[1]) == [3,4]
    end

    C = B + 2N
    @test axes(C) === axes(B) === axes(N)
    @test C*u ≈ 3*Nu

    Cu = C*u
    @test axes(C)[1] == ax1
    @test blocklengths(axes(C)[1]) == blocklengths(ax1)

    A = rand(ComplexF64,2,2)
    B = PseudoBlockMatrix{ComplexF64}(undef, [2,2], [2,2])
    ax1 = axes(B)[1]
    ax2 = axes(B)[2]
    fill!(B,0)
    B[Block(1),Block(2)] .= A
    L = LinearMap(B)
    L2 = L*L
    B2 = B*B
    @test axes(L2) == axes(B2)
    B2 = B*Matrix(B)
    L2 = L*LinearMap(Matrix(B))
    @test axes(L2) == axes(B2)
    u = similar(Array{ComplexF64}, ax2)
    B2u = B2*u; L2u = L2*u
    @test axes(B2u)[1] == axes(L2u)[1] == axes(B2)[1] == axes(L2)[1]
    @test blocklengths(axes(B2u)[1]) == blocklengths(axes(L2u)[1]) == [2,2]

    D1 = rand(4,5)
    D2 = rand(5,3)
    D3 = rand(3,6)
    D4 = rand(6,6)
    A1 = PseudoBlockMatrix(D1, [1,3], [2,3])
    A2 = PseudoBlockMatrix(D2, [2,3], [2,1])
    A3 = PseudoBlockMatrix(D3, [2,1], [3,2,1])
    A4 = PseudoBlockMatrix(D4, [3,2,1], [3,2,1])
    u = rand(6)
    x = PseudoBlockVector(u, [3,2,1])
    L = LinearMap(A1) * LinearMap(A2) * LinearMap(A3) * LinearMap(A4)
    y = L * x
    v = Vector(y)
    @test v ≈ D1*(D2*(D3*(D4*u)))
end

using Test, LinearMaps, LinearAlgebra, SparseArrays, IterativeSolvers

@testset "inversemap" begin
    # First argument to cg!/gmres! doubles as the initial guess so we make sure
    # it is 0 instead of potential garbage since we don't control the
    # allocation of the output vector.
    cgz! = (x, A, b) -> IterativeSolvers.cg!(fill!(x, 0), A, b)
    gmresz! = (x, A, b) -> IterativeSolvers.gmres!(fill!(x, 0), A, b)

    # Dense test data
    A = rand(10, 10) + 5I; A = A'A
    B = rand(10, 10)
    b = rand(10)
    ## LU
    @test A \ b ≈ InverseMap(lu(A)) * b
    ## Cholesky
    @test A \ b ≈ InverseMap(cholesky(A)) * b
    ## Specify solver
    @test A \ b ≈ InverseMap(A; solver=cgz!) * b atol=1e-8
    ## Composition with other maps
    @test A \ B * b ≈ InverseMap(lu(A)) * B * b
    ## Composition: make sure solvers called with vector B * b and not matrix B
    my_ldiv! = (y, A, x) -> begin
        @test x isa AbstractVector
        @test x ≈ B * b
        return ldiv!(y, lu(A), x)
    end
    @test A \ B * b ≈ InverseMap(A; solver=my_ldiv!) * B * b
    ## 3- and 5-arg mul!
    iA = InverseMap(lu(A))
    y = zeros(size(A, 1))
    mul!(y, iA, b)
    @test A \ b ≈ y
    Y = zeros(size(A))
    mul!(Y, iA, B)
    @test A \ B ≈ Y
    y = rand(size(A, 1))
    yc = copy(y)
    α, β = 1.2, 3.4
    mul!(y, iA, b, α, β)
    @test A \ b * α + yc * β ≈ y
    Y = rand(size(A)...)
    Yc = copy(Y)
    mul!(Y, iA, B, α, β)
    @test A \ B * α + Yc * β ≈ Y

    # Sparse test data
    A = sprand(10, 10, 0.2) + 5I; A = A'A
    B = sprand(10, 10, 0.5)
    @test A \ b ≈ InverseMap(lu(A)) * b
    ## Cholesky (CHOLMOD doesn't support inplace ldiv!)
    my_ldiv! = (y, A, x) -> copy!(y, A \ x)
    @test A \ b ≈ InverseMap(cholesky(A); solver=my_ldiv!) * b
    ## Specify solver
    @test A \ b ≈ InverseMap(A; solver=cgz!) * b atol=1e-8
    ## Composition with other maps
    @test A \ (B * b) ≈ InverseMap(lu(A)) * B * b
    ## Composition: make sure solver is called with vector B * b and not matrix B
    my_ldiv! = (y, A, x) -> begin
        @test x isa AbstractVector
        @test x ≈ B * b
        return ldiv!(y, lu(A), x)
    end
    @test A \ (B * b) ≈ InverseMap(A; solver=my_ldiv!) * B * b
    ## 3- and 5-arg mul!
    iA = InverseMap(lu(A))
    y = zeros(size(A, 1))
    mul!(y, iA, b)
    @test A \ b ≈ y
    y = rand(size(A, 1))
    yc = copy(y)
    α, β = 1.2, 3.4
    mul!(y, iA, b, α, β)
    @test A \ b * α + yc * β ≈ y

    # Combine with another LinearMap
    A = LinearMap(cumsum, 10, 10)
    iA = InverseMap(A; solver=gmresz!)
    y = zeros(size(A, 1))
    mul!(y, iA, b)
    @test IterativeSolvers.gmres(A, b) ≈ iA * b ≈ y
    y = rand(size(A, 1))
    yc = copy(y)
    α, β = 1.2, 3.4
    mul!(y, iA, b, α, β)
    @test IterativeSolvers.gmres(A, b * α) + β * yc ≈ iA * b * α + yc * β ≈ y

    # Interface testing: note that not all combinations of factorization and
    # is(symmetric|hermitian|posdef) and transpose/adjoint are supported by LinearAlgebra,
    # so we test this for a custom type just to make sure the call is forwarded correctly
    # and then run some tests for supported combinations.
    struct TestMap{T} <: LinearMap{T}
        A::Matrix{T}
    end
    Base.size(tm::TestMap) = size(tm.A)
    Base.transpose(tm::TestMap) = transpose(tm.A)
    Base.adjoint(tm::TestMap) = adjoint(tm.A)
    LinearAlgebra.issymmetric(tm::TestMap) = issymmetric(tm.A)
    LinearAlgebra.ishermitian(tm::TestMap) = ishermitian(tm.A)
    LinearAlgebra.isposdef(tm::TestMap) = isposdef(tm.A)
    A = [5.0 2.0; 2.0 4.0]
    itm = InverseMap(TestMap(A))
    @test size(itm) == size(A)
    @test transpose(itm).A === transpose(A)
    @test adjoint(itm).A === adjoint(A)
    @test issymmetric(itm)
    @test ishermitian(itm)
    @test isposdef(itm)
    ## Real symmetric (and Hermitian)
    A = Float64[3 2; 2 5]; x = rand(2)
    ### Wrapping a matrix and factorize in solver
    iA = InverseMap(A; solver=(y, A, x)->ldiv!(y, cholesky(A), x))
    @test ishermitian(A) == ishermitian(iA) == true
    @test issymmetric(A) == issymmetric(iA) == true
    @test isposdef(A) == isposdef(iA) == true
    @test A \ x ≈ iA * x
    if VERSION >= v"1.8.0-"
        @test transpose(A) \ x ≈ transpose(iA) * x
        @test adjoint(A) \ x ≈ adjoint(iA) * x
    end
    ### Wrapping a factorization
    iA = InverseMap(cholesky(A))
    # @test ishermitian(A) == ishermitian(iA) == true
    # @test issymmetric(A) == issymmetric(iA) == true
    @test isposdef(A) == isposdef(iA) == true
    @test A \ x ≈ iA * x
    # @test transpose(A) \ x ≈ transpose(iA) * x
    if VERSION >= v"1.7.0"
        @test adjoint(A) \ x ≈ adjoint(iA) * x
    end
    ## Real non-symmetric
    A = Float64[3 2; -2 5]; x = rand(2)
    ### Wrapping a matrix and factorize in solver
    iA = InverseMap(A; solver=(y, A, x)->ldiv!(y, lu(A), x))
    @test ishermitian(A) == ishermitian(iA) == false
    @test issymmetric(A) == issymmetric(iA) == false
    @test isposdef(A) == isposdef(iA) == false
    @test A \ x ≈ iA * x
    @test transpose(A) \ x ≈ transpose(iA) * x
    @test adjoint(A) \ x ≈ adjoint(iA) * x
    ### Wrapping a factorization
    iA = InverseMap(lu(A))
    # @test ishermitian(A) == ishermitian(iA) == true
    # @test issymmetric(A) == issymmetric(iA) == true
    # @test isposdef(A) == isposdef(iA) == true
    @test A \ x ≈ iA * x
    @test transpose(A) \ x ≈ transpose(iA) * x
    @test adjoint(A) \ x ≈ adjoint(iA) * x
    ## Complex Hermitian
    A = ComplexF64[3 2im; -2im 5]; x = rand(ComplexF64, 2)
    ### Wrapping a matrix and factorize in solver
    iA = InverseMap(A; solver=(y, A, x)->ldiv!(y, cholesky(A), x))
    @test ishermitian(A) == ishermitian(iA) == true
    @test issymmetric(A) == issymmetric(iA) == false
    @test isposdef(A) == isposdef(iA) == true
    @test A \ x ≈ iA * x
    if VERSION >= v"1.8.0-"
        @test transpose(A) \ x ≈ transpose(iA) * x
        @test adjoint(A) \ x ≈ adjoint(iA) * x
    end
    ### Wrapping a factorization
    iA = InverseMap(cholesky(A))
    # @test ishermitian(A) == ishermitian(iA) == true
    # @test issymmetric(A) == issymmetric(iA) == true
    @test isposdef(A) == isposdef(iA) == true
    @test A \ x ≈ iA * x
    # @test transpose(A) \ x ≈ transpose(iA) * x
    if VERSION >= v"1.7.0"
        @test adjoint(A) \ x ≈ adjoint(iA) * x
    end
    ## Complex non-Hermitian
    A = ComplexF64[3 2im; 3im 5]; x = rand(ComplexF64, 2)
    ### Wrapping a matrix and factorize in solver
    iA = InverseMap(A; solver=(y, A, x)->ldiv!(y, lu(A), x))
    @test ishermitian(A) == ishermitian(iA) == false
    @test issymmetric(A) == issymmetric(iA) == false
    @test isposdef(A) == isposdef(iA) == false
    @test A \ x ≈ iA * x
    @test transpose(A) \ x ≈ transpose(iA) * x
    @test adjoint(A) \ x ≈ adjoint(iA) * x
    ### Wrapping a factorization
    iA = InverseMap(lu(A))
    # @test ishermitian(A) == ishermitian(iA) == true
    # @test issymmetric(A) == issymmetric(iA) == true
    # @test isposdef(A) == isposdef(iA) == true
    @test A \ x ≈ iA * x
    @test transpose(A) \ x ≈ transpose(iA) * x
    @test adjoint(A) \ x ≈ adjoint(iA) * x

    # Example from https://www.dealii.org/current/doxygen/deal.II/step_20.html#SolvingusingtheSchurcomplement
    M = sparse(2.0I, 10, 10) + sprand(10, 10, 0.1); M = M'M
    iM = InverseMap(M; solver=cgz!)
    B = sparse(5.0I, 10, 5)
    F = rand(10)
    G = rand(5)
    ## Solve using Schur complement
    G′ = B' * iM * F - G
    S = B' * iM * B
    P = IterativeSolvers.cg(S, G′)
    U = IterativeSolvers.cg(M, F - B * P)
    ## Solve using standard method and compare
    @test [M B; B' 0I] \ [F; G] ≈ [U; P] atol=1e-8
end

using LinearMaps, LinearAlgebra, Test

@testset "filled maps" begin
    M, N = 2, 3
    μ = rand()
    for λ in (true, false, 3, μ, μ + 2im)
        L = FillMap(λ, (M, N))
        @test L == FillMap(λ, M, N)
        @test occursin("$M×$N FillMap{$(typeof(λ))} with fill value: $λ", sprint((t, s) -> show(t, "text/plain", s), L))
        @test LinearMaps.MulStyle(L) === LinearMaps.FiveArg()
        A = fill(λ, (M, N))
        x = rand(typeof(λ) <: Real ? Float64 : ComplexF64, 3)
        X = rand(typeof(λ) <: Real ? Float64 : ComplexF64, 3, 4)
        w = similar(x, 2)
        W = similar(X, 2, 4)
        @test size(L) == (M, N)
        @test adjoint(L) == FillMap(adjoint(λ), (3,2))
        @test transpose(L) == FillMap(λ, (3,2))
        @test !issymmetric(L)
        @test !ishermitian(L)
        @test !isposdef(L)
        @test Matrix(L) == A == mul!(copy(A), L, 1) == mul!(copy(A), L, 1, true, false)
        @test mul!(copy(1A), L, 2, true, true) == 3A
        @test L * x ≈ A * x
        @test mul!(w, L, x) ≈ A * x
        @test mul!(W, L, X) ≈ A * X
        for α in (true, false, 1, 0, randn()), β in (true, false, 1, 0, randn())
            @test mul!(copy(w), L, x, α, β) ≈ fill(λ * sum(x) * α, M) + w * β
            @test mul!(copy(W), L, X, α, β) ≈ λ * reduce(vcat, sum(X, dims=1) for _ in 1:2) * α + W * β
        end
    end
    @test issymmetric(FillMap(μ + 1im, (3, 3)))
    @test ishermitian(FillMap(μ + 0im, (3, 3)))
    @test isposdef(FillMap(μ, (1,1))) == isposdef(μ)
    @test !isposdef(FillMap(μ, (3,3)))
    α = rand()
    β = rand()
    @test FillMap(μ, (M, N)) + FillMap(α, (M, N)) == FillMap(μ + α, (M, N))
    @test FillMap(μ, (M, N)) - FillMap(α, (M, N)) == FillMap(μ - α, (M, N))
    @test α*FillMap(μ, (M, N)) == FillMap(α * μ, (M, N))
    @test FillMap(μ, (M, N))*α == FillMap(μ * α, (M, N))
    @test FillMap(μ, (M, N))*FillMap(μ, (N, M)) == FillMap(μ^2*N, (M, M))
    @test Matrix(FillMap(μ, (M, N))*FillMap(μ, (N, M))) ≈ fill(μ, (M, N))*fill(μ, (N, M))
end

struct TransposeMap{T, A<:LinearMap{T}} <: LinearMap{T}
    lmap::A
end
struct AdjointMap{T, A<:LinearMap{T}} <: LinearMap{T}
    lmap::A
end

MulStyle(A::Union{TransposeMap,AdjointMap}) = MulStyle(A.lmap)

# transposition behavior of LinearMap objects
LinearAlgebra.transpose(A::TransposeMap) = A.lmap
LinearAlgebra.adjoint(A::AdjointMap) = A.lmap

"""
    transpose(A::LinearMap)

Construct a lazy representation of the transpose of `A`. This can be either a
`TransposeMap` wrapper of `A`, or a suitably redefined instance of the same type
as `A`. For instance, for a linear combination of linear maps ``A + B``, the transpose
is given by ``A^⊤ + B^⊤``, i.e., another linear combination of linear maps.
"""
LinearAlgebra.transpose(A::LinearMap) = TransposeMap(A)

"""
    adjoint(A::LinearMap)

Construct a lazy representation of the adjoint of `A`. This can be either a
`AdjointMap` wrapper of `A`, or a suitably redefined instance of the same type
as `A`. For instance, for a linear combination of linear maps ``A + B``, the adjoint
is given by ``A^* + B^*``, i.e., another linear combination of linear maps.
"""
LinearAlgebra.adjoint(A::LinearMap) = AdjointMap(A)
LinearAlgebra.adjoint(A::LinearMap{<:Real}) = transpose(A)

# properties
Base.size(A::Union{TransposeMap, AdjointMap}) = reverse(size(A.lmap))
Base.axes(A::Union{TransposeMap, AdjointMap}) = reverse(axes(A.lmap))
LinearAlgebra.issymmetric(A::Union{TransposeMap, AdjointMap}) = issymmetric(A.lmap)
LinearAlgebra.ishermitian(A::Union{TransposeMap, AdjointMap}) = ishermitian(A.lmap)
LinearAlgebra.isposdef(A::Union{TransposeMap, AdjointMap}) = isposdef(A.lmap)

# comparison of TransposeMap objects
Base.:(==)(A::TransposeMap, B::TransposeMap) = A.lmap == B.lmap
Base.:(==)(A::AdjointMap, B::AdjointMap)     = A.lmap == B.lmap
Base.:(==)(A::TransposeMap, B::AdjointMap)   = false # isreal(B) && A.lmap == B.lmap # isreal(::AdjointMap) == false
Base.:(==)(A::AdjointMap, B::TransposeMap)   = false # isreal(A) && A.lmap == B.lmap # isreal(::AdjointMap) == false
Base.:(==)(A::TransposeMap, B::LinearMap)    = issymmetric(B) && A.lmap == B
Base.:(==)(A::AdjointMap, B::LinearMap)      = ishermitian(B) && A.lmap == B
Base.:(==)(A::LinearMap, B::TransposeMap)    = issymmetric(A) && B.lmap == A
Base.:(==)(A::LinearMap, B::AdjointMap)      = ishermitian(A) && B.lmap == A

# multiplication with vector/matrices
for (Typ, prop, text) in ((AdjointMap, ishermitian, "adjoint"), (TransposeMap, issymmetric, "transpose"))
    @eval _unsafe_mul!(y, A::$Typ, x::AbstractVector) =
        $prop(A.lmap) ?
            _unsafe_mul!(y, A.lmap, x) : error($text * " not implemented for $(A.lmap)")
    @eval _unsafe_mul!(y, A::$Typ, x::AbstractVector, α, β) =
        $prop(A.lmap) ?
            _unsafe_mul!(y, A.lmap, x, α, β) : _generic_map_mul!(y, A, x, α, β)

    for In in (Number, AbstractMatrix)
        @eval _unsafe_mul!(y, A::$Typ, x::$In) =
            $prop(A.lmap) ?
                _unsafe_mul!(y, A.lmap, x) : _generic_map_mul!(y, A, x)

        @eval _unsafe_mul!(y, A::$Typ, x::$In, α, β) =
            ishermitian(A.lmap) ?
                _unsafe_mul!(y, A.lmap, x, α, β) : _generic_map_mul!(y, A, x, α, β)
    end
end

# # ConjugateMap
const ConjugateMap = AdjointMap{<:Any, <:TransposeMap}
# canonical order of adjoint followed by transpose
LinearAlgebra.transpose(A::AdjointMap) = adjoint(transpose(A.lmap))
LinearAlgebra.transpose(A::ConjugateMap) = adjoint(A.lmap.lmap)
for In in (AbstractVector, AbstractMatrix)
    @eval begin
        _unsafe_mul!(y, Ac::ConjugateMap, x::$In) = conj!(_unsafe_mul!(y, Ac.lmap.lmap, conj(x)))
        function _unsafe_mul!(y, Ac::ConjugateMap, x::$In, α, β)
            xca = conj!(x * α)
            if !iszero(β)
                z = similar(y)
                _unsafe_mul!(z, Ac.lmap.lmap, xca)
                y .= y .* β + conj.(z)
            else
                conj!(_unsafe_mul!(y, Ac.lmap.lmap, xca))
            end
            return y
        end
    end
end
_unsafe_mul!(y, Ac::ConjugateMap, x::Number) = conj!(_unsafe_mul!(y, Ac.lmap.lmap, conj(x)))

struct CompositeMap{T, As<:LinearMapTupleOrVector} <: LinearMap{T}
    maps::As # stored in order of application to vector
    function CompositeMap{T, As}(maps::As) where {T, As}
        N = length(maps)
        for n in 2:N
            check_dim_mul(maps[n], maps[n-1])
        end
        for TA in Base.Iterators.map(eltype, maps)
            promote_type(T, TA) == T ||
                error("eltype $TA cannot be promoted to $T in CompositeMap constructor")
        end
        new{T, As}(maps)
    end
end
CompositeMap{T}(maps::As) where {T, As<:LinearMapTupleOrVector} = CompositeMap{T, As}(maps)

Base.mapreduce(::typeof(identity), ::typeof(Base.mul_prod), maps::LinearMapTupleOrVector) =
    CompositeMap{promote_type(map(eltype, maps)...)}(_reverse!(maps))
Base.mapreduce(::typeof(identity), ::typeof(Base.mul_prod), maps::AbstractVector{<:LinearMap{T}}) where {T} =
    CompositeMap{T}(reverse!(maps))

MulStyle(A::CompositeMap) = MulStyle(A.maps...) === TwoArg() ? TwoArg() : ThreeArg()

# basic methods
Base.size(A::CompositeMap) = (size(last(A.maps), 1), size(first(A.maps), 2))
Base.axes(A::CompositeMap) = (axes(last(A.maps))[1], axes(first(A.maps))[2])
Base.isreal(A::CompositeMap) = all(isreal, A.maps) # sufficient but not necessary

# the following rules are sufficient but not necessary
for (f, _f, g) in ((:issymmetric, :_issymmetric, :transpose),
                    (:ishermitian, :_ishermitian, :adjoint))
    @eval begin
        LinearAlgebra.$f(A::CompositeMap) = $_f(A.maps)
        $_f(maps::Tuple{}) = true
        $_f(maps::Tuple{<:LinearMap}) = $f(first(maps))
        $_f(maps::LinearMapTuple) =
            maps[end] == $g(first(maps)) && $_f(Base.front(Base.tail(maps)))
        function $_f(maps::LinearMapVector)
            n = length(maps)
            if n == 0
                return true
            elseif n == 1
                return ($f(first(maps)))::Bool
            else
                return ((last(maps) == $g(first(maps)))::Bool && $_f(@views maps[begin+1:end-1]))
            end
        end
        # since the introduction of ScaledMap, the following cases cannot occur
        # function $_f(maps::Tuple{Vararg{LinearMap}}) # length(maps) >= 2
            # if maps[1] isa UniformScalingMap{<:RealOrComplex}
            #     return $f(maps[1]) && $_f(Base.tail(maps))
            # elseif maps[end] isa UniformScalingMap{<:RealOrComplex}
            #     return $f(maps[end]) && $_f(Base.front(maps))
            # else
                # return maps[end] == $g(maps[1]) && $_f(Base.front(Base.tail(maps)))
            # end
        # end
    end
end

# A * B * A and A * B * A' are positive definite if (sufficient condition) A & B are positive definite
LinearAlgebra.isposdef(A::CompositeMap) = _isposdef(A.maps)
_isposdef(maps::Tuple{}) = true # empty product is equivalent to "I" which is pos. def.
_isposdef(maps::Tuple{<:LinearMap}) = isposdef(maps[1])
function _isposdef(maps::LinearMapTuple)
    (maps[end] == adjoint(maps[1]) || maps[end] == maps[1]) &&
        isposdef(maps[1]) && _isposdef(Base.front(Base.tail(maps)))
end
function _isposdef(maps::LinearMapVector)
    n = length(maps)
    if n == 0
        return true
    elseif n == 1
        return isposdef(first(maps))
    else
        return (last(maps) == adjoint(first(maps)) || last(maps) == first(maps)) &&
            isposdef(first(maps)) && _isposdef(maps[begin+1:end-1])
    end
end

# scalar multiplication and division (non-commutative case)
function Base.:(*)(α::Number, A::LinearMap)
    T = promote_type(typeof(α), eltype(A))
    return CompositeMap{T}(_combine(A, UniformScalingMap(α, size(A, 1))))
end
function Base.:(*)(α::Number, A::CompositeMap)
    T = promote_type(typeof(α), eltype(A))
    Alast = last(A.maps)
    if Alast isa UniformScalingMap
        return CompositeMap{T}(_combine(_front(A.maps), α * Alast))
    else
        return CompositeMap{T}(_combine(A.maps, UniformScalingMap(α, size(A, 1))))
    end
end
# needed for disambiguation
function Base.:(*)(α::RealOrComplex, A::CompositeMap{<:RealOrComplex})
    T = Base.promote_op(*, typeof(α), eltype(A))
    return ScaledMap{T}(α, A)
end
function Base.:(*)(A::LinearMap, α::Number)
    T = promote_type(typeof(α), eltype(A))
    return CompositeMap{T}(_combine(UniformScalingMap(α, size(A, 2)), A))
end
function Base.:(*)(A::CompositeMap, α::Number)
    T = promote_type(typeof(α), eltype(A))
    Afirst = first(A.maps)
    if Afirst isa UniformScalingMap
        return CompositeMap{T}(_combine(Afirst * α, _tail(A.maps)))
    else
        return CompositeMap{T}(_combine(UniformScalingMap(α, size(A, 2)), A.maps))
    end
end
# needed for disambiguation
function Base.:(*)(A::CompositeMap{<:RealOrComplex}, α::RealOrComplex)
    T = Base.promote_op(*, typeof(α), eltype(A))
    return ScaledMap{T}(α, A)
end

Base.:(\)(α::Number, A::LinearMap) = inv(α) * A
Base.:(/)(A::LinearMap, α::Number) = A * inv(α)

# composition of linear maps
"""
    *(A::LinearMap, B::LinearMap)::CompositeMap

Construct a (lazy) representation of the product of the two operators.
Products of `LinearMap`/`CompositeMap` objects and `LinearMap`/`CompositeMap`
objects are reduced to a single `CompositeMap`. In products of `LinearMap`s and
`AbstractMatrix`/`UniformScaling` objects, the latter get promoted to `LinearMap`s
automatically.

# Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> CS = LinearMap{Int}(cumsum, 3)::LinearMaps.FunctionMap;

julia> LinearMap(ones(Int, 3, 3)) * CS * I * rand(3, 3);
```
"""
function Base.:(*)(A₁::LinearMap, A₂::LinearMap)
    T = promote_type(eltype(A₁), eltype(A₂))
    return CompositeMap{T}(_combine(A₂, A₁))
end
function Base.:(*)(A₁::LinearMap, A₂::CompositeMap)
    T = promote_type(eltype(A₁), eltype(A₂))
    return CompositeMap{T}(_combine(A₂.maps, A₁))
end
function Base.:(*)(A₁::CompositeMap, A₂::LinearMap)
    T = promote_type(eltype(A₁), eltype(A₂))
    return CompositeMap{T}(_combine(A₂, A₁.maps))
end
function Base.:(*)(A₁::CompositeMap, A₂::CompositeMap)
    T = promote_type(eltype(A₁), eltype(A₂))
    return CompositeMap{T}(_combine(A₂.maps, A₁.maps))
end
# needed for disambiguation
Base.:(*)(A₁::ScaledMap, A₂::CompositeMap) = A₁.λ * (A₁.lmap * A₂)
Base.:(*)(A₁::CompositeMap, A₂::ScaledMap) = (A₁ * A₂.lmap) * A₂.λ

# special transposition behavior
LinearAlgebra.transpose(A::CompositeMap{T}) where {T} =
    CompositeMap{T}(map(transpose, _reverse!(A.maps)))
LinearAlgebra.adjoint(A::CompositeMap{T}) where {T} =
    CompositeMap{T}(map(adjoint, _reverse!(A.maps)))

# comparison of CompositeMap objects
Base.:(==)(A::CompositeMap, B::CompositeMap) =
    (eltype(A) == eltype(B) && all(A.maps .== B.maps))

# multiplication with vectors/matrices
function Base.:(*)(A::CompositeMap, x::AbstractVector)
    MulStyle(A) === TwoArg() ?
        foldr(*, _reverse!(A.maps), init=x) :
        invoke(*, Tuple{LinearMap, AbstractVector}, A, x)
end

function _unsafe_mul!(y, A::CompositeMap, x::AbstractVector)
    MulStyle(A) === TwoArg() ?
        copyto!(y, A*x) :
        _compositemul!(y, A, x)
    return y
end
_unsafe_mul!(y, A::CompositeMap, x::AbstractMatrix) = _compositemul!(y, A, x)
_unsafe_mul!(y, A::CompositeMap{<:Any,<:Tuple{LinearMap}}, x::AbstractVector) =
    _unsafe_mul!(y, A.maps[1], x)
_unsafe_mul!(y, A::CompositeMap{<:Any,<:Tuple{LinearMap}}, X::AbstractMatrix) =
    _unsafe_mul!(y, A.maps[1], X)

function _compositemul!(y, A::CompositeMap{<:Any,<:Tuple{LinearMap,LinearMap}}, x,
                        source = nothing,
                        dest = nothing)
    if isnothing(source)
        z = convert(AbstractArray, A.maps[1] * x)
        _unsafe_mul!(y, A.maps[2], z)
        return y
    else
        _unsafe_mul!(source, A.maps[1], x)
        _unsafe_mul!(y, A.maps[2], source)
        return y
    end
end
_compositemul!(y, A::CompositeMap{<:Any,<:LinearMapTuple}, x, s = nothing, d = nothing) =
    _compositemulN!(y, A, x, s, d)
function _compositemul!(y, A::CompositeMap{<:Any,<:LinearMapVector}, x,
                        source = nothing,
                        dest = nothing)
    N = length(A.maps)
    if N == 1
        return _unsafe_mul!(y, A.maps[begin], x)
    elseif N == 2
        return _unsafe_mul!(y, A.maps[end] * A.maps[begin], x)
    else
        return _compositemulN!(y, A, x, source, dest)
    end
end

function _compositemulN!(y, A::CompositeMap, x,
                         src = nothing,
                         dst = nothing)
    N = length(A.maps) # ≥ 3
    n = n0 = firstindex(A.maps)
    source = isnothing(src) ?
        convert(AbstractArray, A.maps[n] * x) :
        _unsafe_mul!(src, A.maps[n], x)
    n += 1
    dest = isnothing(dst) ?
        convert(AbstractArray, A.maps[n] * source) :
        _unsafe_mul!(dst, A.maps[n], source)
    dest, source = source, dest # alternate dest and source
    for n in (n0+2):N-1
        dest = _resize(dest, (size(A.maps[n], 1), size(x)[2:end]...))
        _unsafe_mul!(dest, A.maps[n], source)
        dest, source = source, dest # alternate dest and source
    end
    _unsafe_mul!(y, last(A.maps), source)
    return y
end

function _resize(dest::AbstractVector, sz::Tuple{<:Integer})
    try
        resize!(dest, sz[1])
    catch err
        dest = similar(dest, sz)
    end
    dest
end
function _resize(dest::AbstractMatrix, sz::Tuple{<:Integer,<:Integer})
    size(dest) == sz && return dest
    similar(dest, sz)
end

module LinearMapsSparseArraysExt

import SparseArrays: sparse, blockdiag, SparseMatrixCSC
using SparseArrays: AbstractSparseMatrix

using LinearAlgebra, LinearMaps
import LinearMaps: _issymmetric, _ishermitian
using LinearMaps: WrappedMap, CompositeMap, LinearCombination, ScaledMap, UniformScalingMap,
    AdjointMap, TransposeMap, BlockMap, BlockDiagonalMap, KroneckerMap, KroneckerSumMap,
    VecOrMatMap, AbstractVecOrMatOrQ, MapOrVecOrMat
using LinearMaps: convert_to_lmaps, _tail, _unsafe_mul!

_issymmetric(A::AbstractSparseMatrix) = issymmetric(A)
_ishermitian(A::AbstractSparseMatrix) = ishermitian(A)

# blockdiagonal concatenation via extension of blockdiag

"""
    blockdiag(As::Union{LinearMap,AbstractVecOrMatOrQ}...)::BlockDiagonalMap

Construct a (lazy) representation of the diagonal concatenation of the arguments.
To avoid fallback to the generic `blockdiag`, there must be a `LinearMap`
object among the first 8 arguments.
"""
blockdiag

for k in 1:8 # is 8 sufficient?
    Is = ntuple(n->:($(Symbol(:A, n))::AbstractVecOrMatOrQ), Val(k-1))
    # yields (:A1, :A2, :A3, ..., :A(k-1))
    L = :($(Symbol(:A, k))::LinearMap)
    # yields :Ak
    mapargs = ntuple(n ->:($(Symbol(:A, n))), Val(k-1))
    # yields (:LinearMap(A1), :LinearMap(A2), ..., :LinearMap(A(k-1)))

    @eval function blockdiag($(Is...), $L, As::MapOrVecOrMat...)
        return BlockDiagonalMap(convert_to_lmaps($(mapargs...))...,
                                $(Symbol(:A, k)),
                                convert_to_lmaps(As...)...)
    end
end

# conversion to sparse arrays
# sparse: create sparse matrix representation of LinearMap
function sparse(A::LinearMap{T}) where {T}
    M, N = size(A)
    rowind = Int[]
    nzval = T[]
    colptr = Vector{Int}(undef, N+1)
    v = fill(zero(T), N)
    Av = Vector{T}(undef, M)

    @inbounds for i in eachindex(v)
        v[i] = one(T)
        _unsafe_mul!(Av, A, v)
        js = findall(!iszero, Av)
        colptr[i] = length(nzval) + 1
        if length(js) > 0
            append!(rowind, js)
            append!(nzval, Av[js])
        end
        v[i] = zero(T)
    end
    colptr[N+1] = length(nzval) + 1

    return SparseMatrixCSC(M, N, colptr, rowind, nzval)
end
Base.convert(::Type{SparseMatrixCSC}, A::LinearMap) = sparse(A)
SparseMatrixCSC(A::LinearMap) = sparse(A)

sparse(A::ScaledMap{<:Any, <:Any, <:VecOrMatMap}) =
    A.λ * sparse(A.lmap.lmap)
sparse(A::WrappedMap) = sparse(A.lmap)
Base.convert(::Type{SparseMatrixCSC}, A::WrappedMap) = convert(SparseMatrixCSC, A.lmap)
for (T, t) in ((:AdjointMap, adjoint), (:TransposeMap, transpose))
    @eval sparse(A::$T) = $t(convert(SparseMatrixCSC, A.lmap))
end
function sparse(ΣA::LinearCombination{<:Any, <:Tuple{Vararg{VecOrMatMap}}})
    mats = map(A->getfield(A, :lmap), ΣA.maps)
    return sum(sparse, mats)
end
function sparse(AB::CompositeMap{<:Any, <:Tuple{VecOrMatMap, VecOrMatMap}})
    B, A = AB.maps
    return sparse(A.lmap)*sparse(B.lmap)
end
function sparse(λA::CompositeMap{<:Any, <:Tuple{VecOrMatMap, UniformScalingMap}})
    A, J = λA.maps
    return J.λ*sparse(A.lmap)
end
function sparse(Aλ::CompositeMap{<:Any, <:Tuple{UniformScalingMap, VecOrMatMap}})
    J, A = Aλ.maps
    return sparse(A.lmap)*J.λ
end
function sparse(A::BlockMap)
    return hvcat(
        A.rows,
        convert(SparseMatrixCSC, first(A.maps)),
        convert.(AbstractArray, _tail(A.maps))...
    )
end
function sparse(A::BlockDiagonalMap)
    return blockdiag(convert.(SparseMatrixCSC, A.maps)...)
end
Base.convert(::Type{AbstractMatrix}, A::BlockDiagonalMap) = sparse(A)
function sparse(A::KroneckerMap)
    return kron(
        convert(SparseMatrixCSC, first(A.maps)),
        convert.(AbstractMatrix, _tail(A.maps))...
    )
end
function sparse(L::KroneckerSumMap)
    A, B = L.maps
    IA = sparse(Diagonal(ones(Bool, size(A, 1))))
    IB = sparse(Diagonal(ones(Bool, size(B, 1))))
    return kron(convert(AbstractMatrix, A), IB) + kron(IA, convert(AbstractMatrix, B))
end

end # module LinearMapsSparseArraysExt

using Test, LinearMaps, LinearAlgebra

@testset "function maps" begin
    N = 100
    function myft(v::AbstractVector)
        # not so fast fourier transform
        N = length(v)
        w = zeros(complex(eltype(v)), N)
        for k = 1:N
            kappa = (2*(k-1)/N)*pi
            for n = 1:N
                w[k] += v[n]*exp(kappa*(n-1)*im)
            end
        end
        return w
    end
    MyFT = @inferred LinearMap{ComplexF64}(myft, N) / sqrt(N)
    U = Matrix(MyFT) # will be a unitary matrix
    @test @inferred U'U ≈ Matrix{eltype(U)}(I, N, N)
    @test occursin("$N×$N FunctionMap{$(eltype(MyFT)),false}", sprint((t, s) -> show(t, "text/plain", s), MyFT))

    CS = LinearMap(cumsum, 2)
    @test size(CS) == (2, 2)
    @test @inferred !issymmetric(CS)
    @test @inferred !ishermitian(CS)
    @test @inferred !isposdef(CS)
    @test (@test_deprecated (@inferred LinearMaps.ismutating(CS))) == false
    @test @inferred Matrix(CS) == [1. 0.; 1. 1.]
    @test @inferred Array(CS) == [1. 0.; 1. 1.]
    CS = @inferred (() -> LinearMap(cumsum, 10; ismutating=false))()
    v = rand(10)
    cv = cumsum(v)
    @test CS * v == cv
    @test *(CS, v) == cv
    @test_throws ErrorException CS' * v
    CS = LinearMap(cumsum, x -> reverse(cumsum(reverse(x))), 10; ismutating=false)
    @test occursin("10×10 FunctionMap{Float64,false}", sprint((t, s) -> show(t, "text/plain", s), CS))
    cv = cumsum(v)
    @test @inferred CS * v == cv
    @test @inferred *(CS, v) == cv
    @test @inferred CS' * v == reverse!(cumsum(reverse(v)))
    @test @inferred mul!(similar(v), transpose(CS), v) == reverse!(cumsum(reverse(v)))

    CS! = LinearMap(cumsum!, 10; ismutating=true)
    @test (@test_deprecated (@inferred LinearMaps.ismutating(CS!)))
    @test @inferred CS! * v == cv
    @test @inferred *(CS!, v) == cv
    @test @inferred mul!(similar(v), CS!, v) == cv
    @test_throws ErrorException CS!'v
    @test_throws ErrorException transpose(CS!) * v

    CS! = LinearMap{ComplexF64}(cumsum!, 10; ismutating=true)
    @test CS! == FunctionMap{ComplexF64, true}(cumsum!, 10, 10)
    v = rand(ComplexF64, 10)
    cv = cumsum(v)
    @test (@test_deprecated (@inferred LinearMaps.ismutating(CS!)))
    @test @inferred CS! * v == cv
    @test @inferred *(CS!, v) == cv
    @test @inferred mul!(similar(v), CS!, v) == cv
    @test_throws ErrorException CS!'v
    @test_throws ErrorException adjoint(CS!) * v
    @test_throws ErrorException mul!(similar(v), CS!', v)
    @test_throws ErrorException mul!(similar(v), transpose(CS!), v)
    CS! = LinearMap{ComplexF64}(cumsum!, (y, x) -> (copyto!(y, x); reverse!(y); cumsum!(y, y); reverse!(y)), 10; ismutating=true)
    M = Matrix(CS!)
    @inferred adjoint(CS!)
    @test (@test_deprecated (@inferred LinearMaps.ismutating(CS!)))
    @test @inferred CS! * v == cv
    @test @inferred *(CS!, v) == cv
    @test @inferred mul!(similar(v), CS!, v) == cv
    @test @inferred CS' * v == reverse!(cumsum(reverse(v)))
    @test @inferred mul!(similar(v), transpose(CS), v) == reverse!(cumsum(reverse(v)))
    @test @inferred mul!(similar(v), adjoint(CS), v) == reverse!(cumsum(reverse(v)))
    u = similar(v)
    CS!3 = 3*CS!
    mul!(u, CS!3, v)
    @test (@allocated mul!(u, CS!3, v)) == 0
    CS!3t = 3*CS!'
    mul!(u, CS!3t, v)
    @test (@allocated mul!(u, CS!3t, v)) == 0
    u = rand(ComplexF64, 10)
    v = rand(ComplexF64, 10)
    for α in (false, true, rand(ComplexF64)), β in (false, true, rand(ComplexF64))
        for transform in (identity, adjoint, transpose)
            @test mul!(copy(v), transform(CS!), u, α, β) ≈ transform(M)*u*α + v*β
            @test mul!(copy(v), transform(LinearMap(CS!)), u, α, β) ≈ transform(M)*u*α + v*β
            @test mul!(copy(v), LinearMap(transform(CS!)), u, α, β) ≈ transform(M)*u*α + v*β
            if transform != transpose
                transCS! = transform(CS!)
                alloc = @allocated similar(v)
                @test (@allocated mul!(v, transCS!, u, α, β)) <= alloc
            end
        end
    end

    # Test fallback methods:
    L = LinearMap(x -> x, x -> x, 10)
    v = randn(10)
    @test @inferred (2 * L)' * v ≈ 2 * v
    @test @inferred transpose(2 * L) * v ≈ 2 * v
    L = @inferred FunctionMap{ComplexF64,false}(x -> x, x -> x, 10)
    v = rand(ComplexF64, 10)
    w = similar(v)
    @test @inferred (2 * L)' * v ≈ 2 * v
    @test @inferred transpose(2 * L) * v ≈ 2 * v

    A = rand(ComplexF64, 10, 10)
    L = LinearMap{ComplexF64}(x -> A*x, 10)
    @test L * v == A * v == mul!(w, L, v)
    L = LinearMap{ComplexF64}((y, x) -> mul!(y, A, x), 10)
    @test L * v == A * v == mul!(w, L, v)
    L = LinearMap{ComplexF64}((y, x) -> mul!(y, A, x), (y, x) -> mul!(y, A', x), 10)
    @test L * v == A * v == mul!(w, L, v)
    @test adjoint(L) * v ≈ A'v ≈ mul!(w, L', v)
    @test transpose(L) * v ≈ transpose(A)*v ≈ mul!(w, transpose(L), v)

    A = Symmetric(rand(ComplexF64, 10, 10))
    L = LinearMap{ComplexF64}(x -> A*x, 10; issymmetric=true)
    @test L * v == A * v == mul!(w, L, v)
    @test adjoint(L) * v ≈ A'v ≈ mul!(w, L', v)
    @test transpose(L) * v ≈ transpose(A)*v ≈ mul!(w, transpose(L), v)
    L = LinearMap{ComplexF64}((y, x) -> mul!(y, A, x), 10; issymmetric=true)
    @test L * v == A * v == mul!(w, L, v)
    @test adjoint(L) * v ≈ A'v ≈ mul!(w, L', v)
    @test transpose(L) * v ≈ transpose(A)*v ≈ mul!(w, transpose(L), v)

    A = Hermitian(rand(ComplexF64, 10, 10))
    L = LinearMap{ComplexF64}(x -> A*x, 10; ishermitian=true)
    @test L * v == A * v == mul!(w, L, v)
    @test adjoint(L) * v ≈ A'v ≈ mul!(w, L', v)
    @test transpose(L) * v ≈ transpose(A)*v ≈ mul!(w, transpose(L), v)
    L = LinearMap{ComplexF64}((y, x) -> mul!(y, A, x), 10; ishermitian=true)
    @test L * v == A * v == mul!(w, L, v)
    @test adjoint(L) * v ≈ A'v ≈ mul!(w, L', v)
    @test transpose(L) * v ≈ transpose(A)*v ≈ mul!(w, transpose(L), v)
end

using Test, LinearMaps, LinearAlgebra

@testset "wrapped maps" begin
    A = rand(10, 20)
    B = rand(ComplexF64, 10, 20)
    SA = Hermitian(A'A + I)
    SB = Hermitian(B'B + I)
    L = @inferred LinearMap{Float64}(A)
    @test summary(L) == "10×20 LinearMaps.WrappedMap{Float64}"
    @test occursin("10×20 LinearMaps.WrappedMap{Float64}", sprint((t, s) -> show(t, "text/plain", s), L))
    MA = @inferred LinearMap(SA, isposdef=true)
    MB = @inferred LinearMap(SB, isposdef=true)
    @test eltype(Matrix{Complex{Float32}}(LinearMap(A))) <: Complex
    @test size(L) == size(A)
    @test @inferred !issymmetric(L)
    @test @inferred issymmetric(MA)
    @test @inferred !issymmetric(MB)
    @test @inferred isposdef(MA)
    @test @inferred isposdef(MB)

    A = 2 * rand(ComplexF64, (20, 10)) .- 1
    v = rand(ComplexF64, 10)
    w = rand(ComplexF64, 20)
    u = rand(ComplexF64, 20, 1)
    V = rand(ComplexF64, 10, 3)
    W = rand(ComplexF64, 20, 3)
    Av = A * v
    AV = A * V
    M = @inferred LinearMap(A)
    N = @inferred LinearMap(M)

    @test @inferred M' * w == A' * w
    @test @inferred mul!(copy(V), adjoint(M), W) ≈ A' * W
    @test @inferred transpose(M) * w == transpose(A) * w
    @test @inferred transpose(LinearMap(transpose(M))) * v == A * v
    @test @inferred LinearMap(M')' * v == A * v
    @test @inferred(transpose(transpose(M))) === M
    @test @inferred(adjoint(adjoint(M))) === M
    Mherm = @inferred LinearMap(Hermitian(A'A), isposdef=true)
    @test @inferred ishermitian(Mherm)
    @test @inferred !issymmetric(Mherm)
    @test @inferred !issymmetric(transpose(Mherm))
    @test @inferred ishermitian(transpose(Mherm))
    @test @inferred ishermitian(Mherm')
    @test @inferred isposdef(Mherm)
    @test @inferred isposdef(transpose(Mherm))
    @test @inferred isposdef(adjoint(Mherm))
    @test @inferred !(transpose(M) == adjoint(M))
    @test @inferred !(adjoint(M) == transpose(M))
    @test @inferred transpose(M') * v ≈ transpose(A') * v
    @test @inferred transpose(LinearMap(M')) * v ≈ transpose(A') * v
    @test @inferred LinearMap(transpose(M))' * v ≈ transpose(A)' * v
    @test @inferred transpose(LinearMap(transpose(M))) * v ≈ Av
    @test @inferred adjoint(LinearMap(adjoint(M))) * v ≈ Av

    for w in (vec(u), u)
        @test @inferred mul!(copy(w), transpose(LinearMap(M')), v) ≈ transpose(A') * v
        @test @inferred mul!(copy(w), LinearMap(transpose(M))', v) ≈ transpose(A)' * v
        @test @inferred mul!(copy(w), transpose(LinearMap(transpose(M))), v) ≈ Av
        @test @inferred mul!(copy(w), adjoint(LinearMap(adjoint(M))), v) ≈ Av
    end
    @test @inferred mul!(copy(W), transpose(LinearMap(M')), V) ≈ transpose(A') * V
    @test @inferred mul!(copy(W), LinearMap(transpose(M))', V) ≈ transpose(A)' * V
    @test @inferred mul!(copy(W), transpose(LinearMap(transpose(M))), V) ≈ AV
    @test @inferred mul!(copy(W), adjoint(LinearMap(adjoint(M))), V) ≈ AV
    @test @inferred mul!(copy(V), transpose(M), W) ≈ transpose(A) * W
    @test @inferred mul!(copy(V), adjoint(M), W) ≈ A' * W

    B = @inferred LinearMap(Symmetric(rand(10, 10)))
    @test transpose(B) == B
    @test B == transpose(B)

    B = @inferred LinearMap(Hermitian(rand(ComplexF64, 10, 10)))
    @test adjoint(B) == B
    @test B == B'

    N = 10
    Id = LinearMap(identity, N; issymmetric=true)
    A = rand(N, N)
    B = similar(A)
    @test mul!(copy(B), Id, A) == A
    @test mul!(B, A, Id) == B == A
    @test mul!(copy(B), A, LinearMap(Matrix(Id))) == A
    @test mul!(B, Id, A, true, true) ≈ 2A
    @test mul!(B, A, Id, true, true) == B == 3A
    @test mul!(copy(B), A, LinearMap(Matrix(Id)), true, true) == 4A

    # wrapped vectors viewed as column matrices
    u = ones(1); U = @inferred LinearMap(u)
    @test U isa LinearMap{Float64}
    @test issymmetric(U)
    @test ishermitian(U)
    @test isposdef(U)
    U = @inferred LinearMap(u.*im)
    @test U isa LinearMap{ComplexF64}
    @test issymmetric(U)
    @test !ishermitian(U)
    @test !isposdef(U)
    # symmetry
    O4 = ones(4)
    O3 = ones(3)
    Z3 = zeros(3)
    for M in (Bidiagonal(O4, O3, :U),
              Bidiagonal(O4, Z3, :L),
              Diagonal(O4),
              Diagonal(im*O4),
              SymTridiagonal(O4, O3),
              Tridiagonal(O3, O4, O3),
              Tridiagonal(O3, O4, Z3),
              sparse(Tridiagonal(O3, O4, O3)),
              sparse(Diagonal(im*O4)),
            )
        @test issymmetric(LinearMap(M)) == issymmetric(M)
        @test ishermitian(LinearMap(M)) == ishermitian(M)
    end

    # AbstractQ
    Q = qr(rand(10, 20)).Q
    Qmap = @inferred LinearMap(Q)
    @test size(Qmap) == (10, 10)
    @test LinearMaps.MulStyle(Qmap) === LinearMaps.ThreeArg()
    @test !issymmetric(Qmap)
    @test !ishermitian(Qmap)
    @test !isposdef(Qmap)
end

const Indexer = AbstractVector{<:Integer}

Base.IndexStyle(::LinearMap) = IndexCartesian()
# required in Base.to_indices for [:]-indexing (only size check)
Base.eachindex(::IndexLinear, A::LinearMap) = Base.OneTo(length(A))
# Base.lastindex(A::LinearMap) = last(eachindex(IndexLinear(), A))
# Base.firstindex(A::LinearMap) = first(eachindex(IndexLinear(), A))

function Base.checkbounds(A::LinearMap, i, j)
    Base.checkbounds_indices(Bool, axes(A), (i, j)) || throw(BoundsError(A, (i, j)))
    nothing
end
function Base.checkbounds(A::LinearMap, i)
    Base.checkindex(Bool, Base.OneTo(length(A)), i) || throw(BoundsError(A, i))
    nothing
end
# checkbounds in indexing via CartesianIndex
Base.checkbounds(A::LinearMap, i::Union{CartesianIndex{2}, AbstractArray{CartesianIndex{2}}}) =
    Base.checkbounds_indices(Bool, axes(A), (i,)) || throw(BoundsError(A, i))
Base.checkbounds(A::LinearMap, I::AbstractMatrix{Bool}) =
    axes(A) == axes(I) || throw(BoundsError(A, I))

# main entry point
function Base.getindex(A::LinearMap, I...)
    @boundscheck checkbounds(A, I...)
    _getindex(A, Base.to_indices(A, I)...)
end
# quick pass forward
Base.@propagate_inbounds Base.getindex(A::ScaledMap, I...) = A.λ * A.lmap[I...]
Base.@propagate_inbounds Base.getindex(A::WrappedMap, I...) = A.lmap[I...]

########################
# linear indexing
########################
_getindex(A::LinearMap, _) = error("linear indexing of LinearMaps is not supported")

########################
# Cartesian indexing (partial slicing is not supported)
########################
_getindex(A::LinearMap, i::Integer, j::Integer) =
    error("scalar indexing of LinearMaps is not supported, consider using A[:,j][i] instead")
_getindex(A::LinearMap, I::Indexer, j::Integer) =
    error("partial vertical slicing of LinearMaps is not supported, consider using A[:,j][I] instead")
_getindex(A::LinearMap, i::Integer, J::Indexer) =
    error("partial horizontal slicing of LinearMaps is not supported, consider using A[i,:][J] instead")
_getindex(A::LinearMap, I::Indexer, J::Indexer) =
    error("partial two-dimensional slicing of LinearMaps is not supported, consider using A[:,J][I] or A[I,:][J] instead")

_getindex(A::LinearMap, ::Base.Slice, j::Integer) = A*unitvec(A, 2, j)
function _getindex(A::LinearMap, i::Integer, ::Base.Slice)
    try
        # requires adjoint action to be defined
        return vec(unitvec(A, 1, i)'A)
    catch
        error("horizontal slicing A[$i,:] requires the adjoint of $(typeof(A)) to be defined")
    end
end
_getindex(A::LinearMap, ::Base.Slice, ::Base.Slice) = convert(AbstractMatrix, A)
_getindex(A::LinearMap, I::Base.Slice, J::Indexer) = __getindex(A, I, J)
_getindex(A::LinearMap, I::Indexer, J::Base.Slice) = __getindex(A, I, J)
function __getindex(A, I, J)
    dest = zeros(eltype(A), Base.index_shape(I, J))
    # choose whichever requires less map applications
    if length(I) <= length(J)
        try
            # requires adjoint action to be defined
            _fillbyrows!(dest, A, I, J)
        catch
            error("wide slicing A[I,J] with length(I) <= length(J) requires the adjoint of $(typeof(A)) to be defined")
        end
    else
        _fillbycols!(dest, A, I, J)
    end
    return dest
end

# helpers
function unitvec(A, dim, i)
    x = zeros(eltype(A), size(A, dim))
    @inbounds x[i] = one(eltype(A))
    return x
end

function _fillbyrows!(dest, A, I, J)
    x = zeros(eltype(A), size(A, 1))
    temp = similar(x, eltype(A), size(A, 2))
    @views @inbounds for (di, i) in zip(eachrow(dest), I)
        x[i] = one(eltype(A))
        _unsafe_mul!(temp, A', x)
        di .= adjoint.(temp[J])
        x[i] = zero(eltype(A))
    end
    return dest
end
function _fillbycols!(dest, A, I::Indexer, J)
    x = zeros(eltype(A), size(A, 2))
    temp = similar(x, eltype(A), size(A, 1))
    @inbounds for (ind, j) in enumerate(J)
        x[j] = one(eltype(A))
        _unsafe_mul!(temp, A, x)
        dest[:,ind] .= temp[I]
        x[j] = zero(eltype(A))
    end
    return dest
end
function _fillbycols!(dest, A, ::Base.Slice, J)
    x = zeros(eltype(A), size(A, 2))
    @inbounds for (ind, j) in enumerate(J)
        x[j] = one(eltype(A))
        _unsafe_mul!(selectdim(dest, 2, ind), A, x)
        x[j] = zero(eltype(A))
    end
    return dest
end

using Test, LinearMaps, LinearAlgebra
using Quaternions: Quaternion, quat
using Octonions: Octonion

@testset "noncommutative number type" begin
    x = randn(Quaternion{Float64},10)
    v = rand(10)
    A = randn(Quaternion{Float64}, 10, 10)
    B = randn(Quaternion{Float64}, 10, 10)
    C = similar(A)
    γ = randn(Quaternion{Float64}) # "Number"
    α = UniformScaling(γ)
    β = UniformScaling(randn(Quaternion{Float64}))
    λ = randn(Quaternion{Float64})
    L = LinearMap(A)
    F = LinearMap{eltype(A)}(x -> A*x, y -> A'y, 10)
    @test Array(F) == A
    @test Array(F') == A'
    @test Array(transpose(F)) == transpose(A)
    @test Array(α * F) == α * A
    @test Array(F * α) == A * α
    @test Array(α * F) == α * A
    @test Array(F * α ) == A * α
    @test Array(α * F') == α * A'
    for M in (L, F)
        @test mul!(C, transpose(A), M) ≈ transpose(A)*A
        @test mul!(C, A', M) ≈ A'A
        @test mul!(C, A, M) ≈ A*A
        @test mul!(copy(C), M, A, γ, λ) ≈ A*A*γ + C*λ
        @test mul!(copy(C), A, M, γ, λ) ≈ A*A*γ + C*λ
        @test mul!(copy(C), A, M, γ, 0) ≈ A*A*γ
        @test mul!(copy(C), transpose(A), M, γ, λ) ≈ transpose(A)*A*γ + C*λ
        @test mul!(copy(C), adjoint(A), M, γ, λ) ≈ A'*A*γ + C*λ
    end
    @test Array((α * F')') ≈ (γ * A')' ≈ A * conj(γ)
    @test L * x ≈ A * x
    @test L' * x ≈ A' * x
    @test α * (L * x) ≈ γ * (A * x)
    @test α * L * x ≈ γ * A * x
    @test L * α * x ≈ A * γ * x
    @test 3L * x ≈ 3A * x
    @test 3L' * x ≈ 3A' * x
    @test λ*L isa LinearMaps.CompositeMap
    @test γ * (λ * LinearMap(B)) isa LinearMaps.CompositeMap
    @test (λ * LinearMap(B)) * γ isa LinearMaps.CompositeMap
    @test ((L*L)*λ) isa LinearMaps.CompositeMap
    @test (λ*(L*L)) isa LinearMaps.CompositeMap
    @test λ*L * x ≈ λ*A * x
    @test λ*L' * x ≈ λ*A' * x
    @test α * (3L * x) ≈ γ * (3A * x)
    @test (@inferred α * 3L) * x ≈ γ * 3A * x
    @test (@inferred 3L * α) * x ≈ 3A * γ * x
    @test (α * L') * x ≈ (γ * A') * x
    @test (α * L')' * x ≈ (γ * A')' * x
    @test (α * L')' * v ≈ (γ * A')' * v
    @test Array(@inferred adjoint(α * L * β)) ≈ conj(β) * A' * conj(γ)
    @test Array(@inferred transpose(α * L * β)) ≈ β * transpose(A) * γ
    J = LinearMap(α, 10)
    @test (β * J) * x ≈ LinearMap(β*α, 10) * x ≈ β*γ*x
    @test (J * β) * x ≈ LinearMap(α*β, 10) * x ≈ γ*β*x
    M = β.λ * (γ * L * L)
    @test M == β * (γ * L * L)
    @test length(M.maps) == 3
    @test M.maps[end].λ == β.λ * γ
    @test γ * (β * L * L) == γ * (β.λ * L * L) == α * (β.λ * L * L) == α * (β * L * L)
    @test length(M.maps) == 3
    @test M.maps[end].λ == β.λ * γ
    M = (L * L * γ) * β.λ
    @test M == (L * L * γ) * β == (L * L * α) * β == (L * L * α) * β.λ
    @test length(M.maps) == 3
    @test M.maps[1].λ == γ*β.λ
    @test γ*FillMap(γ, (3, 4)) == FillMap(γ^2, (3, 4)) == FillMap(γ, (3, 4))*γ
    U = LinearMap(quat(1.0)*I, 10)
    for β in (0, 1, rand())
        @test mul!(copy(x), J, x, γ, β) == γ * x * γ + x * β
        @test mul!(copy(x), U, x, γ, β) == x * γ + x * β
    end
    # exercise non-RealOrComplex scalar operations
    @test Array(γ * (L'*L)) ≈ γ * (A'*A) # CompositeMap
    @test Array((L'*L) * γ) ≈ (A'*A) * γ
    @test Array(-L) == -A
    @test Array(γ \ L) ≈ γ \ A
    @test Array(L / γ) ≈ A / γ
    M = randn(10, 10); α = randn();
    y = α^2 * M * x; Y = α * M * A
    @test (α^2 * LinearMap(M)) * x ≈ quat(α)*(α * LinearMap(M)) * x ≈ y
    @test ((α * LinearMap(M))*quat(α)) * x ≈ y
    @test mul!(copy(y), α * LinearMap(M), x) ≈ α * M * x
    @test mul!(copy(y), α * LinearMap(M), x, α, false) ≈ α * M * x * α
    @test mul!(copy(y), α * LinearMap(M), x, quat(α), false) ≈ α * M * x * α
    @test mul!(copy(Y), α * LinearMap(M), A) ≈ α * M * A
    @test mul!(copy(Y), α * LinearMap(M), A, α, false) ≈ α * M * A * α
end

@testset "nonassociative number type" begin
    x = randn(Octonion{Float64}, 10)
    v = rand(10)
    A = randn(Octonion{Float64}, 10, 10)
    α = randn(Octonion{Float64})*I
    β = randn(Octonion{Float64})*I
    L = LinearMap(A)
    @test Array(L) == A
    @test Array(α * L) == α * A
    @test Array(L * α) == A * α
    @test Array(α * L) == α * A
    @test Array(L * α) == A * α
    @test (α * L')' * v ≈ (α * A')' * v
end

struct LinearCombination{T, As<:LinearMapTupleOrVector} <: LinearMap{T}
    maps::As
    function LinearCombination{T, As}(maps::As) where {T, As<:LinearMapTupleOrVector}
        N = length(maps)
        ax = axes(maps[1])
        for n in eachindex(maps)
            A = maps[n]
            axes(A) == ax || throw(DimensionMismatch("LinearCombination"))
            @assert promote_type(T, eltype(A)) == T  "eltype $(eltype(A)) cannot be promoted to $T in LinearCombination constructor"
        end
        new{T, As}(maps)
    end
end

LinearCombination{T}(maps::As) where {T, As} = LinearCombination{T, As}(maps)

# this method avoids the afoldl-mechanism even for LinearMapTuple
Base.mapreduce(::typeof(identity), ::typeof(Base.add_sum), maps::LinearMapTupleOrVector) =
    LinearCombination{promote_type(map(eltype, maps)...)}(maps)
# this method is required for type stability in the mixed-map-equal-eltype case
Base.mapreduce(::typeof(identity), ::typeof(Base.add_sum), maps::AbstractVector{<:LinearMap{T}}) where {T} =
    LinearCombination{T}(maps)

MulStyle(A::LinearCombination) = MulStyle(A.maps...)

# basic methods
Base.size(A::LinearCombination) = size(A.maps[1])
Base.axes(A::LinearCombination) = axes(A.maps[1])
# following conditions are sufficient but not necessary
LinearAlgebra.issymmetric(A::LinearCombination) = all(issymmetric, A.maps)
LinearAlgebra.ishermitian(A::LinearCombination) = all(ishermitian, A.maps)
LinearAlgebra.isposdef(A::LinearCombination) = all(isposdef, A.maps)

# adding linear maps
"""
    +(A::LinearMap, B::LinearMap)::LinearCombination

Construct a (lazy) representation of the sum/linear combination of the two operators.
Sums of `LinearMap`/`LinearCombination` objects and
`LinearMap`/`LinearCombination` objects are reduced to a single `LinearCombination`.
In sums of `LinearMap`s and `AbstractMatrix`/`UniformScaling` objects, the latter
get promoted to `LinearMap`s automatically.

# Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> CS = LinearMap{Int}(cumsum, 3)::LinearMaps.FunctionMap;

julia> LinearMap(ones(Int, 3, 3)) + CS + I + rand(3, 3);
```
"""
function Base.:(+)(A₁::LinearMap, A₂::LinearMap)
    size(A₁) == size(A₂) || throw(DimensionMismatch("+"))
    T = promote_type(eltype(A₁), eltype(A₂))
    return LinearCombination{T}(_combine(A₁, A₂))
end
function Base.:(+)(A₁::LinearMap, A₂::LinearCombination)
    size(A₁) == size(A₂) || throw(DimensionMismatch("+"))
    T = promote_type(eltype(A₁), eltype(A₂))
    return LinearCombination{T}(_combine(A₁, A₂.maps))
end
Base.:(+)(A₁::LinearCombination, A₂::LinearMap) = +(A₂, A₁)
function Base.:(+)(A₁::LinearCombination, A₂::LinearCombination)
    size(A₁) == size(A₂) || throw(DimensionMismatch("+"))
    T = promote_type(eltype(A₁), eltype(A₂))
    return LinearCombination{T}(_combine(A₁.maps, A₂.maps))
end
Base.:(-)(A₁::LinearMap, A₂::LinearMap) = +(A₁, -A₂)

# comparison of LinearCombination objects, sufficient but not necessary
Base.:(==)(A::LinearCombination, B::LinearCombination) =
    (eltype(A) == eltype(B) && all(A.maps .== B.maps))

# special transposition behavior
LinearAlgebra.transpose(A::LinearCombination) =
    LinearCombination{eltype(A)}(map(transpose, A.maps))
LinearAlgebra.adjoint(A::LinearCombination) =
    LinearCombination{eltype(A)}(map(adjoint, A.maps))

# multiplication with vectors & matrices
function Base.:(*)(A::LinearCombination, x::AbstractVector)
    midmaps = _tail(_front(A.maps))
    if !isempty(midmaps) && MulStyle(midmaps...) === TwoArg()
        mapreduce(L -> L * x, Base.add_sum, A.maps)
    else
        invoke(*, Tuple{LinearMap, AbstractVector}, A, x)
    end
end
function Base.:(*)(A::LinearCombination{T,<:Union{Tuple{Vararg{LinearMap{T}}},AbstractVector{<:LinearMap{T}}}},
                    x::AbstractVector) where {T}
    midmaps = _tail(_front(A.maps))
    if (!isempty(midmaps) && MulStyle(midmaps...) === TwoArg()) || MulStyle(A) === TwoArg()
        mapreduce(L -> L * x, (x, y) -> x .+= y, A.maps)
    else
        invoke(*, Tuple{LinearMap, AbstractVector}, A, x)
    end
end

for In in (AbstractVector, AbstractMatrix)
    @eval function _unsafe_mul!(y, A::LinearCombination, x::$In)
        _unsafe_mul!(y, first(A.maps), x)
        _mul!(MulStyle(_tail(A.maps)...), y, A, x, true)
        return y
    end
    @eval function _unsafe_mul!(y, A::LinearCombination, x::$In, α, β)
        if iszero(α) # trivial cases
            iszero(β) && return fill!(y, zero(eltype(y)))
            isone(β) && return y
            return rmul!(y, β)
        else
            A1 = first(A.maps)
            if MulStyle(A1) !== ThreeArg() || iszero(β)
                # this is allocation-free for MulStyle(A1) === FiveArg(), but allocates
                # A1 * x for MulStyle(A1) === TwoArg()
                # but I'm afraid to reuse it since it may have too small of an eltype
                _unsafe_mul!(y, A1, x, α, β)
                # let _mul! decide whether an intermediate vector needs to be allocated
                _mul!(MulStyle(A), y, A, x, α)
            else # MulStyle(A1) === ThreeArg() && !iszero(β)
                # since we need an intermediate vector, allocate here and potentially reuse
                !isone(β) && rmul!(y, β)
                z = similar(y)
                muladd!(ThreeArg(), y, A1, x, α, z)
                __mul!(y, _tail(A.maps), x, α, z)
            end
            return y
        end
    end
end

function _unsafe_mul!(M, L::LinearCombination, s::Number)
    _unsafe_mul!(M, first(L.maps), s)
    _mul!(MulStyle(L), M, L, s, true)
    return M
end

function _unsafe_mul!(M, L::LinearCombination, s::Number, α, β)
    LinearAlgebra._rmul_or_fill!(M, β)
    for map in L.maps
        _unsafe_mul!(M, map, s, α, true)
    end
    return M
end

_mul!(::FiveArg, y, A::LinearCombination, x, α) = __mul!(y, _tail(A.maps), x, α, nothing)
_mul!(::ThreeArg, y, A::LinearCombination, x, α) = __mul!(y, _tail(A.maps), x, α, similar(y))
_mul!(::TwoArg, y, A::LinearCombination, x, α) = __mul!(y, _tail(A.maps), x, α, nothing)

# For tuple-like storage of the maps (default), we recurse on the tail of the tuple.
__mul!(y, As::LinearMapTuple, x, α, z) =
    __mul!(__mul!(y, first(As), x, α, z), Base.tail(As), x, α, z)
__mul!(y, A::Tuple{LinearMap}, x, α, z) = __mul!(y, first(A), x, α, z)
__mul!(y, A::LinearMap, x, α, z) = muladd!(MulStyle(A), y, A, x, α, z)
# For vector-like storage of the maps, we simply loop over the maps.
function __mul!(y, As::LinearMapVector, x, α, z)
    @inbounds for i in eachindex(As)
        Ai = As[i]
        muladd!(MulStyle(Ai), y, Ai, x, α, z)
    end
    y
end

@inline muladd!(::FiveArg, y, A, x, α, _) = _unsafe_mul!(y, A, x, α, true)
@inline function muladd!(::ThreeArg, y, A, x, α, z)
    _unsafe_mul!(z, A, x)
    isone(α) ? (y .+= z) : axpy!(α, z, y)
    return y
end
@inline function muladd!(::TwoArg, y, A, x, α, _)
    z = convert(AbstractArray, A * x)
    isone(α) ? (y .+= z) : axpy!(α, z, y)
    return y
end

struct InverseMap{T, F, S} <: LinearMap{T}
    A::F
    ldiv!::S
end

"""
    InverseMap(A; solver = ldiv!)

Lazy inverse of `A` such that `InverseMap(A) * x` is the same as `A \\ x`. Letting an
`InverseMap` act on a vector thus requires solving a linear system.

A solver function can be passed with the `solver` keyword argument. The solver should
be of the form `f(y, A, x)` where `A` is the wrapped map, `x` the right hand side, and
`y` a preallocated output vector in which the result should be stored. The default solver
is `LinearAlgebra.ldiv!`.

Note that `A` must be compatible with the solver function. `A` can, for example, be a
factorization of a matrix, or another `LinearMap` (in combination with an iterative solver
such as conjugate gradient).

# Examples
```julia
julia> using LinearMaps, LinearAlgebra

julia> A = rand(2, 2); b = rand(2);

julia> InverseMap(lu(A)) * b
2-element Vector{Float64}:
  1.0531895201271027
 -0.4718540250893251

julia> A \\ b
2-element Vector{Float64}:
  1.0531895201271027
 -0.4718540250893251
```
"""
function InverseMap(A::F; solver::S=LinearAlgebra.ldiv!) where {F, S}
    T = eltype(A)
    InverseMap{T,F,S}(A, solver)
end

Base.size(imap::InverseMap) = size(imap.A)
Base.transpose(imap::InverseMap) = InverseMap(transpose(imap.A); solver=imap.ldiv!)
Base.adjoint(imap::InverseMap) = InverseMap(adjoint(imap.A); solver=imap.ldiv!)

LinearAlgebra.issymmetric(imap::InverseMap) = issymmetric(imap.A)
LinearAlgebra.ishermitian(imap::InverseMap) = ishermitian(imap.A)
LinearAlgebra.isposdef(imap::InverseMap) = isposdef(imap.A)

# Two separate methods to deal with method ambiguities
function _unsafe_mul!(y, imap::InverseMap, x::AbstractVector)
    imap.ldiv!(y, imap.A, x)
    return y
end
function _unsafe_mul!(y, imap::InverseMap, x::AbstractMatrix)
    imap.ldiv!(y, imap.A, x)
    return y
end

struct WrappedMap{T, A<:MapOrVecOrMat} <: LinearMap{T}
    lmap::A
    _issymmetric::Bool
    _ishermitian::Bool
    _isposdef::Bool
end
function WrappedMap{T}(lmap::MapOrMatrix;
                        issymmetric::Bool = _issymmetric(lmap),
                        ishermitian::Bool = _ishermitian(lmap),
                        isposdef::Bool = _isposdef(lmap)) where {T}
    WrappedMap{T, typeof(lmap)}(lmap, issymmetric, ishermitian, isposdef)
end
function WrappedMap{T}(lmap::AbstractVector;
                        issym::Bool = false,
                        isherm::Bool = false,
                        ispd::Bool = false) where {T}
    WrappedMap{T, typeof(lmap)}(lmap,
                                length(lmap) == 1 && issymmetric(first(lmap)),
                                length(lmap) == 1 && ishermitian(first(lmap)),
                                length(lmap) == 1 && isposdef(first(lmap)))
end
WrappedMap(lmap::MapOrVecOrMat{T}; kwargs...) where {T} = WrappedMap{T}(lmap; kwargs...)

# cheap property checks (usually by type)
_issymmetric(A::AbstractMatrix) = false
_issymmetric(A::AbstractQ) = false
_issymmetric(A::LinearMap) = issymmetric(A)
_issymmetric(A::LinearAlgebra.RealHermSymComplexSym) = issymmetric(A)
_issymmetric(A::Union{Bidiagonal,Diagonal,SymTridiagonal,Tridiagonal}) = issymmetric(A)

_ishermitian(A::AbstractMatrix) = false
_ishermitian(A::AbstractQ) = false
_ishermitian(A::LinearMap) = ishermitian(A)
_ishermitian(A::LinearAlgebra.RealHermSymComplexHerm) = ishermitian(A)
_ishermitian(A::Union{Bidiagonal,Diagonal,SymTridiagonal,Tridiagonal}) = ishermitian(A)

_isposdef(A::AbstractMatrix) = false
_isposdef(A::AbstractQ) = false
_isposdef(A::LinearMap) = isposdef(A)

const VecOrMatMap{T} = WrappedMap{T,<:AbstractVecOrMatOrQ}

MulStyle(A::VecOrMatMap) = MulStyle(A.lmap)

LinearAlgebra.transpose(A::VecOrMatMap{T}) where {T} =
    WrappedMap{T}(transpose(A.lmap);
                    issymmetric = A._issymmetric,
                    ishermitian = A._ishermitian,
                    isposdef = A._isposdef)
LinearAlgebra.adjoint(A::VecOrMatMap{T}) where {T} =
    WrappedMap{T}(adjoint(A.lmap);
                    issymmetric = A._issymmetric,
                    ishermitian = A._ishermitian,
                    isposdef = A._isposdef)

Base.:(==)(A::VecOrMatMap, B::VecOrMatMap) =
    (eltype(A) == eltype(B) && A.lmap == B.lmap && A._issymmetric == B._issymmetric &&
     A._ishermitian == B._ishermitian && A._isposdef == B._isposdef)

# properties
Base.size(A::WrappedMap) = size(A.lmap)
Base.size(A::WrappedMap{<:Any,<:AbstractVector}) = (Int(length(A.lmap))::Int, 1)
Base.axes(A::WrappedMap) = axes(A.lmap)
LinearAlgebra.issymmetric(A::WrappedMap) = A._issymmetric
LinearAlgebra.ishermitian(A::WrappedMap) = A._ishermitian
LinearAlgebra.isposdef(A::WrappedMap) = A._isposdef

# multiplication with vectors & matrices
for In in (AbstractVector, AbstractMatrix)
    @eval begin
        _unsafe_mul!(y, A::WrappedMap, x::$In) = _unsafe_mul!(y, A.lmap, x)
        function _unsafe_mul!(y, At::TransposeMap{<:Any,<:WrappedMap}, x::$In)
            A = At.lmap
            return (issymmetric(A) || (isreal(A) && ishermitian(A))) ?
                _unsafe_mul!(y, A.lmap, x) :
                _unsafe_mul!(y, transpose(A.lmap), x)
        end
        function _unsafe_mul!(y, Ac::AdjointMap{<:Any,<:WrappedMap}, x::$In)
            A = Ac.lmap
            return ishermitian(A) ?
                _unsafe_mul!(y, A.lmap, x) :
                _unsafe_mul!(y, adjoint(A.lmap), x)
        end
    end
end

for In in (AbstractVector, AbstractMatrix)
    @eval begin
        function _unsafe_mul!(y, A::WrappedMap, x::$In, α, β)
            return _unsafe_mul!(y, A.lmap, x, α, β)
        end
        function _unsafe_mul!(y, At::TransposeMap{<:Any,<:WrappedMap}, x::$In, α, β)
            A = At.lmap
            return (issymmetric(A) || (isreal(A) && ishermitian(A))) ?
                _unsafe_mul!(y, A.lmap, x, α, β) :
                _unsafe_mul!(y, transpose(A.lmap), x, α, β)
        end
        function _unsafe_mul!(y, Ac::AdjointMap{<:Any,<:WrappedMap}, x::$In, α, β)
            A = Ac.lmap
            return ishermitian(A) ?
                _unsafe_mul!(y, A.lmap, x, α, β) :
                _unsafe_mul!(y, adjoint(A.lmap), x, α, β)
        end
    end
end

_unsafe_mul!(Y, A::VecOrMatMap, s::Number) = _unsafe_mul!(Y, A.lmap, s)
_unsafe_mul!(Y, A::VecOrMatMap, s::Number, α, β) = _unsafe_mul!(Y, A.lmap, s, α, β)

# combine LinearMap and Matrix objects: linear combinations and map composition
Base.:(+)(A₁::LinearMap, A₂::Union{AbstractMatrix,AbstractQ}) = +(A₁, WrappedMap(A₂))
Base.:(+)(A₁::Union{AbstractMatrix,AbstractQ}, A₂::LinearMap) = +(WrappedMap(A₁), A₂)
Base.:(-)(A₁::LinearMap, A₂::Union{AbstractMatrix,AbstractQ}) = -(A₁, WrappedMap(A₂))
Base.:(-)(A₁::Union{AbstractMatrix,AbstractQ}, A₂::LinearMap) = -(WrappedMap(A₁), A₂)

"""
    *(A::LinearMap, X::Union{AbstractMatrix,AbstractQ})::CompositeMap

Return the `CompositeMap` `A*LinearMap(X)`, interpreting the matrix `X` as a linear
operator, rather than a collection of column vectors. To compute the action of `A` on each
column of `X`, call `Matrix(A*X)` or use the in-place multiplication `mul!(Y, A, X[, α, β])`
with an appropriately sized, preallocated matrix `Y`.

## Examples
```jldoctest; setup=(using LinearMaps)
julia> A=LinearMap([1.0 2.0; 3.0 4.0]); X=[1.0 1.0; 1.0 1.0];

julia> A*X isa LinearMaps.CompositeMap
true
```
"""
Base.:(*)(A₁::LinearMap, A₂::Union{AbstractMatrix,AbstractQ}) = *(A₁, WrappedMap(A₂))

"""
    *(X::Union{AbstractMatrix,AbstractQ}, A::LinearMap)::CompositeMap

Return the `CompositeMap` `LinearMap(X)*A`, interpreting the matrix `X` as a linear
operator. To compute the right-action of `A` on each row of `X`, call `Matrix(X*A)`
or `mul!(Y, X, A)` for the in-place version.

## Examples
```jldoctest; setup=(using LinearMaps)
julia> X=[1.0 1.0; 1.0 1.0]; A=LinearMap([1.0 2.0; 3.0 4.0]);

julia> X*A isa LinearMaps.CompositeMap
true
```
"""
Base.:(*)(A₁::Union{AbstractMatrix,AbstractQ}, A₂::LinearMap) = *(WrappedMap(A₁), A₂)

using Test, LinearMaps, LinearAlgebra, SparseArrays, InteractiveUtils
using LinearMaps: FiveArg

@testset "block maps" begin
    @testset "hcat" begin
        m = 3
        n = 4
        for elty in (Float32, ComplexF64), n2 in (0, 2)
            A11 = rand(elty, m, n)
            A12 = rand(elty, m, n2)
            a = rand(elty, m)
            L = @inferred hcat(LinearMap(A11), LinearMap(A12))
            @test L.maps isa Tuple
            Lv = @inferred LinearMaps.BlockMap{elty}([LinearMap(A11), LinearMap(A12)], (2,))
            @test Lv.maps isa Vector
            @test L == Lv == LinearMaps.BlockMap([LinearMap(A11), LinearMap(A12)], (2,))
            @test occursin("$m×$(n+n2) LinearMaps.BlockMap{$elty}", sprint((t, s) -> show(t, "text/plain", s), L))
            @test @inferred(LinearMaps.MulStyle(L)) === FiveArg()
            @test L isa LinearMaps.BlockMap{elty}
            if elty <: Complex
                @test_throws ErrorException LinearMaps.BlockMap{Float64}((LinearMap(A11), LinearMap(A12)), (2,))
            end
            A = [A11 A12]
            x = rand(n+n2)
            @test size(L) == size(A) == size(Lv)
            @test Matrix(L) == A == Matrix(Lv) == mul!(copy(A), L, 1, true, false)
            @test L * x ≈ A * x ≈ Lv * x
            L = @inferred hcat(LinearMap(A11), LinearMap(A12), LinearMap(A11))
            A = [A11 A12 A11]
            @test Matrix(L) == A == mul!(zero(A), L, 1, true, false)
            A = [I I I A11 A11 A11 a]
            @test (@which [A11 A11 A11]).module != LinearMaps
            @test (@which [I I I A11 A11 A11]).module != LinearMaps
            @test (@which hcat(I, I, I)).module != LinearMaps
            @test (@which hcat(I, I, I, LinearMap(A11), A11, A11)).module == LinearMaps
            maps = @inferred LinearMaps.promote_to_lmaps(ntuple(i->m, 7), 1, 1, I, I, I, LinearMap(A11), A11, A11, a)
            @inferred LinearMaps.rowcolranges(maps, (7,))
            L = @inferred hcat(I, I, I, LinearMap(A11), A11, A11, a)
            @test L == [I I I LinearMap(A11) LinearMap(A11) LinearMap(A11) LinearMap(a)]
            x = ones(elty, size(L, 2))
            @test L isa LinearMaps.BlockMap{elty}
            @test L * x ≈ A * x
            L = @inferred hcat(I, I, I, LinearMap(A11), A11, A11, a, a, a, a)
            @test occursin("$m×$(3m+3n+4) LinearMaps.BlockMap{$elty}", sprint((t, s) -> show(t, "text/plain", s), L))
            L = @inferred hcat(I, I, I, LinearMap(A11), A11, A11, a, a, a, a, a, a, a)
            @test occursin("$m×$(3m+3n+7) LinearMaps.BlockMap{$elty}", sprint((t, s) -> show(t, "text/plain", s), L))
        end
        A11 = zeros(m+1, n)
        A12 = zeros(m, n)
        @test_throws DimensionMismatch hcat(LinearMap(A11), LinearMap(A12))
    end

    @testset "vcat" begin
        m = 2
        n = 3
        for elty in (Float32, ComplexF64)
            A11 = rand(elty, m, n)
            v = rand(elty, n)
            L = @inferred vcat(LinearMap(A11))
            @test L == [LinearMap(A11);]
            @test Matrix(L) ≈ A11
            A21 = rand(elty, 2m, n)
            L = @inferred vcat(LinearMap(A11), LinearMap(A21))
            @test L.maps isa Tuple
            @test L isa LinearMaps.BlockMap{elty}
            @test occursin("$(3m)×$n LinearMaps.BlockMap{$elty}", sprint((t, s) -> show(t, "text/plain", s), L))
            @test @inferred(LinearMaps.MulStyle(L)) === FiveArg()
            Lv = LinearMaps.BlockMap{elty}([LinearMap(A11), LinearMap(A21)], (1,1))
            @test Lv.maps isa Vector
            @test L == Lv
            @test (@which [A11; A21]).module != LinearMaps
            A = [A11; A21]
            x = rand(elty, n)
            @test size(L) == size(A)
            @test Matrix(L) == A == mul!(copy(A), L, 1, true, false)
            @test Matrix(Lv) == A == mul!(copy(A), Lv, 1, true, false)
            @test L * x ≈ Lv * x ≈ A * x
            A = [I; I; I; A11; A11; A11; reduce(hcat, fill(v, n))]
            @test (@which [I; I; I; A11; A11; A11; v v v v v v v v v v]).module != LinearMaps
            L = @inferred vcat(I, I, I, LinearMap(A11), LinearMap(A11), LinearMap(A11), reduce(hcat, fill(v, n)))
            @test L == [I; I; I; LinearMap(A11); LinearMap(A11); LinearMap(A11); reduce(hcat, fill(v, n))]
            @test L isa LinearMaps.BlockMap{elty}
            @test L * x ≈ A * x
        end
        A11 = zeros(m, n+1)
        A21 = zeros(2m, n)
        @test_throws DimensionMismatch vcat(LinearMap(A11), LinearMap(A21))
    end

    @testset "hvcat" begin
        m1 = 2
        m2 = 3
        n = 3
        for elty in (Float32, ComplexF64)
            A11 = rand(elty, m1, m1)
            A12 = ones(elty, m1, m2)
            A21 = rand(elty, m2, m1)
            A22 = ones(elty, m2, m2)
            A = [A11 A12; A21 A22]
            @test (@which [A11 A12; A21 A22]).module != LinearMaps
            @inferred hvcat((2,2), LinearMap(A11), LinearMap(A12), LinearMap(A21), LinearMap(A22))
            L = [LinearMap(A11) LinearMap(A12); LinearMap(A21) LinearMap(A22)]
            @test L.maps isa Tuple
            Lv = @inferred LinearMaps.BlockMap{elty}([LinearMap(A11), LinearMap(A12), LinearMap(A21), LinearMap(A22)], (2,2))
            @test Lv.maps isa Vector
            @test @inferred(LinearMaps.MulStyle(L)) === FiveArg()
            @test @inferred !issymmetric(L)
            @test @inferred !ishermitian(L)
            x = rand(m1+m2)
            @test L isa LinearMaps.BlockMap{elty}
            @test size(L) == size(A)
            @test L * x ≈ Lv * x ≈ A * x
            @test Matrix(L) == Matrix(Lv) == A == mul!(zero(A), L, 1)
            for α in (false, 1, rand()), β in (false, 1, rand())
                @test mul!(copy(A), L, 2, α, β) ≈ A*(2α + β)
            end
            @test convert(AbstractMatrix, L) == A
            A = [I A12; A21 I]
            @test (@which [I A12; A21 I]).module != LinearMaps
            @inferred hvcat((2,2), I, LinearMap(A12), LinearMap(A21), I)
            L = @inferred hvcat((2,2), I, LinearMap(A12), LinearMap(A21), I)
            @test L isa LinearMaps.BlockMap{elty}
            @test size(L) == (m1+m2, m1+m2)
            @test Matrix(L) ≈ A
            @test L * x ≈ A * x
            y = randn(elty, size(L, 1))
            for α in (0, 1, rand(elty)), β in (0, 1, rand(elty))
                @test mul!(copy(y), L, x, α, β) ≈ y*β .+ A*x*α
            end
            X = rand(elty, m1+m2, n)
            Y = randn(elty, size(L, 1), n)
            for α in (0, 1, rand(elty)), β in (0, 1, rand(elty))
                @test mul!(copy(Y), L, X, α, β) ≈ Y*β .+ A*X*α
            end
            A = ones(elty, m1, m1); LA = LinearMap(A)
            B = zeros(elty, m2, 3m1); LB = LinearMap(B)
            @test [LA LA LA; LB] isa LinearMaps.BlockMap{elty}
            @test Matrix([LA LA LA; LB]) ≈ [A A A; B]
            @test [LB; LA LA LA] isa LinearMaps.BlockMap{elty}
            @test Matrix([LB; LA LA LA]) ≈ [B; A A A]
            @test [I; LA LA LA] isa LinearMaps.BlockMap{elty}
            @test Matrix([I; LA LA LA]) ≈ [I; A A A]
            A12 = LinearMap(zeros(elty, m1, m2+1))
            A21 = LinearMap(zeros(elty, m2, m1))
            @test_throws DimensionMismatch [I A12; A21 I]
            @test_throws DimensionMismatch [I A21; A12 I]
            @test_throws DimensionMismatch [A12 A12; A21 A21]
            @test_throws DimensionMismatch [A12 A21; A12 A21]

            # basic test of "misaligned" blocks
            M = ones(elty, 3, 2) # non-square
            A = LinearMap(M)
            B = [I A; A I]
            C = [I M; M I]
            @test B isa LinearMaps.BlockMap{elty}
            @test Matrix(B) == C
            @test Matrix(transpose(B)) == transpose(C)
            @test Matrix(adjoint(B)) == C'
        end
    end

    @testset "adjoint/transpose" begin
        for elty in (Float32, ComplexF64), transform in (transpose, adjoint)
            A12 = rand(elty, 10, 10)
            A = [I A12; transform(A12) I]
            L = [I LinearMap(A12); transform(LinearMap(A12)) I]
            @test @inferred(LinearMaps.MulStyle(L)) === FiveArg()
            if elty <: Complex
                if transform == transpose
                    @test @inferred issymmetric(L)
                else
                    @test @inferred ishermitian(L)
                end
            end
            if elty <: Real
                @test @inferred ishermitian(L)
                @test @inferred issymmetric(L)
            end
            x = rand(elty, 20)
            @test L isa LinearMaps.LinearMap{elty}
            @test size(L) == size(A)
            @test L * x ≈ A * x
            @test Matrix(L) == A
            @test convert(AbstractMatrix, L) == A
            @test sparse(L) == sparse(A)
            Lt = @inferred transform(L)
            @test Lt isa LinearMaps.LinearMap{elty}
            @test Lt * x ≈ transform(A) * x
            @test convert(AbstractMatrix, Lt) == transform(A)
            @test sparse(transform(L)) == transform(A)
            for α in (false, 1, rand()), β in (false, 1, rand())
                @test mul!(copy(transform(A)), Lt, 2, α, β) ≈ transform(A)*(2α + β)
            end
            Lt = @inferred transform(LinearMap(L))
            @test Lt * x ≈ transform(A) * x
            @test Matrix(Lt) == Matrix(transform(A))
            A21 = rand(elty, 10, 10)
            A = [I A12; A21 I]
            L = [I LinearMap(A12); LinearMap(A21) I]
            Lt = @inferred transform(L)
            @test Lt isa LinearMaps.LinearMap{elty}
            @test Lt * x ≈ transform(A) * x
            @test Matrix(Lt) ≈ Matrix(transform(LinearMap(L))) ≈ Matrix(transform(A))
            @test Matrix(transform(LinearMap(L))+transform(LinearMap(L))) ≈ 2Matrix(transform(A))
            X = rand(elty, size(L, 1), 10)
            Y = randn(elty, size(L, 2), 10)
            for α in (0, 1, rand(elty)), β in (0, 1, rand(elty))
                @test mul!(copy(Y), Lt, X, α, β) ≈ Y*β .+ transform(A)*X*α
            end
        end
    end

    @testset "block diagonal maps" begin
        for elty in (Float32, ComplexF64)
            m = 2; n = 3
            M1 = 10*(1:m) .+ (1:(n+1))'; L1 = LinearMap(M1)
            M2 = randn(elty, m, n+2); L2 = LinearMap(M2)
            M3 = randn(elty, m, n+3); L3 = LinearMap(M3)

            if elty <: Complex
                @test_throws ErrorException LinearMaps.BlockDiagonalMap{Float64}((L1, L2, L3, L2, L1))
            end
            # Md = diag(M1, M2, M3, M2, M1) # unsupported so use sparse:
            Md = Matrix(blockdiag(sparse.((M1, M2, M3, M2, M1))...))
            @test (@which blockdiag(sparse.((M1, M2, M3, M2, M1))...)).module != LinearMaps
            @test (@which cat(M1, M2, M3, M2, M1; dims=(1,2))).module != LinearMaps
            x = randn(elty, size(Md, 2))
            Bd = @inferred blockdiag(L1, L2, L3, L2, L1)
            @test Bd.maps isa Tuple
            Bdv = @inferred LinearMaps.BlockDiagonalMap{elty}([L1, L2, L3, L2, L1])
            @test Bdv.maps isa Vector
            @test @inferred(LinearMaps.MulStyle(Bd)) === FiveArg()
            @test occursin("$(5m)×$(5n+9) LinearMaps.BlockDiagonalMap{$elty}", sprint((t, s) -> show(t, "text/plain", s), Bd))
            @test Matrix(Bd) == Md == mul!(zero(Md), Bd, 1)
            for α in (false, rand()), β in (false, rand())
                @test mul!(copy(Md), Bd, 2, α, β) ≈ Md*(2α + β)
            end
            @test convert(AbstractMatrix, Bd) isa SparseMatrixCSC
            @test sparse(Bd) == Md
            @test Matrix(@inferred blockdiag(L1)) == M1
            @test Matrix(@inferred blockdiag(L1, L2)) == blockdiag(sparse.((M1, M2))...)
            Bd2 = @inferred cat(L1, L2, L3, L2, L1; dims=(1,2))
            @test_throws ArgumentError cat(L1, L2, L3, L2, L1; dims=(2,2))
            @test Bd == Bdv == Bd2
            @test Bd == blockdiag(L1, M2, M3, M2, M1)
            @test size(Bd) == (5m, 5n+9)
            @test !issymmetric(Bd)
            @test !ishermitian(Bd)
            @test (@inferred Bd * x) ≈ Bdv * x ≈ Md * x
            for transform in (identity, adjoint, transpose)
                @test Matrix(@inferred transform(Bd)) == transform(Md)
                @test Matrix(@inferred transform(LinearMap(Bd))) == transform(Md)
            end
            y = randn(elty, size(Md, 1))
            for α in (0, 1, rand(elty)), β in (0, 1, rand(elty))
                @test mul!(copy(y), Bd, x, α, β) ≈ y*β .+ Md*x*α
                @test mul!(copy(y), Bdv, x, α, β) ≈ y*β .+ Md*x*α
            end
            X = randn(elty, size(Md, 2), 3)
            Y = randn(elty, size(Md, 1), 3)
            for α in (0, 1, rand(elty)), β in (0, 1, rand(elty))
                @test mul!(copy(Y), Bd, X, α, β) ≈ Y*β .+ Md*X*α
                @test mul!(copy(Y), Bdv, X, α, β) ≈ Y*β .+ Md*X*α
            end
        end
    end

    @testset "function block map" begin
        N = 5
        T = ComplexF64
        CS! = LinearMap{T}(cumsum!,
            (y, x) -> (copyto!(y, x); reverse!(cumsum!(y, reverse!(y)))), N;
            ismutating=true)
        A = rand(T, N, N)
        B = rand(T, N, N)
        LT = LowerTriangular(ones(T, N, N))
        L1 = [CS! CS! CS!; CS! CS! CS!; CS! CS! CS!]
        M1 = [LT LT LT; LT LT LT; LT LT LT]
        L2 = [CS! LinearMap(A) CS!; LinearMap(B) CS! CS!; CS! CS! CS!]
        M2 = [LT A LT
              B LT LT
              LT LT LT]
        u = rand(T, 3N)
        v = rand(T, 3N)
        for α in (false, true, rand(T)), β in (false, true, rand(T))
            for transform in (identity, adjoint), (L, M) in ((L1, M1), (L2, M2))
                # @show α, β, transform
                @test mul!(copy(v), transform(L), u, α, β) ≈ transform(M)*u*α + v*β
                @test mul!(copy(v), transform(LinearMap(L)), u, α, β) ≈ transform(M)*u*α + v*β
                @test mul!(copy(v), LinearMap(transform(L)), u, α, β) ≈ transform(M)*u*α + v*β
                if transform != adjoint
                    transL = transform(L)
                    alloc = @allocated similar(v)
                    if L == L2 && α != false
                        @test_broken (@allocated mul!(v, transL, u, α, β)) <= alloc
                    else
                        @test (@allocated mul!(v, transL, u, α, β)) <= alloc
                    end
                end
            end
        end
    end
end

# # Defining custom `LinearMap` types

# In this section, we want to demonstrate on a simple, actually built-in, linear map type
# how to define custom `LinearMap` subtypes. First of all, `LinearMap{T}` is an extendable
# abstract type, where `T` denotes the `eltype`.

# ## Basics

# As an example, we want to define a map type whose objects correspond to lazy analogues
# of `fill`ed matrices. Naturally, we need to store the filled value `λ` and the `size`
# of the linear map.

using LinearMaps, LinearAlgebra

struct MyFillMap{T} <: LinearMaps.LinearMap{T}
    λ::T
    size::Dims{2}
    function MyFillMap(λ::T, dims::Dims{2}) where {T}
        all(≥(0), dims) || throw(ArgumentError("dims of MyFillMap must be non-negative"))
        promote_type(T, typeof(λ)) == T || throw(InexactError())
        return new{T}(λ, dims)
    end
end

# By default, for any `A::MyFillMap{T}`, `eltype(A)` returns `T`. Upon application to a
# vector `x` and/or interaction with other `LinearMap` objects, we need to check consistent
# sizes.

Base.size(A::MyFillMap) = A.size

# By a couple of defaults provided for all subtypes of `LinearMap`, we only need to define
# a `LinearMaps._unsafe_mul!` method to have a minimal, operational type. The (internal)
# function `_unsafe_mul!` is called by `LinearAlgebra.mul!`, constructors, and conversions
# and only needs to be concerned with the bare computing kernel. Dimension checking is done
# on the level of `mul!` etc. Factoring out dimension checking is done to minimise overhead
# caused by repetitive checking.

# !!! note
#     Multiple dispatch at the `_unsafe_mul!` level happens via the second (the map type)
#     and the third arguments (`AbstractVector` or `AbstractMatrix`, see the
#     [Application to matrices](@ref) section below). For that reason, the output argument
#     can remain type-unbound.

function LinearMaps._unsafe_mul!(y, A::MyFillMap, x::AbstractVector)
    return fill!(y, iszero(A.λ) ? zero(eltype(y)) : A.λ*sum(x))
end

# Again, due to generic fallbacks the following now "just work":

# * out-of-place multiplication `A*x`,
# * in-place multiplication with vectors `mul!(y, A, x)`,
# * in-place multiply-and-add with vectors `mul!(y, A, x, α, β)`,
# * in-place multiplication and multiply-and-add with matrices `mul!(Y, A, X, α, β)`,
# * conversion to a (sparse) matrix `Matrix(A)` and `sparse(A)`,
# * complete slicing of columns (and rows if the adjoint action is defined).

A = MyFillMap(5.0, (3, 3)); x = ones(3); sum(x)

#-

A * x

#-

mul!(zeros(3), A, x)

#-

mul!(ones(3), A, x, 2, 2)

#-

mul!(ones(3,3), A, reshape(collect(1:9), 3, 3), 2, 2)

# ## Multiply-and-add and the `MulStyle` trait

# While the above function calls work out of the box due to generic fallbacks, the latter
# may be suboptimally implemented for your custom map type. Let's see some benchmarks.

using BenchmarkTools

@benchmark mul!($(zeros(3)), $A, $x)

#-

@benchmark mul!($(zeros(3)), $A, $x, $(rand()), $(rand()))

# The second benchmark indicates the allocation of an intermediate vector `z`
# which stores the result of `A*x` before it gets scaled and added to (the scaled)
# `y = zeros(3)`. For that reason, it is beneficial to provide a custom "5-arg
# `_unsafe_mul!`" if you can avoid the allocation of an intermediate vector. To indicate
# that there exists an allocation-free implementation of multiply-and-add, you should set
# the `MulStyle` trait, whose default is `ThreeArg()`, to `FiveArg()`.

LinearMaps.MulStyle(A::MyFillMap) = FiveArg()

function LinearMaps._unsafe_mul!(y, A::MyFillMap, x::AbstractVector, α, β)
    if iszero(α)
        !isone(β) && rmul!(y, β)
        return y
    else
        temp = A.λ * sum(x) * α
        if iszero(β)
            y .= temp
        elseif isone(β)
            y .+= temp
        else
            y .= y .* β .+ temp
        end
    end
    return y
end

# With this function at hand, let's redo the benchmark.

@benchmark mul!($(zeros(3)), $A, $x, $(rand()), $(rand()))

# There you go, the allocation is gone and the computation time is significantly reduced.

# ## Adjoints and transposes

# Generically, taking the transpose (or the adjoint) of a (real, resp.) map wraps the
# linear map by a `TransposeMap`, taking the adjoint of a complex map wraps it by an
# `AdjointMap`.

typeof(A')

# Not surprisingly, without further definitions, multiplying `A'` by `x` yields an error.

try A'x catch e println(e) end

# If the operator is symmetric or Hermitian, the transpose and the adjoint, respectively,
# of the linear map `A` is given by `A` itself. So let us define corresponding checks.

LinearAlgebra.issymmetric(A::MyFillMap) = A.size[1] == A.size[2]
LinearAlgebra.ishermitian(A::MyFillMap) = isreal(A.λ) && A.size[1] == A.size[2]
LinearAlgebra.isposdef(A::MyFillMap) = (size(A, 1) == size(A, 2) == 1 && isposdef(A.λ))
Base.:(==)(A::MyFillMap, B::MyFillMap) = A.λ == B.λ && A.size == B.size

# These are used, for instance, in checking symmetry or positive definiteness of
# higher-order `LinearMap`s, like products or linear combinations of linear maps, or signal
# to iterative eigenproblem solvers that real eigenvalues are to be computed.
# Without these definitions, the first three functions would return `false` (by default),
# and the last one would fall back to `===`.

# With this at hand, we note that `A` above is symmetric, and we can compute

transpose(A)*x

# This, however, does not work for nonsquare maps

try MyFillMap(5.0, (3, 4))' * ones(3) catch e println(e) end

# which require explicit adjoint/transpose handling, for which there exist two *distinct*
# paths.

# ### Path 1: Generic, non-invariant `LinearMap` subtypes

# The first option is to write `LinearMaps._unsafe_mul!` methods for the corresponding
# wrapped map types; for instance,

function LinearMaps._unsafe_mul!(
    y,
    transA::LinearMaps.TransposeMap{<:Any,<:MyFillMap},
    x::AbstractVector
)
    λ = transA.lmap.λ
    return fill!(y, iszero(λ) ? zero(eltype(y)) : transpose(λ)*sum(x))
end

# Now, the adjoint multiplication works.

MyFillMap(5.0, (3, 4))' * ones(3)

# If you have set the `MulStyle` trait to `FiveArg()`, you should provide a corresponding
# 5-arg `mul!` method for `LinearMaps.TransposeMap{<:Any,<:MyFillMap}` and
# `LinearMaps.AdjointMap{<:Any,<:MyFillMap}`.

# ### Path 2: Invariant `LinearMap` subtypes

# Before we start, let us delete the previously defined method to make sure we use the
# following definitions.

Base.delete_method(
    first(methods(
        LinearMaps._unsafe_mul!,
        (Any, LinearMaps.TransposeMap{<:Any,<:MyFillMap}, AbstractVector))
    )
)

# The second option is when your class of linear maps that are modelled by your custom
# `LinearMap` subtype are invariant under taking adjoints and transposes.

LinearAlgebra.adjoint(A::MyFillMap) = MyFillMap(adjoint(A.λ), reverse(A.size))
LinearAlgebra.transpose(A::MyFillMap) = MyFillMap(transpose(A.λ), reverse(A.size))

# With such invariant definitions, i.e., the adjoint/transpose of a `MyFillMap` is again
# a `MyFillMap`, no further method definitions are required, and the entire functionality
# listed above just works for adjoints/transposes of your custom map type.

mul!(ones(3), A', x, 2, 2)

#-

MyFillMap(5.0, (3, 4))' * ones(3)

# Now that we have defined the action of adjoints/transposes, the
# following right action on vectors is automatically defined:

ones(3)' * MyFillMap(5.0, (3, 4))

# and `transpose(x) * A` correspondingly, as well as in-place multiplication

mul!(similar(x)', x', A)

# and `mul!(transpose(y), transpose(x), A)`.

# ## Application to matrices

# By default, applying a `LinearMap` `A` to a matrix `X` via `A*X` does
# *not* apply `A` to each column of `X` viewed as a vector, but interprets
# `X` as a linear map, wraps it as such and returns `(A*X)::CompositeMap`.
# Calling the in-place multiplication function `mul!(Y, A, X)` for matrices,
# however, does compute the columnwise action of `A` on `X` and stores the
# result in `Y`. In case there is a more efficient implementation for the
# matrix application, you can provide `_unsafe_mul!` methods with signature
# `_unsafe_mul!(Y, A::MyFillMap, X::AbstractMatrix)`, and, depending
# on the chosen path to handle adjoints/transposes, corresponding methods
# for wrapped maps of type `AdjointMap` or `TransposeMap`, plus potentially
# corresponding 5-arg `mul!` methods. This may seem like a lot of methods to
# be implemented, but note that adding such methods is only necessary/recommended
# for increased performance.

# ## Computing a matrix representation

# In some cases, it might be necessary to compute a matrix representation of a `LinearMap`.
# This is essentially done via the
# `[LinearMaps._unsafe_mul!(::Matrix,::LinearMap,::Number)]`(@ref) method, for which a
# generic fallback exists: it applies the `LinearMap` successively to the standard unit
# vectors.

F = MyFillMap(5, (100,100))
M = Matrix{eltype(F)}(undef, size(F))
@benchmark Matrix($F)

#-

@benchmark LinearMaps._unsafe_mul!($(Matrix{Int}(undef, (100,100))), $(MyFillMap(5, (100,100))), true)

# If a more performant implementation exists, it is recommended to overwrite this method,
# for instance (as before, size checks need not be included here since they are handled by
# the corresponding `LinearAlgebra.mul!` method):

LinearMaps._unsafe_mul!(M, A::MyFillMap, s::Number) = fill!(M, A.λ*s)
@benchmark Matrix($F)

#-

@benchmark LinearMaps._unsafe_mul!($(Matrix{Int}(undef, (100,100))), $(MyFillMap(5, (100,100))), true)

# As one can see, the above runtimes are dominated by the allocation of the output matrix,
# but still overwriting the multiplication kernel yields a speed-up of about factor 3 for
# the matrix filling part.

# ## Slicing

# As usual, generic fallbacks for `LinearMap` slicing exist and are handled by the following
# method hierarchy, where at least one of `I` and `J` has to be a `Colon`:
#
#     Base.getindex(::LinearMap, I, J)
#     -> LinearMaps._getindex(::LinearMap, I, J)
#
# The method `Base.getindex` checks the validity of the the requested indices and calls
# `LinearMaps._getindex`, which should be overloaded for custom `LinearMap`s subtypes.
# For instance:

@benchmark F[1,:]

#-

LinearMaps._getindex(A::MyFillMap, ::Integer, J::Base.Slice) = fill(A.λ, axes(J))
@benchmark F[1,:]

# Note that in `Base.getindex` `Colon`s are converted to `Base.Slice` via
# `Base.to_indices`, thus the dispatch must be on `Base.Slice` rather than on `Colon`.

struct EmbeddedMap{T, As <: LinearMap, Rs <: AbstractVector{Int},
                    Cs <: AbstractVector{Int}} <: LinearMap{T}
    lmap::As
    dims::Dims{2}
    rows::Rs # typically i1:i2 with 1 <= i1 <= i2 <= size(map,1)
    cols::Cs # typically j1:j2 with 1 <= j1 <= j2 <= size(map,2)

    function EmbeddedMap{T}(map::As, dims::Dims{2}, rows::Rs, cols::Cs) where {T,
                    As <: LinearMap, Rs <: AbstractVector{Int}, Cs <: AbstractVector{Int}}
        check_index(rows, size(map, 1), dims[1])
        check_index(cols, size(map, 2), dims[2])
        return new{T,As,Rs,Cs}(map, dims, rows, cols)
    end
end

EmbeddedMap(map::LinearMap{T}, dims::Dims{2}; offset::Dims{2}) where {T} =
    EmbeddedMap{T}(map, dims, offset[1] .+ (1:size(map, 1)), offset[2] .+ (1:size(map, 2)))
EmbeddedMap(map::LinearMap, dims::Dims{2}, rows::AbstractVector{Int}, cols::AbstractVector{Int}) =
    EmbeddedMap{eltype(map)}(map, dims, rows, cols)

@static if VERSION >= v"1.8-"
    Base.reverse(A::LinearMap; dims=:) = _reverse(A, dims)
    function _reverse(A, dims::Integer)
        if dims == 1
            return EmbeddedMap(A, size(A), reverse(axes(A, 1)), axes(A, 2))
        elseif dims == 2
            return EmbeddedMap(A, size(A), axes(A, 1), reverse(axes(A, 2)))
        else
            throw(ArgumentError("invalid dims argument to reverse, should be 1 or 2, got $dims"))
        end
    end
    _reverse(A, ::Colon) = EmbeddedMap(A, size(A), map(reverse, axes(A))...)
    _reverse(A, dims::NTuple{1,Integer}) = _reverse(A, first(dims))
    function _reverse(A, dims::NTuple{M,Integer}) where {M}
        dimrev = ntuple(k -> k in dims, 2)
        if 2 < M || M != sum(dimrev)
            throw(ArgumentError("invalid dimensions $dims in reverse!"))
        end
        ax = ntuple(k -> dimrev[k] ? reverse(axes(A, k)) : axes(A, k), 2)
        return EmbeddedMap(A, size(A), ax...)
    end
end

function check_index(index::AbstractVector{Int}, dimA::Int, dimB::Int)
    length(index) != dimA && throw(ArgumentError("invalid length of index vector"))
    minimum(index) <= 0 && throw(ArgumentError("minimal index is below 1"))
    maximum(index) > dimB && throw(ArgumentError(
        "maximal index $(maximum(index)) exceeds dimension $dimB"
        ))
    # _isvalidstep(index) || throw(ArgumentError("non-monotone index set"))
    nothing
end

# _isvalidstep(index::AbstractRange) = step(index) > 0
# _isvalidstep(index::AbstractVector) = all(diff(index) .> 0)

Base.size(A::EmbeddedMap) = A.dims

# sufficient but not necessary conditions
LinearAlgebra.issymmetric(A::EmbeddedMap) =
    issymmetric(A.lmap) && (A.dims[1] == A.dims[2]) && (A.rows == A.cols)
LinearAlgebra.ishermitian(A::EmbeddedMap) =
    ishermitian(A.lmap) && (A.dims[1] == A.dims[2]) && (A.rows == A.cols)

Base.:(==)(A::EmbeddedMap, B::EmbeddedMap) =
    (eltype(A) == eltype(B)) && (A.lmap == B.lmap) &&
    (A.dims == B.dims) && (A.rows == B.rows) && (A.cols == B.cols)

LinearAlgebra.adjoint(A::EmbeddedMap) = EmbeddedMap(adjoint(A.lmap), reverse(A.dims), A.cols, A.rows)
LinearAlgebra.transpose(A::EmbeddedMap) = EmbeddedMap(transpose(A.lmap), reverse(A.dims), A.cols, A.rows)

for In in (AbstractVector, AbstractMatrix)
    @eval function _unsafe_mul!(y, A::EmbeddedMap, x::$In)
        fill!(y, zero(eltype(y)))
        _unsafe_mul!(selectdim(y, 1, A.rows), A.lmap, selectdim(x, 1, A.cols))
        return y
    end
    @eval function _unsafe_mul!(y, A::EmbeddedMap, x::$In, α, β)
        LinearAlgebra._rmul_or_fill!(y, β)
        _unsafe_mul!(selectdim(y, 1, A.rows), A.lmap, selectdim(x, 1, A.cols), α, !iszero(β))
        return y
    end
end

function _unsafe_mul!(Y, A::EmbeddedMap, x::Number)
    fill!(Y, zero(eltype(Y)))
    _unsafe_mul!(view(Y, A.rows, A.cols), A.lmap, x)
    return Y
end
function _unsafe_mul!(Y, A::EmbeddedMap, x::Number, α, β)
    LinearAlgebra._rmul_or_fill!(Y, β)
    _unsafe_mul!(view(Y, A.rows, A.cols), A.lmap, x, α, !iszero(β))
    return Y
end

module LinearMapsChainRulesCoreExt

using ChainRulesCore: unthunk, NoTangent, @thunk, @not_implemented
import ChainRulesCore: rrule

using LinearMaps

function rrule(::typeof(*), A::LinearMap, x::AbstractVector)
    y = A*x
    function pullback(dy)
        DY = unthunk(dy)
        return NoTangent(), @not_implemented("Gradient with respect to linear map itself not implemented."), @thunk(A' * DY)
    end
    return y, pullback
end

function rrule(A::LinearMap, x::AbstractVector)
    y = A*x
    function pullback(dy)
        DY = unthunk(dy)
        return @not_implemented("Gradient with respect to linear map itself not implemented."), @thunk(A' * DY)
    end
    return y, pullback
end


end # module ChainRulesCore

using Documenter
using Literate
using LinearMaps
using LinearAlgebra
using SparseArrays

Literate.markdown(joinpath(@__DIR__, "src", "custom.jl"), joinpath(@__DIR__, "src/generated"))

makedocs(
    sitename = "LinearMaps.jl",
    modules = [LinearMaps,
        isdefined(Base, :get_extension) ? Base.get_extension(LinearMaps, :LinearMapsSparseArraysExt) :
        LinearMaps.LinearMapsSparseArraysExt],
    pages = Any[
        "Home" => "index.md",
        "Version history" => "history.md",
        "Types and methods" => "types.md",
        "Custom maps" => "generated/custom.md",
        "Related packages" => "related.md"
    ]
)

# Documenter can also automatically deploy documentation to gh-pages.
# See "Hosting Documentation" and deploydocs() in the Documenter manual
# for more information.
deploydocs(
    repo = "github.com/JuliaLinearAlgebra/LinearMaps.jl.git",
    push_preview=true
)

function tr(A::LinearMap)
    _issquare(A) || throw(ArgumentError("operator needs to be square in tr"))
    _tr(A)
end

function _tr(A::LinearMap{T}) where {T}
    S = typeof(oneunit(eltype(A)) + oneunit(eltype(A)))
    ax1, ax2 = axes(A)
    xi = zeros(eltype(A), ax2)
    y = similar(xi, T, ax1)
    o = one(T)
    z = zero(T)
    s = zero(S)
    @inbounds for (i, j) in zip(ax1, ax2)
        xi[j] = o
        mul!(y, A, xi)
        xi[j] = z
        s += y[i]
    end
    return s
end
function _tr(A::OOPFunctionMap{T}) where {T}
    S = typeof(oneunit(eltype(A)) + oneunit(eltype(A)))
    ax1, ax2 = axes(A)
    xi = zeros(eltype(A), ax2)
    o = one(T)
    z = zero(T)
    s = zero(S)
    @inbounds for (i, j) in zip(ax1, ax2)
        xi[j] = o
        s += (A * xi)[i]
        xi[j] = z
    end
    return s
end
# specialisations
_tr(A::AbstractVecOrMat) = tr(A)
_tr(A::WrappedMap) = _tr(A.lmap)
_tr(A::TransposeMap) = _tr(A.lmap)
_tr(A::AdjointMap) = conj(_tr(A.lmap))
_tr(A::UniformScalingMap) = A.M * A.λ
_tr(A::ScaledMap) = A.λ * _tr(A.lmap)
function _tr(L::KroneckerMap)
    if all(_issquare, L.maps)
        return prod(_tr, L.maps)
    else
        return invoke(_tr, Tuple{LinearMap}, L)
    end
end
function _tr(L::OuterProductMap{<:RealOrComplex})
    a, bt = L.maps
    return bt.lmap*a.lmap
end
function _tr(L::OuterProductMap)
    a, bt = L.maps
    mapreduce(*, +, a.lmap, bt.lmap)
end
function _tr(L::KroneckerSumMap)
    A, B = L.maps # A and B are square by construction
    return _tr(A) * size(B, 1) + _tr(B) * size(A, 1)
end
_tr(A::FillMap) = A.size[1] * A.λ

struct KroneckerMap{T, As<:LinearMapTupleOrVector} <: LinearMap{T}
    maps::As
    function KroneckerMap{T}(maps::LinearMapTupleOrVector) where {T}
        for TA in Base.Iterators.map(eltype, maps)
            promote_type(T, TA) == T ||
                error("eltype $TA cannot be promoted to $T in KroneckerMap constructor")
        end
        return new{T,typeof(maps)}(maps)
    end
end

"""
    kron(A::LinearMap, B::LinearMap)::KroneckerMap
    kron(A, B, Cs...)::KroneckerMap

Construct a (lazy) representation of the Kronecker product `A⊗B`. One of the two factors
can be an `AbstractMatrix`, which is then promoted to a `LinearMap` automatically.

To avoid fallback to the generic [`Base.kron`](@ref) in the multi-map case,
there must be a `LinearMap` object among the first 8 arguments in usage like
`kron(A, B, Cs...)`.

For convenience, one can also use `A ⊗ B` or `⊗(A, B, Cs...)` (typed as `\\otimes+TAB`) to construct the
`KroneckerMap`, even when all arguments are of `AbstractMatrix` type.

If `A`, `B`, `C` and `D` are linear maps of such size that one can form the matrix
products `A*C` and `B*D`, then the mixed-product property `(A⊗B)*(C⊗D) = (A*C)⊗(B*D)`
holds. Upon vector multiplication, this rule is checked for applicability.

# Examples
```jldoctest; setup=(using LinearAlgebra, SparseArrays, LinearMaps)
julia> J = LinearMap(I, 2) # 2×2 identity map
2×2 LinearMaps.UniformScalingMap{Bool} with scaling factor: true

julia> E = spdiagm(-1 => trues(1)); D = E + E' - 2I;

julia> Δ = kron(D, J) + kron(J, D); # discrete 2D-Laplace operator

julia> Matrix(Δ)
4×4 Matrix{Int64}:
 -4   1   1   0
  1  -4   0   1
  1   0  -4   1
  0   1   1  -4
```
"""
Base.kron(A::LinearMap, B::LinearMap) =
    KroneckerMap{promote_type(eltype(A), eltype(B))}((A, B))
Base.kron(A::LinearMap, B::KroneckerMap) =
    KroneckerMap{promote_type(eltype(A), eltype(B))}(_combine(A, B.maps))
Base.kron(A::KroneckerMap, B::LinearMap) =
    KroneckerMap{promote_type(eltype(A), eltype(B))}(_combine(A.maps, B))
Base.kron(A::KroneckerMap, B::KroneckerMap) =
    KroneckerMap{promote_type(eltype(A), eltype(B))}(_combine(A.maps, B.maps))
# hoist out scalings
Base.kron(A::ScaledMap, B::LinearMap) = A.λ * kron(A.lmap, B)
Base.kron(A::LinearMap, B::ScaledMap) = kron(A, B.lmap) * B.λ
Base.kron(A::ScaledMap, B::ScaledMap) = (A.λ * B.λ) * kron(A.lmap, B.lmap)
# reduce UniformScalingMaps
Base.kron(A::UniformScalingMap, B::UniformScalingMap) = UniformScalingMap(A.λ * B.λ, A.M * B.M)
# disambiguation
Base.kron(A::ScaledMap, B::KroneckerMap) = A.λ * kron(A.lmap, B)
Base.kron(A::KroneckerMap, B::ScaledMap) = kron(A, B.lmap) * B.λ
# generic definitions
Base.kron(A::LinearMap, B::LinearMap, C::LinearMap, Ds::LinearMap...) =
    kron(kron(A, B), C, Ds...)
Base.kron(A::AbstractVecOrMat, B::LinearMap) = kron(LinearMap(A), B)
Base.kron(A::LinearMap, B::AbstractVecOrMat) = kron(A, LinearMap(B))
# promote AbstractMatrix arguments to LinearMaps, then take LinearMap-Kronecker product
for k in 3:8 # is 8 sufficient?
    Is = ntuple(n->:($(Symbol(:A, n))::AbstractVecOrMat), Val(k-1))
    # yields (:A1, :A2, :A3, ..., :A(k-1))
    L = :($(Symbol(:A, k))::LinearMap)
    # yields :Ak::LinearMap
    mapargs = ntuple(n -> :(LinearMap($(Symbol(:A, n)))), Val(k-1))
    # yields (:LinearMap(A1), :LinearMap(A2), ..., :LinearMap(A(k-1)))

    @eval Base.kron($(Is...), $L, As::MapOrVecOrMat...) =
        kron($(mapargs...), $(Symbol(:A, k)), convert_to_lmaps(As...)...)
end

@doc raw"""
    squarekron(A₁::MapOrMatrix, A₂::MapOrMatrix, A₃::MapOrMatrix, Aᵢ::MapOrMatrix...)::CompositeMap

Construct a (lazy) representation of the Kronecker product `⨂ᵢ₌₁ⁿ Aᵢ` of at least 3 _square_
Kronecker factors. In contrast to [`kron`](@ref), this function assumes that all Kronecker
factors are square, and makes use of the following identity[^1]:

```math
\bigotimes_{i=1}^n A_i = \prod_{i=1}^n I_1 \otimes \ldots \otimes I_{i-1} \otimes A_i \otimes I_{i+1} \otimes \ldots \otimes I_n
```

where ``I_k`` is an identity matrix of the size of ``A_k``. By associativity, the
Kronecker product of the identity operators may be combined to larger identity operators
``I_{1:i-1}`` and ``I_{i+1:n}``, which yields

```math
\bigotimes_{i=1}^n A_i = \prod_{i=1}^n I_{1:i-1} \otimes A_i \otimes I_{i+1:n}
```

i.e., a `CompositeMap` where each factor is a Kronecker product consisting of three maps:
outer `UniformScalingMap`s and the respective Kronecker factor. This representation is
expected to yield significantly faster multiplication (and reduce memory allocation)
compared to [`kron`](@ref), but benchmarking intended use cases is highly recommended.

[^1]: Fernandes, P. and Plateau, B. and Stewart, W. J. ["Efficient Descriptor-Vector Multiplications in Stochastic Automata Networks"](https://doi.org/10.1145/278298.278303), _Journal of the ACM_, 45(3), 381–414, 1998.
"""
function squarekron(A::MapOrMatrix, B::MapOrMatrix, C::MapOrMatrix, Ds::MapOrMatrix...)
    maps = (A, B, C, Ds...)
    T = promote_type(map(eltype, maps)...)
    all(_issquare, maps) || throw(ArgumentError("operators need to be square in squarekron"))
    ns = map(a -> size(a, 1), maps)
    firstmap = first(maps) ⊗ UniformScalingMap(true, prod(ns[2:end]))
    lastmap  = UniformScalingMap(true, prod(ns[1:end-1])) ⊗ last(maps)
    middlemaps = prod(enumerate(maps[2:end-1])) do (i, map)
        UniformScalingMap(true, prod(ns[1:i])) ⊗ map ⊗ UniformScalingMap(true, prod(ns[i+2:end]))
    end
    return firstmap * middlemaps * lastmap
end

struct KronPower{p}
    function KronPower(p::Integer)
        p > 1 || throw(ArgumentError("the Kronecker power is only defined for exponents larger than 1, got $k"))
        return new{p}()
    end
end

"""
    ⊗(k::Integer)

Construct a lazy representation of the `k`-th Kronecker power
`A^⊗(k) = A ⊗ A ⊗ ... ⊗ A`, where `A` can be an `AbstractMatrix` or a `LinearMap`.
"""
⊗(k::Integer) = KronPower(k)

⊗(A, B, Cs...) = kron(convert_to_lmaps(A, B, Cs...)...)

Base.:(^)(A::MapOrMatrix, ::KronPower{p}) where {p} =
    kron(ntuple(n -> convert(LinearMap, A), Val(p))...)

Base.size(A::KroneckerMap) = map(*, size.(A.maps)...)

LinearAlgebra.issymmetric(A::KroneckerMap) = all(issymmetric, A.maps)
LinearAlgebra.ishermitian(A::KroneckerMap) = all(ishermitian, A.maps)

LinearAlgebra.adjoint(A::KroneckerMap) = KroneckerMap{eltype(A)}(map(adjoint, A.maps))
LinearAlgebra.transpose(A::KroneckerMap) = KroneckerMap{eltype(A)}(map(transpose, A.maps))

Base.:(==)(A::KroneckerMap, B::KroneckerMap) =
    (eltype(A) == eltype(B) && all(A.maps .== B.maps))

#################
# multiplication helper functions
#################

@inline function _kronmul!(Y, B, X, A)
    # minimize intermediate memory allocation
    if size(B, 2) * size(A, 1) <= size(B, 1) * size(A, 2)
        temp = similar(Y, (size(B, 2), size(A, 1) ))
        _unsafe_mul!(temp, X, transpose(A))
        _unsafe_mul!(Y, B, temp)
    else
        temp = similar(Y, (size(B, 1), size(A, 2)))
        _unsafe_mul!(temp, B, X)
        _unsafe_mul!(Y, temp, transpose(A))
    end
    return Y
end
@inline function _kronmul!(Y, B::UniformScalingMap, X, A)
    _unsafe_mul!(Y, X, transpose(A))
    !isone(B.λ) && lmul!(B.λ, Y)
    return Y
end
@inline function _kronmul!(Y, B, X, A::UniformScalingMap)
    _unsafe_mul!(Y, B, X)
    !isone(A.λ) && rmul!(Y, A.λ)
    return Y
end
# disambiguation (cannot occur)
@inline function _kronmul!(Y, B::UniformScalingMap, X, A::UniformScalingMap)
    mul!(parent(Y), A.λ * B.λ, parent(X))
    return Y
end
@inline function _kronmul!(Y, B, X, A::VecOrMatMap)
    At = transpose(A.lmap)
    if size(B, 2) * size(A, 1) <= size(B, 1) * size(A, 2)
        _unsafe_mul!(Y, B, X * At)
    else
        _unsafe_mul!(Y, Matrix(B * X), At)
    end
    return Y
end
@inline function _kronmul!(Y, B::UniformScalingMap, X, A::VecOrMatMap)
    _unsafe_mul!(Y, X, transpose(A.lmap))
    !isone(B.λ) && lmul!(B.λ, Y)
    return Y
end

const VectorMap{T} = WrappedMap{T,<:AbstractVector}
const AdjOrTransVectorMap{T} = WrappedMap{T,<:LinearAlgebra.AdjOrTransAbsVec}

#################
# multiplication with vectors
#################

const KroneckerMap2{T} = KroneckerMap{T, <:Tuple{LinearMap, LinearMap}}
const OuterProductMap{T} = KroneckerMap{T, <:Tuple{VectorMap, AdjOrTransVectorMap}}
function _unsafe_mul!(y, L::OuterProductMap, x::AbstractVector)
    a, bt = L.maps
    mul!(y, a.lmap, bt.lmap * x)
end
function _unsafe_mul!(y, L::KroneckerMap{<:Any,<:Tuple{VectorMap,VectorMap}}, x::AbstractVector)
    a, b = L.maps
    kron!(y, a.lmap, b.lmap)
    rmul!(y, first(x))
    return y
end
function _unsafe_mul!(y, L::KroneckerMap2, x::AbstractVector)
    require_one_based_indexing(y)
    A, B = L.maps
    ma, na = size(A)
    mb, nb = size(B)
    X = reshape(x, (nb, na))
    Y = reshape(y, (mb, ma))
    _kronmul!(Y, B, X, A)
    return y
end
function _unsafe_mul!(y, L::KroneckerMap, x::AbstractVector)
    require_one_based_indexing(y)
    maps = L.maps
    if length(maps) == 2 # reachable only for L.maps::Vector
        A, B = maps
        ma, na = size(A)
        mb, nb = size(B)
        X = reshape(x, (nb, na))
        Y = reshape(y, (mb, ma))
        _kronmul!(Y, B, X, A)
    else
        A = first(maps)
        B = KroneckerMap{eltype(L)}(_tail(maps))
        ma, na = size(A)
        mb, nb = size(B)
        X = reshape(x, (nb, na))
        Y = reshape(y, (mb, ma))
        _kronmul!(Y, B, X, A)
    end
    return y
end
# mixed-product rule, prefer the right if possible
# (A₁ ⊗ A₂ ⊗ ... ⊗ Aᵣ) * (B₁ ⊗ B₂ ⊗ ... ⊗ Bᵣ) = (A₁B₁) ⊗ (A₂B₂) ⊗ ... ⊗ (AᵣBᵣ)
function _unsafe_mul!(y,
                        L::CompositeMap{<:Any,<:Tuple{KroneckerMap,KroneckerMap}},
                        x::AbstractVector)
    require_one_based_indexing(y)
    B, A = L.maps
    if length(A.maps) == length(B.maps) && all(_iscompatible, zip(A.maps, B.maps))
        _unsafe_mul!(y, KroneckerMap{eltype(L)}(map(*, A.maps, B.maps)), x)
    else
        _unsafe_mul!(y, LinearMap(A)*B, x)
    end
    return y
end
# mixed-product rule, prefer the right if possible
# (A₁⊗B₁) * (A₂⊗B₂) * ... * (Aᵣ⊗Bᵣ) = (A₁*A₂*...*Aᵣ) ⊗ (B₁*B₂*...*Bᵣ)
function _unsafe_mul!(y,
                        L::CompositeMap{T, <:Union{Tuple{Vararg{KroneckerMap2}},AbstractVector{<:KroneckerMap2}}},
                        x::AbstractVector) where {T}
    require_one_based_indexing(y)
    As = map(AB -> AB.maps[1], L.maps)
    Bs = map(AB -> AB.maps[2], L.maps)
    As1, As2 = _front(As), _tail(As)
    Bs1, Bs2 = _front(Bs), _tail(Bs)
    apply = all(_iscompatible, zip(As1, As2)) && all(_iscompatible, zip(Bs1, Bs2))
    if apply
        _unsafe_mul!(y, kron(prod(_reverse!(As)), prod(_reverse!(Bs))), x)
    else
        _unsafe_mul!(y, CompositeMap{T}(map(LinearMap, L.maps)), x)
    end
    return y
end

###############
# KroneckerSumMap
###############
struct KroneckerSumMap{T, As<:Tuple{LinearMap, LinearMap}} <: LinearMap{T}
    maps::As
    function KroneckerSumMap{T}(maps::Tuple{LinearMap,LinearMap}) where {T}
        A1, A2 = maps
        (_issquare(A1) && _issquare(A2)) ||
            throw(ArgumentError("operators need to be square in Kronecker sums"))
        for TA in Base.Iterators.map(eltype, maps)
            promote_type(T, TA) == T ||
                error("eltype $TA cannot be promoted to $T in KroneckerSumMap constructor")
        end
        return new{T, typeof(maps)}(maps)
    end
end

"""
    kronsum(A, B)::KroneckerSumMap
    kronsum(A, B, Cs...)::KroneckerSumMap

Construct a (lazy) representation of the Kronecker sum `A⊕B = A ⊗ Ib + Ia ⊗ B`
of two square linear maps of type `LinearMap` or `AbstractMatrix`. Here, `Ia`
and `Ib` are identity operators of the size of `A` and `B`, respectively.
Arguments of type `AbstractMatrix` are automatically promoted to `LinearMap`.

For convenience, one can also use `A ⊕ B` or `⊕(A, B, Cs...)` (typed as
`\\oplus+TAB`) to construct the `KroneckerSumMap`.

# Examples
```jldoctest; setup=(using LinearAlgebra, SparseArrays, LinearMaps)
julia> J = LinearMap(I, 2) # 2×2 identity map
2×2 LinearMaps.UniformScalingMap{Bool} with scaling factor: true

julia> E = spdiagm(-1 => trues(1)); D = LinearMap(E + E' - 2I);

julia> Δ₁ = kron(D, J) + kron(J, D); # discrete 2D-Laplace operator, Kronecker sum

julia> Δ₂ = kronsum(D, D);

julia> Δ₃ = D^⊕(2);

julia> Matrix(Δ₁) == Matrix(Δ₂) == Matrix(Δ₃)
true
```
"""
kronsum(A::MapOrMatrix, B::MapOrMatrix) =
    KroneckerSumMap{promote_type(eltype(A), eltype(B))}(convert_to_lmaps(A, B))
kronsum(A::MapOrMatrix, B::MapOrMatrix, C::MapOrMatrix, Ds::MapOrMatrix...) =
    kronsum(A, kronsum(B, C, Ds...))

@doc raw"""
    sumkronsum(A, B)::LinearCombination
    sumkronsum(A, B, Cs...)::LinearCombination

Construct a (lazy) representation of the Kronecker sum `A⊕B` of two or more square
objects of type `LinearMap` or `AbstractMatrix`. This function makes use of the following
representation of Kronecker sums[^1]:

```math
\bigoplus_{i=1}^n A_i = \sum_{i=1}^n I_1 \otimes \ldots \otimes I_{i-1} \otimes A_i \otimes I_{i+1} \otimes \ldots \otimes I_n
```

where ``I_k`` is the identity operator of the size of ``A_k``. By associativity, the
Kronecker product of the identity operators may be combined to larger identity operators
``I_{1:i-1}`` and ``I_{i+1:n}``, which yields

```math
\bigoplus_{i=1}^n A_i = \sum_{i=1}^n I_{1:i-1} \otimes A_i \otimes I_{i+1:n},
```

i.e., a `LinearCombination` where each summand is a Kronecker product consisting of three
maps: outer `UniformScalingMap`s and the respective Kronecker factor. This representation is
expected to yield significantly faster multiplication (and reduce memory allocation)
compared to [`kronsum`](@ref), especially for 3 or more Kronecker summands, but
benchmarking intended use cases is highly recommended.

# Examples
```jldoctest; setup=(using LinearAlgebra, SparseArrays, LinearMaps)
julia> J = LinearMap(I, 2) # 2×2 identity map
2×2 LinearMaps.UniformScalingMap{Bool} with scaling factor: true

julia> E = spdiagm(-1 => trues(1)); D = LinearMap(E + E' - 2I);

julia> Δ₁ = kron(D, J) + kron(J, D); # discrete 2D-Laplace operator, Kronecker sum

julia> Δ₂ = sumkronsum(D, D);

julia> Δ₃ = D^⊕(2);

julia> Matrix(Δ₁) == Matrix(Δ₂) == Matrix(Δ₃)
true
```

[^1]: Fernandes, P. and Plateau, B. and Stewart, W. J. ["Efficient Descriptor-Vector Multiplications in Stochastic Automata Networks"](https://doi.org/10.1145/278298.278303), _Journal of the ACM_, 45(3), 381–414, 1998.
"""
function sumkronsum(A::MapOrMatrix, B::MapOrMatrix)
    (_issquare(A) && _issquare(B)) || throw(ArgumentError("operators need to be square in Kronecker sums"))
    A ⊗ UniformScalingMap(true, size(B,1)) + UniformScalingMap(true, size(A,1)) ⊗ B
end
function sumkronsum(A::MapOrMatrix, B::MapOrMatrix, C::MapOrMatrix, Ds::MapOrMatrix...)
    maps = (A, B, C, Ds...)
    all(_issquare, maps) || throw(ArgumentError("operators need to be square in Kronecker sums"))
    ns = map(a -> size(a, 1), maps)
    n = length(maps)
    firstmap = first(maps) ⊗ UniformScalingMap(true, prod(ns[2:end]))
    lastmap  = UniformScalingMap(true, prod(ns[1:end-1])) ⊗ last(maps)
    middlemaps = sum(enumerate(Base.front(Base.tail(maps)))) do (i, map)
        UniformScalingMap(true, prod(ns[1:i])) ⊗ map ⊗ UniformScalingMap(true, prod(ns[i+2:end]))
    end
    return firstmap + middlemaps + lastmap
end

struct KronSumPower{p}
    function KronSumPower(p::Integer)
        p > 1 || throw(ArgumentError("the Kronecker sum power is only defined for exponents larger than 1, got $k"))
        return new{p}()
    end
end

"""
    ⊕(k::Integer)

Construct a lazy representation of the `k`-th Kronecker sum power `A^⊕(k) = A ⊕ A ⊕ ... ⊕ A`,
where `A` can be a square `AbstractMatrix` or a `LinearMap`. This calls [`sumkronsum`](@ref)
on the `k`-tuple `(A, ..., A)` for `k ≥ 3`.

# Example
```jldoctest
julia> Matrix([1 0; 0 1]^⊕(2))
4×4 Matrix{Int64}:
 2  0  0  0
 0  2  0  0
 0  0  2  0
 0  0  0  2
"""
⊕(k::Integer) = KronSumPower(k)

⊕(a, b, c...) = kronsum(a, b, c...)

Base.:(^)(A::MapOrMatrix, ::KronSumPower{2}) =
    kronsum(convert(LinearMap, A), convert(LinearMap, A))
Base.:(^)(A::MapOrMatrix, ::KronSumPower{p}) where {p} =
    sumkronsum(ntuple(_ -> convert(LinearMap, A), Val(p))...)

Base.size(A::KroneckerSumMap, i) = prod(size.(A.maps, i))
Base.size(A::KroneckerSumMap) = (size(A, 1), size(A, 2))

LinearAlgebra.issymmetric(A::KroneckerSumMap) = all(issymmetric, A.maps)
LinearAlgebra.ishermitian(A::KroneckerSumMap) = all(ishermitian, A.maps)

LinearAlgebra.adjoint(A::KroneckerSumMap) =
    KroneckerSumMap{eltype(A)}(map(adjoint, A.maps))
LinearAlgebra.transpose(A::KroneckerSumMap) =
    KroneckerSumMap{eltype(A)}(map(transpose, A.maps))

Base.:(==)(A::KroneckerSumMap, B::KroneckerSumMap) =
    (eltype(A) == eltype(B) && all(A.maps .== B.maps))

function _unsafe_mul!(y, L::KroneckerSumMap, x::AbstractVector)
    A, B = L.maps
    a = size(A, 1)
    b = size(B, 1)
    X = reshape(x, (b, a))
    Y = reshape(y, (b, a))
    _unsafe_mul!(Y, X, transpose(A))
    _unsafe_mul!(Y, B, X, true, true)
    return y
end

using Test, LinearMaps, LinearAlgebra

function left_tester(L::LinearMap{T}) where {T}
    M, N = size(L)
    A = Matrix(L)

    x = rand(T, N)
    y = rand(T, M)

    # *
    @test y' * A ≈ y' * L
    @test (y' * A) * x ≈ y' * (L * x) # associative
    @test transpose(y) * A ≈ transpose(y) * L

    # mul!
    α = rand(T); β = rand(T)
    b1 = y' * A
    b2 = similar(b1)
    bt = copy(b1')'
    bm = Matrix(bt)
    @test mul!(b2, y', L) ≈ mul!(bt, y', L) ≈ mul!(bm, y', L)
    @test mul!(b2, y', L) === b2
    @test b1 ≈ b2 ≈ bt
    @test mul!(copy(b2), y', L, α, β) ≈ b2*β + y'A*α

    b1 = transpose(y) * A
    b2 = similar(b1)
    bt = transpose(copy(transpose(b1)))
    @test mul!(b2, transpose(y), L) ≈ mul!(bt, transpose(y), L)
    @test b1 ≈ b2 ≈ bt
    @test mul!(copy(b2), transpose(y), L, α, β) ≈ b2*β + transpose(y)*A*α

    Y = rand(T, M, 3)
    X = similar(Y, 3, N)
    Xt = copy(X')'
    @test Y'L isa LinearMap
    @test Matrix(Y'L) ≈ Y'A
    @test mul!(X, Y', L) ≈ mul!(Xt, Y', L) ≈ Y'A
    @test mul!(Xt, Y', L) === Xt
    @test mul!(copy(X), Y', L, α, β) ≈ X*β + Y'A*α
    @test mul!(X, Y', L) === X
    @test mul!(X, Y', L, α, β) === X

    @test transpose(Y)*L isa LinearMap
    @test Matrix(transpose(Y)*L) ≈ transpose(Y)*A
    @test mul!(X, transpose(Y), L) ≈ mul!(Xt, transpose(Y), L) ≈ transpose(Y)*A
    @test mul!(Xt, transpose(Y), L) === Xt
    @test mul!(copy(X), transpose(Y), L, α, β) ≈ X*β + transpose(Y)*A*α
    @test mul!(X, transpose(Y), L) === X
    @test mul!(X, transpose(Y), L, α, β) === X

    return true
end

@testset "left multiplication" begin
    T = ComplexF32
    N = 5
    L = LinearMap{T}(cumsum, reverse ∘ cumsum ∘ reverse, N)

    @test left_tester(L) # FunctionMap
    @test left_tester(adjoint(L)) # AdjointMap
    @test left_tester(transpose(L)) # TransposeMap
    @test left_tester(L'*L) # CompositeMap
    @test left_tester(2rand(T)*L) # ScaledMap
    @test left_tester(kron(L, L')) # KroneckerMap
    @test left_tester(2rand(T)*L + 3rand(T)*L') # LinearCombination
    @test left_tester([L L]) # BlockMap

    W = LinearMap(randn(T,5,4)) # WrappedMap
    @test left_tester(W)
    @test left_tester(W')
    @test left_tester(transpose(W))
    
    J = LinearMap(1.0I, 5) # UniformScalingMap
    @test left_tester(J)
end

using Test, LinearMaps, LinearAlgebra, SparseArrays

@testset "embeddedmap" begin
    m = 6; n = 5
    M = 10(1:m) .+ (1:n)'; L = LinearMap(M)
    offset = (3,4)

    BM = [zeros(offset...) zeros(offset[1], size(M,2));
        zeros(size(M,1), offset[2]) M]
    BL = @inferred LinearMap(L, size(BM); offset=offset)
    s1, s2 = size(BM)
    @test (@inferred Matrix(BL)) == BM == mul!(zero(BM), BL, 1)
    @test mul!(copy(BM), BL, 2, true, true) == 3BM
    @test (@inferred Matrix(BL')) == BM'
    @test (@inferred Matrix(transpose(BL))) == transpose(BM)

    @test_throws UndefKeywordError LinearMap(M, (10, 10))
    @test_throws ArgumentError LinearMap(M, (m, n), (0:m, 1:n))
    @test_throws ArgumentError LinearMap(M, (m, n), (0:m-1, 1:n))
    @test_throws ArgumentError LinearMap(M, (m, n), (1:m, 1:n+1))
    @test_throws ArgumentError LinearMap(M, (m, n), (1:m, 2:n+1))
    @test_throws ArgumentError LinearMap(M, (m, n), offset=(3,3))
    # @test_throws ArgumentError LinearMap(M, (m, n), (m:-1:1, 1:n))
    # @test_throws ArgumentError LinearMap(M, (m, n), (collect(m:-1:1), 1:n))
    @test size(@inferred LinearMap(M, (2m, 2n), (1:2:2m, 1:2:2n))) == (2m, 2n)
    @test @inferred !ishermitian(BL)
    @test @inferred !issymmetric(BL)
    @test @inferred LinearMap(L, size(BM), (offset[1] .+ (1:m), offset[2] .+ (1:n))) == BL
    Wc = @inferred LinearMap([2 im; -im 0]; ishermitian=true)
    Bc = @inferred LinearMap(Wc, (4,4); offset=(2,2))
    @test (@inferred ishermitian(Bc))

    x = randn(s2); X = rand(s2, 3)
    y = BM * x; Y = zeros(s1, 3)

    @test @inferred BL * x ≈ BM * x
    @test @inferred BL' * y ≈ BM' * y

    for α in (true, false, rand()),
            β in (true, false, rand()),
            t in (identity, adjoint, transpose)

        @test t(BL) * x ≈ mul!(copy(y), t(BL), x) ≈ t(BM) * x
        @test Matrix(t(BL) * X) ≈ mul!(copy(Y), t(BL), X) ≈ t(BM) * X
        y = randn(s1); Y = randn(s1, 3)
        @test (@inferred mul!(copy(y), t(BL), x, α, β)) ≈ mul!(copy(y), t(BM), x, α, β)
        @test (@inferred mul!(copy(Y), t(BL), X, α, β)) ≈ mul!(copy(Y), t(BM), X, α, β)
    end

    if VERSION >= v"1.8"
        M = rand(3,4)
        L = LinearMap(M)
        @test Matrix(reverse(L)) == reverse(M)
        for dims in (1, 2, (1,), (2,), (1, 2), (2, 1), :)
            @test Matrix(reverse(L, dims=dims)) == reverse(M, dims=dims)
        end
    end
end

using Test, LinearMaps, ChainRulesTestUtils
using ChainRulesCore: NoTangent

@testset "AD rules" begin
    x = randn(10)
    for A in (
        LinearMap(rand(10, 10)),
        LinearMap(cumsum, reverse∘cumsum∘reverse, 10),
        LinearMap((y, x) -> cumsum!(y, x), (y, x) -> reverse!(cumsum!(y, reverse!(copyto!(y, x)))), 10)
    )
        test_rrule(*, A ⊢ NoTangent(), x)
        test_rrule(A ⊢ NoTangent(), x)
        test_rrule(*, A' ⊢ NoTangent(), x)
        test_rrule(A' ⊢ NoTangent(), x)
    end
end

using Test, Documenter, LinearMaps, Aqua

@testset "code quality" begin
    Aqua.test_all(LinearMaps, piracies = (broken=true,))
end

doctest(LinearMaps)

include("linearmaps.jl")

include("transpose.jl")

include("functionmap.jl")

include("scaledmap.jl")

include("composition.jl")

include("linearcombination.jl")

include("wrappedmap.jl")

include("uniformscalingmap.jl")

include("numbertypes.jl")

include("blockmap.jl")

include("kronecker.jl")

include("conversion.jl")

include("left.jl")

include("fillmap.jl")

include("nontradaxes.jl")

include("embeddedmap.jl")

include("getindex.jl")

include("inversemap.jl")

include("rrules.jl")

include("khatrirao.jl")

include("trace.jl")

module LinearMaps

export LinearMap, FunctionMap, FillMap, InverseMap
export ⊗, squarekron, kronsum, ⊕, sumkronsum, khatrirao, facesplitting

using LinearAlgebra
using LinearAlgebra: AbstractQ
import LinearAlgebra: mul!, tr

using Base: require_one_based_indexing

abstract type LinearMap{T} end

const AbstractVecOrMatOrQ{T} = Union{AbstractVecOrMat{T}, AbstractQ{T}}
const MapOrVecOrMat{T} = Union{LinearMap{T}, AbstractVecOrMatOrQ{T}}
const MapOrMatrix{T} = Union{LinearMap{T}, AbstractMatrix{T}, AbstractQ{T}}
const TransposeAbsVecOrMat{T} = Transpose{T,<:AbstractVecOrMat}
const RealOrComplex = Union{Real, Complex}

const LinearMapTuple = Tuple{Vararg{LinearMap}}
const LinearMapVector = AbstractVector{<:LinearMap}
const LinearMapTupleOrVector = Union{LinearMapTuple,LinearMapVector}

Base.eltype(::LinearMap{T}) where {T} = T

# conversion to LinearMap
Base.convert(::Type{LinearMap}, A::LinearMap) = A
Base.convert(::Type{LinearMap}, A::AbstractVecOrMatOrQ) = LinearMap(A)

convert_to_lmaps() = ()
convert_to_lmaps(A) = (convert(LinearMap, A),)
@inline convert_to_lmaps(A, B, Cs...) =
    (convert(LinearMap, A), convert(LinearMap, B), convert_to_lmaps(Cs...)...)

abstract type MulStyle end

struct FiveArg <: MulStyle end # types admit in-place multiplication and addition
struct ThreeArg <: MulStyle end # types "only" admit in-place multiplication
struct TwoArg <: MulStyle end # types "only" admit out-of-place multiplication

MulStyle(::FiveArg, ::FiveArg) = FiveArg()
MulStyle(::FiveArg, ::ThreeArg) = ThreeArg()
MulStyle(::FiveArg, ::TwoArg) = TwoArg()
MulStyle(::ThreeArg, ::FiveArg) = ThreeArg()
MulStyle(::ThreeArg, ::ThreeArg) = ThreeArg()
MulStyle(::ThreeArg, ::TwoArg) = ThreeArg()
MulStyle(::TwoArg, ::FiveArg) = TwoArg()
MulStyle(::TwoArg, ::ThreeArg) = ThreeArg()
MulStyle(::TwoArg, ::TwoArg) = TwoArg()
MulStyle(::LinearMap) = ThreeArg() # default
MulStyle(::AbstractVecOrMat) = FiveArg()
MulStyle(::AbstractQ) = ThreeArg()
MulStyle(A::LinearMap, As::LinearMap...) = MulStyle(MulStyle(A), MulStyle(As...))

Base.isreal(A::LinearMap) = eltype(A) <: Real
LinearAlgebra.issymmetric(::LinearMap) = false # default assumptions
LinearAlgebra.ishermitian(A::LinearMap{<:Real}) = issymmetric(A)
LinearAlgebra.ishermitian(::LinearMap) = false # default assumptions
LinearAlgebra.isposdef(::LinearMap) = false # default assumptions

Base.ndims(::LinearMap) = 2
Base.size(A::LinearMap, n) =
    (n == 1 || n == 2 ? size(A)[n] : error("LinearMap objects have only 2 dimensions"))
Base.axes(A::LinearMap, n::Integer) =
    (n == 1 || n == 2 ? axes(A)[n] : error("LinearMap objects have only 2 dimensions"))
Base.length(A::LinearMap) = prod(size(A))

# check dimension consistency for multiplication A*B
_iscompatible((A, B)) = size(A, 2) == size(B, 1)
function check_dim_mul(A, B)
    _iscompatible((A, B)) ||
        throw(DimensionMismatch("second dimension of left factor, $(size(A, 2)), " *
            "does not match first dimension of right factor, $(size(B, 1))"))
    return nothing
end
# check dimension consistency for multiplication C = A*B
function check_dim_mul(C, A, B)
    mA, nA = size(A) # A always has two dimensions
    mB, nB = size(B, 1), size(B, 2)
    (mB == nA && size(C, 1) == mA && size(C, 2) == nB) ||
        throw(DimensionMismatch("A has size ($mA,$nA), B has size ($mB,$nB), C has size $(size(C))"))
    return nothing
end

_issquare(A) = size(A, 1) == size(A, 2)

_front(As::Tuple) = Base.front(As)
_front(As::AbstractVector) = @inbounds @views As[begin:end-1]
_tail(As::Tuple) = Base.tail(As)
_tail(As::AbstractVector) = @inbounds @views As[begin+1:end]

_combine(A::LinearMap, B::LinearMap) = tuple(A, B)
_combine(A::LinearMap, Bs::LinearMapTuple) = tuple(A, Bs...)
_combine(As::LinearMapTuple, B::LinearMap) = tuple(As..., B)
_combine(As::LinearMapTuple, Bs::LinearMapTuple) = tuple(As..., Bs...)
_combine(A::LinearMap, Bs::LinearMapVector) = Base.vect(A, Bs...)
_combine(As::LinearMapVector, B::LinearMap) = Base.vect(As..., B)
_combine(As::LinearMapVector, Bs::LinearMapTuple) = Base.vect(As..., Bs...)
_combine(As::LinearMapTuple, Bs::LinearMapVector) = Base.vect(As..., Bs...)
_combine(As::LinearMapVector, Bs::LinearMapVector) = Base.vect(As..., Bs...)

_reverse!(As::LinearMapTuple) = reverse(As)
_reverse!(As::LinearMapVector) = reverse!(As)

# The (internal) multiplication logic is as follows:
#  - `*(A, x)` calls `mul!(y, A, x)` for appropriately-sized y
#  - `mul!` checks consistency of the sizes, and calls `_unsafe_mul!`,
#    which does not check sizes, but potentially one-based indexing if necessary
#  - by default, `_unsafe_mul!` is redirected back to `mul!`
#  - custom map types only need to implement 3-arg (vector) `mul!`, and
#    everything else (5-arg multiplication, application to matrices,
#    conversion to matrices) will just work

"""
    *(A::LinearMap, x::AbstractVector)::AbstractVector

Compute the action of the linear map `A` on the vector `x`.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A=LinearMap([1.0 2.0; 3.0 4.0]); x=[1.0, 1.0];

julia> A*x
2-element Vector{Float64}:
 3.0
 7.0

julia> A(x)
2-element Vector{Float64}:
 3.0
 7.0
```
"""
function Base.:(*)(A::LinearMap, x::AbstractVector)
    check_dim_mul(A, x)
    T = promote_type(eltype(A), eltype(x))
    y = similar(x, T, axes(A)[1])
    return @inbounds mul!(y, A, x)
end

(L::LinearMap)(x::AbstractVector) = L*x

"""
    mul!(Y::AbstractVecOrMat, A::LinearMap, B::AbstractVector) -> Y
    mul!(Y::AbstractMatrix, A::LinearMap, B::AbstractMatrix) -> Y

Calculates the action of the linear map `A` on the vector or matrix `B` and stores the
result in `Y`, overwriting the existing value of `Y`. Note that `Y` must not be aliased
with either `A` or `B`.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A = LinearMap([1.0 2.0; 3.0 4.0]); B = ones(2); Y = similar(B); mul!(Y, A, B)
2-element Vector{Float64}:
 3.0
 7.0

julia> A = LinearMap([1.0 2.0; 3.0 4.0]); B = ones(2,2); Y = similar(B); mul!(Y, A, B)
2×2 Matrix{Float64}:
 3.0  3.0
 7.0  7.0
```
"""
@inline function mul!(y::AbstractVecOrMat, A::LinearMap, x::AbstractVector)
    @boundscheck check_dim_mul(y, A, x)
    return _unsafe_mul!(y, A, x)
end
# the following is of interest in, e.g., subspace-iteration methods
function mul!(Y::AbstractMatrix, A::LinearMap, X::AbstractMatrix)
    check_dim_mul(Y, A, X)
    return _unsafe_mul!(Y, A, X)
end

"""
    mul!(Y::AbstractMatrix, A::LinearMap, b::Number) -> Y

Scales the matrix representation of the linear map `A` by `b` and stores the result in `Y`,
overwriting the existing value of `Y`.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A = LinearMap{Int}(cumsum, 3); b = 2; Y = Matrix{Int}(undef, (3,3));

julia> mul!(Y, A, b)
3×3 Matrix{Int64}:
 2  0  0
 2  2  0
 2  2  2
```
"""
function mul!(y::AbstractVecOrMat, A::LinearMap, s::Number)
    size(y) == size(A) ||
        throw(
            DimensionMismatch("y has size $(size(y)), A has size $(size(A))."))
    return _unsafe_mul!(y, A, s)
end

"""
    mul!(C::AbstractVecOrMat, A::LinearMap, B::AbstractVector, α, β) -> C
    mul!(C::AbstractMatrix, A::LinearMap, B::AbstractMatrix, α, β) -> C

Combined inplace multiply-add ``A B α + C β``. The result is stored in `C` by overwriting
it. Note that `C` must not be aliased with either `A` or `B`.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A=LinearMap([1.0 2.0; 3.0 4.0]); B=[1.0, 1.0]; C=[1.0, 3.0];

julia> mul!(C, A, B, 100.0, 10.0) === C
true

julia> C
2-element Vector{Float64}:
 310.0
 730.0

julia> A=LinearMap([1.0 2.0; 3.0 4.0]); B=[1.0 1.0; 1.0 1.0]; C=[1.0 2.0; 3.0 4.0];

julia> mul!(C, A, B, 100.0, 10.0) === C
true

julia> C
2×2 Matrix{Float64}:
 310.0  320.0
 730.0  740.0
```
"""
function mul!(y::AbstractVecOrMat, A::LinearMap, x::AbstractVector, α::Number, β::Number)
    check_dim_mul(y, A, x)
    return _unsafe_mul!(y, A, x, α, β)
end
function mul!(Y::AbstractMatrix, A::LinearMap, X::AbstractMatrix, α::Number, β::Number)
    check_dim_mul(Y, A, X)
    return _unsafe_mul!(Y, A, X, α, β)
end

"""
    mul!(Y::AbstractMatrix, A::LinearMap, b::Number, α::Number, β::Number) -> Y

Scales the matrix representation of the linear map `A` by `b*α`, adds the result to `Y*β`
and stores the final result in `Y`, overwriting the existing value of `Y`.

## Examples
```jldoctest; setup=(using LinearAlgebra, LinearMaps)
julia> A = LinearMap{Int}(cumsum, 3); b = 2; Y = ones(Int, (3,3));

julia> mul!(Y, A, b, 2, 1)
3×3 Matrix{Int64}:
 5  1  1
 5  5  1
 5  5  5
```
"""
function mul!(y::AbstractMatrix, A::LinearMap, s::Number, α::Number, β::Number)
    size(y) == size(A) ||
        throw(
            DimensionMismatch("y has size $(size(y)), A has size $(size(A))."))
    return _unsafe_mul!(y, A, s, α, β)
end

_unsafe_mul!(y, A::MapOrVecOrMat, x) = mul!(y, A, x)
_unsafe_mul!(y, A::AbstractVecOrMat, x, α, β) = mul!(y, A, x, α, β)
_unsafe_mul!(X, Y::AbstractMatrix, A::AbstractVecOrMat) = mul!(X, Y, A)
_unsafe_mul!(X, Y::AbstractMatrix, A::AbstractVecOrMat, α, β) = mul!(X, Y, A, α, β)
_unsafe_mul!(y, A::LinearMap, x::AbstractVector, α, β) = _generic_map_mul!(y, A, x, α, β)
_unsafe_mul!(y, A::LinearMap, x::AbstractMatrix) = _generic_map_mul!(y, A, x)
_unsafe_mul!(y, A::LinearMap, x::AbstractMatrix, α, β) = _generic_map_mul!(y, A, x, α, β)
_unsafe_mul!(Y, A::LinearMap, s::Number) = _generic_map_mul!(Y, A, s)
_unsafe_mul!(Y, A::LinearMap, s::Number, α, β) = _generic_map_mul!(Y, A, s, α, β)

function _generic_map_mul!(y, A, x::AbstractVector, α, β)
    # this function needs to call mul! for, e.g.,  AdjointMap{...,<:CustomMap}
    if isone(α)
        iszero(β) && return mul!(y, A, x)
        z = A * x
        if isone(β)
            y .+= z
        else
            y .= y.*β .+ z
        end
        return y
    elseif iszero(α)
        iszero(β) && return fill!(y, zero(eltype(y)))
        isone(β) && return y
        # β != 0, 1
        return rmul!(y, β)
    else # α != 0, 1
        iszero(β) && return rmul!(mul!(y, A, x), α)
        z = A * x
        if isone(β)
            y .+= z .* α
        else
            y .= y .* β .+ z .* α
        end
        return y
    end
end
function _generic_map_mul!(Y, A, X::AbstractMatrix)
    for (Xi, Yi) in zip(eachcol(X), eachcol(Y))
        mul!(Yi, A, Xi)
    end
    return Y
end
function _generic_map_mul!(Y, A, X::AbstractMatrix, α, β)
    for (Xi, Yi) in zip(eachcol(X), eachcol(Y))
        mul!(Yi, A, Xi, α, β)
    end
    return Y
end
function _generic_map_mul!(Y, A, s::Number)
    T = promote_type(eltype(A), typeof(s))
    ax2 = axes(A)[2]
    xi = zeros(T, ax2)
    @inbounds for (i, Yi) in zip(ax2, eachcol(Y))
        xi[i] = s
        mul!(Yi, A, xi)
        xi[i] = zero(T)
    end
    return Y
end
function _generic_map_mul!(Y, A, s::Number, α, β)
    T = promote_type(eltype(A), typeof(s))
    ax2 = axes(A)[2]
    xi = zeros(T, ax2)
    @inbounds for (i, Yi) in zip(ax2, eachcol(Y))
        xi[i] = s
        mul!(Yi, A, xi, α, β)
        xi[i] = zero(T)
    end
    return Y
end

include("transpose.jl") # transposing linear maps
include("wrappedmap.jl") # wrap a matrix of linear map in a new type, thereby allowing to alter its properties
include("left.jl") # left multiplication by a matrix/transpose or adjoint vector
include("functionmap.jl") # using a function as linear map
include("uniformscalingmap.jl") # the uniform scaling map, to be able to make linear combinations of LinearMap objects and multiples of I
include("linearcombination.jl") # defining linear combinations of linear maps
include("scaledmap.jl") # multiply by a (real or complex) scalar
include("composition.jl") # composition of linear maps
include("blockmap.jl") # block linear maps
include("kronecker.jl") # Kronecker product of linear maps
include("khatrirao.jl") # Khatri-Rao and face-splitting products
include("fillmap.jl") # linear maps representing constantly filled matrices
include("embeddedmap.jl") # embedded linear maps
include("conversion.jl") # conversion of linear maps to matrices
include("show.jl") # show methods for LinearMap objects
include("getindex.jl") # getindex functionality
include("inversemap.jl")
include("trace.jl")

"""
    LinearMap(A::LinearMap; kwargs...)::WrappedMap
    LinearMap(A::AbstractVecOrMatOrQ; kwargs...)::WrappedMap
    LinearMap(J::UniformScaling, M::Int)::UniformScalingMap
    LinearMap{T=Float64}(f, [fc,], M::Int, N::Int = M; kwargs...)::FunctionMap
    LinearMap(A::MapOrVecOrMat, dims::Dims{2}, index::NTuple{2, AbstractVector{Int}})::EmbeddedMap
    LinearMap(A::MapOrVecOrMat, dims::Dims{2}; offset::Dims{2})::EmbeddedMap

Construct a linear map object, either

1. from an existing `LinearMap` or `AbstractVecOrMat`/`AbstractQ` `A`, with the purpose of
  redefining its properties via the keyword arguments `kwargs`, see below;
2. a `UniformScaling` object `J` with specified (square) dimension `M`;
3. from a function or callable object `f`;
4. from an existing `LinearMap` or `AbstractVecOrMat`/`AbstractQ` `A`, embedded in a larger
   zero map.

In the case of item 3, one also needs to specify the size of the equivalent matrix
representation `(M, N)`, i.e., for functions `f` acting on length `N` vectors and producing
length `M` vectors (with default value `N=M`). Preferably, also the `eltype` `T` of the
corresponding matrix representation needs to be specified, i.e., whether the action of `f`
on a vector will be similar to, e.g., multiplying by numbers of type `T`. If not specified,
the default value `T=Float64` will be assumed. Optionally, a corresponding function `fc`
can be specified that implements the adjoint (or transpose in the real case) of `f`.

The keyword arguments and their default values are:

* `issymmetric::Bool = false` : whether `A` or `f` act as a symmetric matrix
* `ishermitian::Bool = issymmetric & T<:Real` : whether `A` or `f` act as a Hermitian
  matrix
* `isposdef::Bool = false` : whether `A` or `f` act as a positive definite matrix.

For existing linear maps or matrices `A`, the default values will be taken by calling
internal functions `_issymmetric`, `_ishermitian` and `_isposdef` on the existing object `A`.
These in turn dispatch to (overloads of) `LinearAlgebra`'s `issymmetric`, `ishermitian`,
and `isposdef` methods whenever these checks are expected to be computationally cheap or even
known at compile time as for certain structured matrices, but return `false` for generic
`AbstractMatrix` types.

For the function-based constructor, there is one more keyword argument:
* `ismutating::Bool` : flags whether the function acts as a mutating matrix multiplication
  `f(y,x)` where the result vector `y` is the first argument (in case of `true`),
  or as a normal matrix multiplication that is called as `y=f(x)` (in case of `false`).
  The default value is guessed by looking at the number of arguments of the first
  occurrence of `f` in the method table.

For the `EmbeddedMap` constructors, `dims` specifies the total dimensions of the map. The
`index` argument specifies two collections of indices `inds1` and `inds2`, such that for
the big zero map `L` (thought of as a matrix), one has `L[inds1,inds2] == A`. In other
words, `inds1` specifies the output indices, `inds2` specifies the input indices.
Alternatively, `A` may be shifted by `offset`, such that (thinking in terms of matrices
again) `L[offset[1] .+ axes(A, 1), offset[2] .+ axes(A, 2)] == A`.
"""
LinearMap(A::MapOrVecOrMat; kwargs...) = WrappedMap(A; kwargs...)
LinearMap(J::UniformScaling, M::Int) = UniformScalingMap(J.λ, M)
LinearMap(f, M::Int; kwargs...) = LinearMap{Float64}(f, M; kwargs...)
LinearMap(f, M::Int, N::Int; kwargs...) = LinearMap{Float64}(f, M, N; kwargs...)
LinearMap(f, fc, M::Int; kwargs...) = LinearMap{Float64}(f, fc, M; kwargs...)
LinearMap(f, fc, M::Int, N::Int; kwargs...) = LinearMap{Float64}(f, fc, M, N; kwargs...)

LinearMap(A::MapOrVecOrMat, dims::Dims{2}, index::NTuple{2, AbstractVector{Int}}) =
    EmbeddedMap(convert(LinearMap, A), dims, index[1], index[2])
LinearMap(A::MapOrVecOrMat, dims::Dims{2}; offset::Dims{2}) =
    EmbeddedMap(convert(LinearMap, A), dims; offset=offset)

LinearMap{T}(A::MapOrVecOrMat; kwargs...) where {T} = WrappedMap{T}(A; kwargs...)
LinearMap{T}(f, args...; kwargs...) where {T} = FunctionMap{T}(f, args...; kwargs...)

@static if !isdefined(Base, :get_extension)
    include("../ext/LinearMapsChainRulesCoreExt.jl")
    include("../ext/LinearMapsSparseArraysExt.jl")
    include("../ext/LinearMapsStatisticsExt.jl")
end

end # module

using Test, LinearMaps, LinearAlgebra

@testset "identity/scaling map" begin
    @test_throws ArgumentError LinearMaps.UniformScalingMap(true, -1)
    m = 5
    A = 2 * rand(ComplexF64, (m, m)) .- 1
    B = rand(size(A)...)
    M = @inferred 1 * LinearMap(A)
    N = @inferred LinearMap(B)
    LC = @inferred M + N
    v = rand(ComplexF64, m)
    w = similar(v)
    Id = @inferred LinearMap(I, m)
    @test occursin("$m×$m LinearMaps.UniformScalingMap{Bool}", sprint((t, s) -> show(t, "text/plain", s), Id))
    @test_throws ErrorException LinearMaps.UniformScalingMap(1, m, 2m)
    @test_throws ErrorException LinearMaps.UniformScalingMap(1, (m, 2m))
    @test size(Id) == (m, m)
    @test @inferred isreal(Id)
    @test @inferred issymmetric(Id)
    @test @inferred ishermitian(Id)
    @test @inferred isposdef(Id)
    @test Id * v == v
    @test (2 * M' + 3 * I) * v == 2 * A'v + 3v
    @test (3 * I + 2 * M') * v ≈ 3v + 2 * A'v rtol=2eps()
    @test (2 * M' - 3 * I) * v == 2 * A'v - 3v
    @test (3 * I - 2 * M') * v ≈ 3v - 2 * A'v rtol=2eps()
    @test transpose(LinearMap(2 * M' + 3 * I)) * v ≈ transpose(2 * A' + 3 * I) * v
    @test LinearMap(2 * M' + 0I)' * v ≈ (2 * A')' * v
    for λ in (0, 1, rand()), α in (0, 1, rand()), β in (0, 1, rand()), sz in (m, (m,5))
        Λ = @inferred LinearMap(λ*I, m)
        x = rand(Float64, sz)
        y = ones(Float64, sz)
        mul!(y, Λ, x, α, β)
        @test (@allocated mul!(y, Λ, x, α, β)) == 0
        y = copy(x)
        @inferred mul!(y, Λ, x, α, β)
        @test y ≈ λ * x * α + β * x
    end
    for elty in (Float64, ComplexF64), transform in (identity, transpose, adjoint)
        λ = rand(elty)
        x = rand(m)
        J = @inferred LinearMap(LinearMaps.UniformScalingMap(λ, m))
        @test transform(J) * x == transform(λ) * x
        J = @inferred LinearMap(λ*I, m)
        @test (λ * J) * x == (J * λ) * x == (λ * λ) * x
    end
    X = rand(m, m); Y = similar(X)
    @test mul!(Y, Id, X) == X
    @test Id*X isa LinearMap
    @test X*Id isa LinearMap
    @test Matrix(Id*X) == X
    @test Matrix(X*Id) == X
    @test Matrix(Id + X) == I + X
    @test Matrix(X + Id) == X + I
end

using LinearMaps, LinearAlgebra, Test

@testset "trace" begin
    for A in (randn(5, 5), randn(ComplexF64, 5, 5))
        @test tr(LinearMap(A)) == tr(A)
        @test tr(transpose(LinearMap(A))) == tr(A)
        @test tr(adjoint(LinearMap(A))) == tr(A')
    end
    @test tr(LinearMap(3I, 10)) == 30
    @test tr(LinearMap{Int}(cumsum, 10)) == 10
    @test tr(LinearMap{Int}(cumsum, reverse∘cumsum∘reverse, 10)') == 10
    @test tr(LinearMap{Complex{Int}}(cumsum, reverse∘cumsum∘reverse, 10)') == 10
    @test tr(LinearMap{Int}(cumsum!, 10)) == 10
    @test tr(2LinearMap{Int}(cumsum!, 10)) == 20
    A = randn(3, 5); B = copy(transpose(A))
    @test tr(A ⊗ B) == tr(kron(A, B))
    @test tr(A ⊗ B ⊗ A ⊗ B) ≈ tr(kron(A, B, A, B))
    A = randn(5, 5); B = copy(transpose(A))
    @test tr(A ⊗ B) ≈ tr(kron(A, B))
    @test tr(A ⊗ B ⊗ A) ≈ tr(kron(A, B, A))
    @test tr(A ⊗ B ⊗ A ⊗ B) ≈ tr(kron(A, B, A, B))
    v = A[:,1]
    @test tr(v ⊗ v') ≈ norm(v)^2
    v = [randn(2,2) for _ in 1:3]
    @test tr(v ⊗ v') ≈ mapreduce(*, +, v, v')
    @test tr(LinearMap{Int}(cumsum!, 10) ⊕ LinearMap{Int}(cumsum!, 10)) == 200
    @test tr(FillMap(true, 5, 5)) == 5
end

using Test, LinearMaps, LinearAlgebra

@testset "scaledmap" begin
    N = 7
    A = LinearMap(cumsum, reverse ∘ cumsum ∘ reverse, N)
    AM = Matrix(A)

    # real case
    α = float(π)
    B = @inferred α * A
    @test occursin("7×7 LinearMaps.ScaledMap{Float64} with scale: $α", sprint((t, s) -> show(t, "text/plain", s), B))
    x = rand(N)

    @test @inferred size(B) == size(A)
    @test @inferred isreal(B)
    @test @inferred issymmetric(B) == issymmetric(A)
    @test @inferred ishermitian(B) == ishermitian(A)
    @test @inferred isposdef(B) == isposdef(A)
    @test @inferred transpose(B) == α * transpose(A)
    A! = LinearMap((y, x) -> cumsum!(y, x), N)
    L = 0.5A! + 0.5A! + 1.0A!
    @test LinearMaps.MulStyle(L) === LinearMaps.ThreeArg()
    L*x; y = similar(x)
    @test mul!(y, L, x) ≈ 2cumsum(x)
    LM = 0.5LinearMap(AM) + 0.5LinearMap(AM) + 1.0LinearMap(AM)
    @test LM*x ≈ 2cumsum(x)
    @test LinearMaps.MulStyle(LM) === LinearMaps.FiveArg()
    mul!(y, LM, x)
    @test (@allocated mul!(y, LM, x)) == 0

    @test B == A * α
    @test B * x == α * (A * x)
    @test @inferred Matrix(B) == α * Matrix(A)
    @test @inferred Matrix(B') == Matrix(B)'

    @test -A == (-1) * A

    @test A * (α * I) == B
    @test (α * I) * A == B

    # complex case
    β = π + 2π * im
    C = @inferred β * A
    @test_throws AssertionError LinearMaps.ScaledMap{Float64}(β, A)
    @inferred conj(β) * A' # needed in left-mul
    T = ComplexF64
    xc = rand(T, N)

    @test @inferred !isreal(C)
    @test @inferred !issymmetric(C)
    @test @inferred ishermitian(C) == ishermitian(A)
    @test @inferred !isposdef(C)
    @test @inferred transpose(C) == β * transpose(A)
    @test @inferred adjoint(C) == conj(β) * adjoint(A)
    for transform in (identity, transpose, adjoint)
        @test transform(C) * xc ≈ transform(β * AM) * xc
    end

    @test C == @inferred A * β
    @test convert(Array{T}, C * xc) ≈ β * (A * xc)
    @test @inferred Matrix(C) == β * Matrix(A)
    @test @inferred Matrix(adjoint(C)) == conj(β) * Matrix(adjoint(A))
    @test @inferred Matrix(C') == Matrix(C)'

    # composition
    BA = @inferred B*A
    @test BA isa LinearMaps.ScaledMap
    @test BA.λ == B.λ
    AB = @inferred A*B
    @test AB isa LinearMaps.ScaledMap
    @test AB.λ == B.λ
    BC = @inferred B * C
    @test BC isa LinearMaps.ScaledMap
    @test BC.λ == α * β
    @test Matrix(BC) ≈ α * β * Matrix(A) * Matrix(A)

    @test Matrix(@inferred α * BC) ≈ α * Matrix(BC)
    @test Matrix(@inferred BC * β) ≈ β * Matrix(BC)

    # in-place
    y1 = β * (A * xc)
    y2 = similar(y1)
    @test mul!(y2, C, xc) == y1

    x1 = conj(β) * (A' * y1)
    x2 = similar(x1)
    @test mul!(x2, C', y1) == x1

    # check scale*conj(scale)
    A = LinearMap{Float32}(rand(1, 2)) # rank=1 w.p.1
    B = @inferred β * A
    C = @inferred B' * B
    @test !isposdef(C)
    @test @inferred isposdef(C.λ)

    N = 2^8
    A0 = LinearMap{T}(cumsum, reverse ∘ cumsum ∘ reverse, N) # out-of-place
    forw! = cumsum!
    back! = (x, y) -> reverse!(cumsum!(x, reverse!(copyto!(x, y))))
    A1 = @inferred FunctionMap{T,true}(forw!, back!, N) # in-place
    λ = 4.2
    B0 = @inferred λ * A0
    B1 = @inferred λ * A1
    for (A, alloc) in ((A0, 1), (A1, 0), (B0, 1), (B1, 0), (A0', 3), (A1', 0), (B0', 3), (B1', 0))
        x = rand(N)
        y = similar(x)
        allocsize = @allocated similar(y)
        mul!(y, A, x)
        @test (@allocated mul!(y, A, x)) == alloc*allocsize
    end
end

using Test, LinearMaps, LinearAlgebra

@testset "KhatriRaoMap & FaceSplittingMap" begin
    for trans in (identity, complex), m in (2, 4)
        A = collect(reshape(trans(1:6), 3, 2))
        B = collect(reshape(trans(1:2m), m, 2))
        K = @inferred khatrirao(A, B)
        @test facesplitting(A', B')' === K
        M = mapreduce(kron, hcat, eachcol(A), eachcol(B))
        Mx = mapreduce((a, b) -> kron(permutedims(a), permutedims(b)), vcat, eachrow(A'), eachrow(B'))
        @test size(K) == size(M)
        @test size(@inferred adjoint(K)) == reverse(size(K))
        @test size(@inferred transpose(K)) == reverse(size(K))
        @test Matrix(K) == M
        @test Matrix(K') == Mx
        @test LinearMaps.MulStyle(K) === LinearMaps.MulStyle(K') === LinearMaps.FiveArg()
        @test (K')' === K
        @test transpose(transpose(K)) === K
        x = trans(rand(-10:10, size(K, 2)))
        y = trans(rand(-10:10, size(K, 1)))
        for α in (false, true, trans(rand(2:5))), β in (false, true, trans(rand(2:5)))
            @test mul!(copy(y), K, x, α, β) == y * β + K * x * α
            @test mul!(copy(x), K', y, α, β) == x * β + K' * y * α
        end
    end
end

struct UniformScalingMap{T} <: LinearMap{T}
    λ::T
    M::Int
    function UniformScalingMap(λ::Number, M::Int)
        M < 0 && throw(ArgumentError("size of UniformScalingMap must be non-negative, got $M"))
        return new{typeof(λ)}(λ, M)
    end
end
UniformScalingMap(λ::Number, M::Int, N::Int) =
    (M == N ?
        UniformScalingMap(λ, M) : error("UniformScalingMap needs to be square"))
UniformScalingMap(λ::T, sz::Dims{2}) where {T} =
    (sz[1] == sz[2] ?
        UniformScalingMap(λ, sz[1]) : error("UniformScalingMap needs to be square"))

MulStyle(::UniformScalingMap) = FiveArg()

# properties
Base.size(A::UniformScalingMap) = (A.M, A.M)
Base.isreal(A::UniformScalingMap) = isreal(A.λ)
LinearAlgebra.issymmetric(::UniformScalingMap) = true
LinearAlgebra.ishermitian(A::UniformScalingMap) = isreal(A)
LinearAlgebra.isposdef(A::UniformScalingMap) = isposdef(A.λ)

# comparison of UniformScalingMap objects
Base.:(==)(A::UniformScalingMap, B::UniformScalingMap) = (A.λ == B.λ && A.M == B.M)

# special transposition behavior
LinearAlgebra.transpose(A::UniformScalingMap) = A
LinearAlgebra.adjoint(A::UniformScalingMap)   = UniformScalingMap(conj(A.λ), size(A))

# multiplication with scalar
Base.:(*)(A::UniformScaling, B::LinearMap) = A.λ * B
Base.:(*)(A::LinearMap, B::UniformScaling) = A * B.λ
Base.:(*)(α::Number, J::UniformScalingMap) = UniformScalingMap(α * J.λ, size(J))
Base.:(*)(J::UniformScalingMap, α::Number) = UniformScalingMap(J.λ * α, size(J))
# needed for disambiguation
Base.:(*)(α::RealOrComplex, J::UniformScalingMap) = UniformScalingMap(α * J.λ, size(J))
Base.:(*)(J::UniformScalingMap, α::RealOrComplex) = UniformScalingMap(J.λ * α, size(J))

# multiplication with vector
Base.:(*)(J::UniformScalingMap, x::AbstractVector) =
    length(x) == J.M ? J.λ * x : throw(DimensionMismatch("*"))
# multiplication with matrix
Base.:(*)(J::UniformScalingMap, B::Union{AbstractMatrix,AbstractQ}) =
    size(B, 1) == J.M ? J.λ * LinearMap(B) : throw(DimensionMismatch("*"))
Base.:(*)(A::Union{AbstractMatrix,AbstractQ}, J::UniformScalingMap) =
    size(A, 2) == J.M ? LinearMap(A) * J.λ : throw(DimensionMismatch("*"))
# disambiguation
Base.:(*)(xc::LinearAlgebra.AdjointAbsVec, J::UniformScalingMap) = xc * J.λ
Base.:(*)(xt::LinearAlgebra.TransposeAbsVec, J::UniformScalingMap) = xt * J.λ

# multiplication with vector/matrix
for In in (AbstractVector, AbstractMatrix)
    @eval begin
        _unsafe_mul!(y, J::UniformScalingMap, x::$In) = _scaling!(y, J.λ, x, true, false)
        _unsafe_mul!(y, J::UniformScalingMap{<:RealOrComplex}, x::$In{<:RealOrComplex},
                    α::RealOrComplex, β) = _scaling!(y, J.λ * α, x, true, β)
        _unsafe_mul!(y, J::UniformScalingMap, x::$In, α, β) = _scaling!(y, J.λ, x, α, β)
    end
end

function _unsafe_mul!(M, L::UniformScalingMap, s::Number, α=true, β=false)
    LinearAlgebra._rmul_or_fill!(M, β)
    c = L.λ * s * α
    for (i,j) in zip(axes(L)...)
        M[i,j] += c
    end
    return M
end

function _scaling!(y, λ, x, α, β)
    if isone(α) && isone(λ)
        iszero(β) && return copyto!(y, x)
        isone(β) && return y .+= x
        return y .= y .* β .+ x
    elseif (iszero(α) || iszero(λ))
        iszero(β) && return fill!(y, zero(eltype(y)))
        isone(β) && return y
        return rmul!(y, β)
    elseif isone(α)
        iszero(β) && return y .= λ .* x
        isone(β) && return y .+= λ .* x
        return y .= y .* β .+ λ .* x
    elseif isone(λ)
        iszero(β) && return y .= x .* α
        isone(β) && return y .+= x .* α
        return y .= y .* β .+ x .* α
    else
        iszero(β) && return y .= λ .* x .* α
        isone(β) && return y .+= λ .* x .* α
        return y .= y .* β .+ λ .* x .* α
    end
end

# combine LinearMap and UniformScaling objects in linear combinations
Base.:(+)(A₁::LinearMap, A₂::UniformScaling) = A₁ + UniformScalingMap(A₂.λ, size(A₁, 1))
Base.:(+)(A₁::UniformScaling, A₂::LinearMap) = UniformScalingMap(A₁.λ, size(A₂, 1)) + A₂
Base.:(-)(A₁::LinearMap, A₂::UniformScaling) = A₁ - UniformScalingMap(A₂.λ, size(A₁, 1))
Base.:(-)(A₁::UniformScaling, A₂::LinearMap) = UniformScalingMap(A₁.λ, size(A₂, 1)) - A₂

struct KhatriRaoMap{T,A<:Tuple{MapOrVecOrMat,MapOrVecOrMat}} <: LinearMap{T}
    maps::A
    function KhatriRaoMap{T,As}(maps::As) where {T,As<:Tuple{MapOrVecOrMat,MapOrVecOrMat}}
        @assert promote_type(T, map(eltype, maps)...) == T  "eltype $(eltype(A)) cannot be promoted to $T in KhatriRaoMap constructor"
        @inbounds size(maps[1], 2) == size(maps[2], 2) || throw(ArgumentError("matrices need equal number of columns"))
        new{T,As}(maps)
    end
end
KhatriRaoMap{T}(maps::As) where {T, As} = KhatriRaoMap{T, As}(maps)

"""
    khatrirao(A::MapOrVecOrMat, B::MapOrVecOrMat) -> KhatriRaoMap

Construct a lazy representation of the Khatri-Rao (or column-wise Kronecker) product of two
maps or arrays `A` and `B`. For the application to vectors, the transpose action of `A` on
vectors needs to be defined.
"""
khatrirao(A::MapOrVecOrMat, B::MapOrVecOrMat) =
    KhatriRaoMap{Base.promote_op(*, eltype(A), eltype(B))}((A, B))

struct FaceSplittingMap{T,A<:Tuple{AbstractMatrix,AbstractMatrix}} <: LinearMap{T}
    maps::A
    function FaceSplittingMap{T,As}(maps::As) where {T,As<:Tuple{AbstractMatrix,AbstractMatrix}}
        @assert promote_type(T, map(eltype, maps)...) == T  "eltype $(eltype(A)) cannot be promoted to $T in KhatriRaoMap constructor"
        @inbounds size(maps[1], 1) == size(maps[2], 1) || throw(ArgumentError("matrices need equal number of columns, got $(size(maps[1], 1)) and $(size(maps[2], 1))"))
        new{T,As}(maps)
    end
end
FaceSplittingMap{T}(maps::As) where {T, As} = FaceSplittingMap{T, As}(maps)

"""
    facesplitting(A::AbstractMatrix, B::AbstractMatrix) -> FaceSplittingMap

Construct a lazy representation of the face-splitting (or row-wise Kronecker) product of
two matrices `A` and `B`.
"""
facesplitting(A::AbstractMatrix, B::AbstractMatrix) =
    FaceSplittingMap{Base.promote_op(*, eltype(A), eltype(B))}((A, B))

Base.size(K::KhatriRaoMap) = ((A, B) = K.maps; (size(A, 1) * size(B, 1), size(A, 2)))
Base.size(K::FaceSplittingMap) = ((A, B) = K.maps; (size(A, 1), size(A, 2) * size(B, 2)))
Base.adjoint(K::KhatriRaoMap) = facesplitting(map(adjoint, K.maps)...)
Base.adjoint(K::FaceSplittingMap) = khatrirao(map(adjoint, K.maps)...)
Base.transpose(K::KhatriRaoMap) = facesplitting(map(transpose, K.maps)...)
Base.transpose(K::FaceSplittingMap) = khatrirao(map(transpose, K.maps)...)

LinearMaps.MulStyle(::Union{KhatriRaoMap,FaceSplittingMap}) = FiveArg()

function _unsafe_mul!(y, K::KhatriRaoMap, x::AbstractVector)
    A, B = K.maps
    Y = reshape(y, (size(B, 1), size(A, 1)))
    if size(B, 1) <= size(A, 1)
        mul!(Y, convert(Matrix, B * Diagonal(x)), transpose(A))
    else
        mul!(Y, B, transpose(convert(Matrix, A * transpose(Diagonal(x)))))
    end
    return y
end
function _unsafe_mul!(y, K::KhatriRaoMap, x::AbstractVector, α, β)
    A, B = K.maps
    Y = reshape(y, (size(B, 1), size(A, 1)))
    if size(B, 1) <= size(A, 1)
        mul!(Y, convert(Matrix, B * Diagonal(x)), transpose(A), α, β)
    else
        mul!(Y, B, transpose(convert(Matrix, A * transpose(Diagonal(x)))), α, β)
    end
    return y
end

function _unsafe_mul!(y, K::FaceSplittingMap, x::AbstractVector)
    A, B = K.maps
    @inbounds for m in eachindex(y)
        y[m] = zero(eltype(y))
        l = firstindex(x)
        for i in axes(A, 2)
            ai = A[m,i]
            @simd for k in axes(B, 2)
                y[m] += ai*B[m,k]*x[l]
                l += 1
            end
        end
    end
    return y
end
function _unsafe_mul!(y, K::FaceSplittingMap, x::AbstractVector, α, β)
    A, B = K.maps
    @inbounds for m in eachindex(y)
        y[m] *= β
        l = firstindex(x)
        for i in axes(A, 2)
            ai = A[m,i]
            @simd for k in axes(B, 2)
                y[m] += ai*B[m,k]*x[l]*α
                l += 1
            end
        end
    end
    return y
end

using Test, LinearMaps, LinearAlgebra, SparseArrays, Statistics
using LinearMaps: FiveArg, LinearMapTuple, LinearMapVector, FunctionMap

@testset "linear combinations" begin
    CR  = FunctionMap{Float64}(cumsum, reverse∘cumsum∘reverse, 10, 10)
    CS  = FunctionMap{ComplexF64}(cumsum, reverse∘cumsum∘reverse, 10, 10)
    CS! = LinearMap{ComplexF64}(cumsum!,
                                (y, x) -> (copyto!(y, x); reverse!(cumsum!(y, reverse!(y)))), 10;
                                ismutating=true)
    v = rand(ComplexF64, 10)
    u = similar(v)
    mul!(u, CS!, v)
    @test (@allocated mul!(u, CS!, v)) == 0
    n = 10
    alloc = @allocated similar(v)
    Loop = @inferred CS + CS + CS
    @test Loop * v ≈ 3cumsum(v)
    @test (CS + CR + CS) * v ≈ 3cumsum(v)
    @test (@allocated Loop * v) <= 3alloc
    Loop = @inferred CS + CS; Loop * v
    @test (@allocated Loop * v) <= 2alloc
    Lmix = @inferred CS + CS + CS!; Lmix * v
    @test (@allocated Lmix * v) <= 3alloc
    Lmix = @inferred CS + CS + CS!; Lmix * v
    @test (@allocated Lmix * v) <= 3alloc
    Lmix = @inferred CS! + (CS + CS); Lmix * v
    @test (@allocated Lmix * v) <= 3alloc
    L = @inferred sum(ntuple(_ -> CS!, n))
    @test (@inferred sum(L.maps::LinearMapTuple)) == L
    Lv = @inferred LinearMaps.LinearCombination{ComplexF64}(fill(CS!, n))
    @test (@inferred sum(Lv.maps::LinearMapVector)) == Lv
    @test isa((@inferred mean(Lv.maps)),
        LinearMaps.ScaledMap{ComplexF64,Float64,<:LinearMaps.LinearCombination{ComplexF64,<:LinearMapVector}})
    @test (@inferred mean(L.maps)) == (@inferred mean(Lv.maps)) == (@inferred sum(Lv.maps))/n
    @test (@inferred mean(L)) == (@inferred mean(Lv))
    @test (@inferred mean(x -> x*x, L.maps)) == (@inferred sum(x -> x*x, L.maps))/n
    @test mean(x -> x*x, Lv.maps) == (sum(x -> x*x, Lv.maps))/n
    @test L == Lv
    A = LinearMap(randn(eltype(CS!), size(CS!)))
    Ar = LinearMap(real(A.lmap))
    @test isa((@inferred sum([CS!, A])),
        LinearMaps.LinearCombination{<:ComplexF64,<:LinearMapVector})
    @test (@inferred mean([CS!, A])) == (@inferred sum([CS!, A]))/2
    @test (@inferred mean([CS!, A])) == (@inferred mean(identity, [CS!, A])) == (@inferred sum([CS!, A]))/2
    @test isa(sum([CS!, Ar]), LinearMaps.LinearCombination{<:ComplexF64,<:LinearMapVector})
    @test sum([CS!, Ar])/2 == mean([CS!, Ar])
    @test sum([CS!, Ar]) == sum(identity, [CS!, Ar])
    for sum1 in (CS!, L, Lv), sum2 in (CS!, L, Lv)
        m1 = sum1 == CS! ? 1 : 10
        m2 = sum2 == CS! ? 1 : 10
        vect = any(x -> isa(x, LinearMaps.LinearCombination{ComplexF64,<:LinearMapVector}), (sum1, sum2))
        maptyp = vect ? LinearMapVector : LinearMapTuple
        @test (sum1+sum2) isa LinearMaps.LinearCombination{ComplexF64,<:maptyp}
        @test (sum1+sum2) * v ≈ (m1+m2)*cumsum(v)
    end
    M, Mv = Matrix.((L, Lv))
    @test M == Mv == LowerTriangular(fill(n, size(L)))
    @test_throws AssertionError LinearMaps.LinearCombination{Float64}((CS!, CS!))
    @test occursin("10×10 $LinearMaps.LinearCombination{$(eltype(L))}", sprint((t, s) -> show(t, "text/plain", s), L))
    @test occursin("10×10 $LinearMaps.LinearCombination{$(eltype(L))}", sprint((t, s) -> show(t, "text/plain", s), L+CS!))
    @test mul!(u, L, v) ≈ n * cumsum(v)
    @test mul!(u, Lv, v) ≈ n * cumsum(v)
    alloc = @allocated similar(u)
    mul!(u, L, v, 2, 2)
    @test (@allocated mul!(u, L, v, 2, 2)) <= alloc
    mul!(u, Lv, v, 2, 2)
    @test (@allocated mul!(u, Lv, v, 2, 2)) <= alloc
    for α in (false, true, rand(ComplexF64)), β in (false, true, rand(ComplexF64))
        for transform in (identity, adjoint, transpose)
            @test mul!(copy(u), transform(L), v, α, β) ≈ transform(M)*v*α + u*β
        end
    end
    V = rand(ComplexF64, 10, 3)
    U = similar(V)
    @test mul!(U, L, V) ≈ n*cumsum(V, dims=1)
    @test mul!(U, LinearMap(L), V) ≈ n*cumsum(V, dims=1)

    A = randn(3,3)
    B = LinearMap(A) + LinearMap(A)'
    C = LinearMap(copy(A)) + LinearMap(copy(A))'
    @test_throws DimensionMismatch A + CS!
    @test B == C

    A = 2 * rand(ComplexF64, (10, 10)) .- 1
    B = rand(ComplexF64, size(A)...)
    M = @inferred LinearMap(A)
    N = @inferred LinearMap(B)
    @test @inferred(LinearMaps.MulStyle(M)) === FiveArg()
    @test @inferred(LinearMaps.MulStyle(N)) === FiveArg()
    LC = @inferred M + N
    @test @inferred(LinearMaps.MulStyle(LC)) === FiveArg()
    @test @inferred(LinearMaps.MulStyle(LC + I)) === FiveArg()
    @test @inferred(LinearMaps.MulStyle(LC + 2.0*I)) === FiveArg()
    @test sparse(LC) == Matrix(LC) == A+B
    v = rand(ComplexF64, 10)
    w = similar(v)
    mul!(w, M, v)
    @test (@allocated mul!(w, M, v)) == 0
    mul!(w, LC, v)
    @test (@allocated mul!(w, LC, v)) == 0
    for α in (false, true, rand(ComplexF64)), β in (false, true, rand(ComplexF64))
        y = rand(ComplexF64, size(v))
        MC = Matrix(LC)
        @test mul!(copy(y), LC, v, α, β) ≈ MC*v*α + y*β
        @test mul!(copy(y), LC+I, v, α, β) ≈ (MC+I)*v*α + y*β
        @test mul!(copy(y), I+LC, v, α, β) ≈ (I+MC)*v*α + y*β
        @test (@allocated mul!(w, LC, v, α, β)) == 0
        ILC = I + LC
        @test (@allocated mul!(w, ILC, v, α, β)) == 0
        LCI = LC + I
        @test (@allocated mul!(w, LCI, v, α, β)) == 0
    end
    # @test_throws ErrorException LinearMaps.LinearCombination{ComplexF64}((M, N), (1, 2, 3))
    @test @inferred size(3M + 2.0N) == size(A)
    # addition
    @test @inferred convert(Matrix, LC) == A + B
    @test @inferred convert(Matrix, LC + LC) ≈ 2A + 2B
    @test @inferred convert(Matrix, M + LC) ≈ 2A + B
    @test @inferred convert(Matrix, M + M) ≈ 2A
    # subtraction
    @test (@inferred Matrix(LC - LC)) ≈ zeros(eltype(LC), size(LC)) atol=10eps()
    @test (@inferred Matrix(LC - M)) ≈ B
    @test (@inferred Matrix(N - LC)) ≈ -A
    @test (@inferred Matrix(M - M)) ≈ zeros(size(M)) atol=10eps()
    # scalar multiplication
    @test @inferred Matrix(-M) == -A
    @test @inferred Matrix(-LC) == -A - B
    @test @inferred Matrix(3 * M) == 3 * A
    @test @inferred Matrix(M * 3) == 3 * A
    @test Matrix(3.0 * LC) ≈ Matrix(LC * 3) ≈ 3A + 3B
    @test @inferred Matrix(3 \ M) ≈ A/3
    @test @inferred Matrix(M / 3) ≈ A/3
    @test @inferred Matrix(3 \ LC) ≈ (A + B) / 3
    @test @inferred Matrix(LC / 3) ≈ (A + B) / 3
    @test @inferred Array(3 * M' - CS!) == 3 * A' - Array(CS!)
    @test (3M - 1im*CS!)' == (3M + ((-1im)*CS!))' == M'*3 + CS!'*1im
    @test @inferred Array(M + A) == 2 * A
    @test @inferred Array(A + M) == 2 * A
    @test @inferred Array(M - A) == 0 * A
    @test Array(A - M) == 0 * A
end

"""
    FillMap(λ, (m, n))::FillMap
    FillMap(λ, m, n)::FillMap

Construct a (lazy) representation of an operator whose matrix representation
would be an m×n-matrix filled constantly with the value `λ`.
"""
struct FillMap{T} <: LinearMap{T}
    λ::T
    size::Dims{2}
    function FillMap(λ::T, dims::Dims{2}) where {T}
        (dims[1]>=0 && dims[2]>=0) || throw(ArgumentError("dims of FillMap must be non-negative"))
        return new{T}(λ, dims)
    end
end

FillMap(λ, m::Int, n::Int) = FillMap(λ, (m, n))

# properties
Base.size(A::FillMap) = A.size
MulStyle(::FillMap) = FiveArg()
LinearAlgebra.issymmetric(A::FillMap) = A.size[1] == A.size[2]
LinearAlgebra.ishermitian(A::FillMap) = isreal(A.λ) && A.size[1] == A.size[2]
LinearAlgebra.isposdef(A::FillMap) = (size(A, 1) == size(A, 2) == 1 && isposdef(A.λ))
Base.:(==)(A::FillMap, B::FillMap) = A.λ == B.λ && A.size == B.size

LinearAlgebra.adjoint(A::FillMap) = FillMap(adjoint(A.λ), reverse(A.size))
LinearAlgebra.transpose(A::FillMap) = FillMap(transpose(A.λ), reverse(A.size))

function _unsafe_mul!(y, A::FillMap, x::AbstractVector)
    return fill!(y, iszero(A.λ) ? zero(eltype(y)) : A.λ*sum(x))
end

_unsafe_mul!(Y, A::FillMap, x::Number) = fill!(Y, A.λ*x)
function _unsafe_mul!(Y, A::FillMap, x::Number, α, β)
    LinearAlgebra._rmul_or_fill!(Y, β)
    Y .+= A.λ*x*α
    return Y
end

function _unsafe_mul!(y, A::FillMap, x::AbstractVector, α, β)
    if iszero(α)
        !isone(β) && rmul!(y, β)
    else
        temp = A.λ * sum(x) * α
        if iszero(β)
            y .= temp
        elseif isone(β)
            y .+= temp
        else
            y .= y .* β .+ temp
        end
    end
    return y
end

Base.:(+)(A::FillMap, B::FillMap) = A.size == B.size ? FillMap(A.λ + B.λ, A.size) : throw(DimensionMismatch())
Base.:(-)(A::FillMap) = FillMap(-A.λ, A.size)
Base.:(*)(λ::Number, A::FillMap) = FillMap(λ * A.λ, size(A))
Base.:(*)(A::FillMap, λ::Number) = FillMap(A.λ * λ, size(A))
Base.:(*)(λ::RealOrComplex, A::FillMap) = FillMap(λ * A.λ, size(A))
Base.:(*)(A::FillMap, λ::RealOrComplex) = FillMap(A.λ * λ, size(A))

function Base.:(*)(A::FillMap, B::FillMap)
    check_dim_mul(A, B)
    return FillMap(A.λ*B.λ*size(A, 2), (size(A, 1), size(B, 2)))
end

using Test, LinearMaps, LinearAlgebra, SparseArrays

@testset "Kronecker products and sums" begin
    @testset "Kronecker product" begin
        A = rand(ComplexF64, 3, 3)
        B = rand(ComplexF64, 2, 2)
        K = kron(A, B)
        LA = LinearMap(A)
        LB = LinearMap(B)
        LK = @inferred kron(LA, LB)
        LKv = @inferred LinearMaps.KroneckerMap{ComplexF64}([LA, LB])
        @test LK * ones(6) ≈ LKv * ones(6)
        @test Matrix(LK) ≈ K
        @test LKv.maps isa Vector
        LKv = LinearMaps.KroneckerMap{ComplexF64}([LA, LB, LA])
        @test kron(A, B, A) * ones(18) ≈ LKv * ones(18)
        @test kron(LA, 2LB) isa LinearMaps.ScaledMap
        @test kron(3LA, LB) isa LinearMaps.ScaledMap
        @test kron(3LA, 2LB) isa LinearMaps.ScaledMap
        @test kron(3LA, 2LB).λ == 6
        @test kron(kron(LA, LA), 2LB) isa LinearMaps.ScaledMap
        @test kron(3LA, kron(LB, LB)) isa LinearMaps.ScaledMap
        @test_throws ErrorException LinearMaps.KroneckerMap{Float64}((LA, LB))
        @test occursin("6×6 LinearMaps.KroneckerMap{$(eltype(LK))}", sprint((t, s) -> show(t, "text/plain", s), LK))
        @test @inferred size(LK) == size(K)
        @test LinearMaps.MulStyle(LK) === LinearMaps.ThreeArg()
        for i in (1, 2)
            @test @inferred size(LK, i) == size(K, i)
        end
        C = randn(3, 4); D = randn(6, 5); v = ones(size(C, 2) * size(D, 2))
        for (L, M) in (
            (kron(LinearMap(C), D), kron(C, D)),
            (kron(LinearMap(LinearMap(C)), D), kron(C, D)),
            (kron(LinearMap(D), C), kron(D, C)),
            (kron(LinearMap(LinearMap(D)), C), kron(D, C))
            )
            @test Matrix(L) ≈ M
            @test L * v ≈ M * v
        end
        L = ones(3) ⊗ (b = rand(ComplexF64, 4))
        @test L * [2] ≈ kron(ones(3), b) * 2
        @test Matrix(L) ≈ kron(ones(3), b) rtol=2eps(Float64)
        L = ones(3) ⊗ ones(ComplexF64, 4)'
        v = rand(4)
        @test Matrix(L) == ones(3,4)
        @test L*v ≈ fill(sum(v), 3)

        for transform in (identity, transpose, adjoint)
            @test Matrix(transform(LK)) ≈ transform(Matrix(LK)) ≈ transform(K)
            @test Matrix(kron(transform(LA), transform(LB))) ≈ transform(K)
            @test Matrix(transform(LinearMap(LK))) ≈ transform(Matrix(LK)) ≈ transform(K)
        end
        @test kron(LA, kron(LA, B)) == kron(LA, LA, LB)
        @test kron(kron(LA, LB), kron(LA, LB)) == kron(LA, LB, LA, LB) == ⊗(LA, LB, LA, LB)
        @test kron(A, A, A) ≈ Matrix(@inferred kron(LA, LA, LA)) ≈ Matrix(@inferred LA^⊗(3)) ≈ Matrix(@inferred A^⊗(3))
        LAs = LinearMap(sparse(A))
        K = @inferred kron(A, A, A, LAs)
        VERSION > v"1.7" && @inferred squarekron(A, A, LAs)
        K2 = squarekron(A, A, A, LAs)
        @test K isa LinearMaps.KroneckerMap
        @test Matrix(K) ≈ Matrix(K2) ≈ kron(A, A, A, A)
        @test convert(AbstractMatrix, K) isa SparseMatrixCSC
        @test convert(AbstractMatrix, K) ≈ kron(A, A, A, A)
        @test sparse(K) ≈ kron(A, A, A, A)
        @test Matrix(@inferred K*K) ≈ kron(A, A, A, A)*kron(A, A, A, A)
        K4 = @inferred kron(A, B, B, LB)
        # check that matrices don't get Kronecker-multiplied, but that everything is lazy
        @test K4.maps[1].lmap === A
        @test @inferred kron(LA, LB)' == @inferred kron(LA', LB')
        @test (@inferred kron(LA, B)) == (@inferred kron(LA, LB)) == (@inferred kron(A, LB))
        @test @inferred ishermitian(kron(LA'LA, LB'LB))
        A = rand(2, 5); B = rand(4, 2)
        K = @inferred kron(A, LinearMap(B))
        v = rand(size(K, 2))
        @test K*v ≈ kron(A, B)*v
        @test Matrix(K) ≈ kron(A, B)
        K = @inferred kron(LinearMap(B), A)
        v = rand(size(K, 2))
        @test K*v ≈ kron(B, A)*v
        @test Matrix(K) ≈ kron(B, A)
        A = rand(3, 3); B = rand(2, 2); LA = LinearMap(A); LB = LinearMap(B)
        @test @inferred issymmetric(kron(LA'LA, LB'LB))
        @test @inferred ishermitian(kron(LA'LA, LB'LB))
        # use mixed-product rule
        K = kron(LA, LB) * kron(LA, LB) * kron(LA, LB)
        Kv = LinearMaps.CompositeMap{ComplexF64}(fill(LA ⊗ LB, 3))
        @test kron(A, B)^3 * ones(6) ≈ Kv * ones(6)
        @test Matrix(K) ≈ kron(A, B)^3
        A = [0 1; 0 0]
        B = [0 0; 1 0]
        J = LinearMap(I, 1)
        @test Matrix(kron(J, A*B)) == Matrix(kron(J, A) * kron(J, B))
        # example that doesn't use mixed-product rule
        A = rand(3, 2); B = rand(2, 3)
        K = @inferred kron(A, LinearMap(B))
        @test Matrix(@inferred K*K) ≈ kron(A, B)*kron(A, B)
        A = rand(3, 2); B = rand(4, 3)
        @test Matrix(kron(LinearMap(A), B, [A A])*kron(LinearMap(A), B, A')) ≈ kron(A, B, [A A])*kron(A, B, A')

        m = 3
        A = rand(m, m)
        F = LinearMap(x -> A*x, m, m)
        S = sparse(I, m, m)
        J = LinearMap(I, m)
        @test kron(J, J) == LinearMap(I, m*m)
        v = rand(m^3)
        for (K, M) in ((⊗(A, J, J), kron(A, S, S)),
                       (⊗(J, A, J), kron(S, A, S)),
                       (⊗(J, J, A), kron(S, S, A)),
                       (⊗(F, J, J), kron(A, S, S)),
                       (⊗(J, F, J), kron(S, A, S)),
                       (⊗(J, J, F), kron(S, S, A)))
            @test K * v ≈ M * v
            @test Matrix(K) ≈ M
        end
    end

    @testset "Kronecker sum" begin
        A = rand(Float64, 3, 3)
        B = rand(Float64, 2, 2)
        LA = LinearMap(A)
        LB = LinearMap(B)
        KS = @inferred kronsum(LA, B)
        KS2 = @inferred sumkronsum(LA, B)
        @test occursin("6×6 LinearMaps.KroneckerSumMap{Float64}", sprint((t, s) -> show(t, "text/plain", s), KS))
        @test_throws ArgumentError kronsum(LA, [B B]) # non-square map
        KSmat = kron(A, Matrix(I, 2, 2)) + kron(Matrix(I, 3, 3), B)
        @test Matrix(KS) ≈ Matrix(KS2) ≈ Matrix(kron(A, LinearMap(I, 2)) + kron(LinearMap(I, 3), B))
        v = ones(size(KS, 2))
        @test KS * v ≈ KS2 * v ≈ KSmat * v
        @test size(KS) == size(kron(A, Matrix(I, 2, 2)))
        for transform in (identity, transpose, adjoint)
            @test Matrix(transform(KS)) ≈ transform(Matrix(KS)) ≈ transform(KSmat)
            @test Matrix(kronsum(transform(LA), transform(LB))) ≈ transform(KSmat)
            @test Matrix(transform(LinearMap(kronsum(LA, LB)))) ≈ Matrix(transform(KS)) ≈ transform(KSmat)
        end
        @test @inferred(kronsum(A, A, LB)) == @inferred(⊕(A, A, B))
        @test Matrix(@inferred LA^⊕(2)) == Matrix(@inferred A^⊕(2)) ≈ Matrix(kronsum(LA, A))
        @test Matrix(@inferred LA^⊕(3)) == Matrix(@inferred A^⊕(3)) ≈ Matrix(kronsum(LA, A, A))
        @test @inferred(kronsum(LA, LA, LB)) == @inferred(kronsum(LA, kronsum(LA, LB))) == @inferred(kronsum(A, A, B))
        @test Matrix(@inferred kronsum(A, B, A, B, A, B)) ≈ Matrix(@inferred kronsum(LA, LB, LA, LB, LA, LB))
        T = typeof(kron(Diagonal(rand(3)), sprand(3, 3, 0.3)))
        @test convert(AbstractMatrix, kronsum(sparse(A), sparse(B), sparse(A))) isa T
        @test convert(AbstractMatrix, kronsum(A, B, A)) == Matrix(kronsum(A, B, A))
        @test sparse(kronsum(sparse(A), B, A)) == Matrix(kronsum(sparse(A), B, A))
    end
end

using Test, LinearMaps, LinearAlgebra, SparseArrays
using LinearMaps: LinearMapVector, LinearMapTuple

@testset "composition" begin
    F = @inferred FunctionMap{Float64,false}(cumsum, reverse ∘ cumsum ∘ reverse, 10)
    @test F == LinearMap(cumsum, reverse ∘ cumsum ∘ reverse, 10; ismutating=false)
    FC = LinearMap{ComplexF64}(cumsum, reverse ∘ cumsum ∘ reverse, 10; ismutating=false)
    FCM = @inferred LinearMaps.CompositeMap{ComplexF64}((FC,))
    FCMv = @inferred LinearMaps.CompositeMap{ComplexF64}([FC,])
    FCiip = LinearMaps.CompositeMap{ComplexF64}((LinearMap{ComplexF64}(cumsum!, 10),))
    FCiipv = LinearMaps.CompositeMap{ComplexF64}([LinearMap{ComplexF64}(cumsum!, 10),])
    FCM2v = @inferred LinearMaps.CompositeMap{ComplexF64}([FC, FC])
    FCM2iipv = @inferred LinearMaps.CompositeMap{ComplexF64}([FCiip, FCiip])
    L = LowerTriangular(ones(10,10))
    @test_throws DimensionMismatch F * LinearMap(zeros(2,2))
    @test_throws ErrorException LinearMaps.CompositeMap{Float64}((FC, LinearMap(rand(10,10))))
    A = 2 * rand(ComplexF64, (10, 10)) .- 1
    B = rand(size(A)...)
    H = LinearMap(Hermitian(A'A))
    S = LinearMap(Symmetric(real(A)'real(A)))
    M = @inferred 1 * LinearMap(A)
    N = @inferred LinearMap(B)
    v = rand(ComplexF64, 10)
    α = rand(ComplexF64)
    @test FCiip * v == FCM * v == F * v == FCMv * v == FCiipv * v
    @test FCM2v * v == F * F * v == FCM2iipv * v
    @test mul!(zero([v v]), FCM, [v v]) == [F*v F*v]
    @test @inferred (F * F) * v == @inferred F * (F * v)
    @test @inferred (F * A) * v == @inferred F * (A * v)
    @test LinearMaps._compositemul!(zero(F * A * v), F * A, v, zero(A*v)) ≈ (F * A) * v
    @test @inferred (A * F) * v == @inferred A * (F * v)
    @test @inferred A * (F * F) * v == @inferred A * (F * (F * v))
    F2 = F*F
    FC2 = FC*FC
    F4 = FC2 * F2
    F4v = @inferred LinearMaps.CompositeMap{ComplexF64}([FC2, F2])
    @test occursin("10×10 LinearMaps.CompositeMap{$(eltype(F4))}", sprint((t, s) -> show(t, "text/plain", s), F4))
    @test length(F4.maps) == 4
    @test (@inferred F4 * v) == F4v * v == (@inferred F * (F * (F * (F * v))))
    @test @inferred Matrix(M * transpose(M)) ≈ A * transpose(A)
    @test @inferred !isposdef(M * transpose(M))
    @test @inferred isposdef(LinearMap(M * M', isposdef=true))
    @test @inferred issymmetric(N * N')
    @test @inferred ishermitian(N * N')
    @test @inferred !issymmetric(M' * M)
    @test @inferred ishermitian(M' * M)
    @test @inferred issymmetric(F'F)
    @test @inferred issymmetric(F'*S*F)
    @test @inferred ishermitian(F'F)
    @test @inferred ishermitian(LinearMaps.CompositeMap{ComplexF64}([F, F']))
    @test @inferred ishermitian(F'*H*F)
    @test @inferred ishermitian(LinearMaps.CompositeMap{ComplexF64}([F, H, F']))
    @test @inferred !issymmetric(FC'FC)
    @test @inferred ishermitian(FC'FC)
    @test @inferred ishermitian(FC'*H*FC)
    @test @inferred issymmetric(transpose(F) * F * 3)
    @test @inferred issymmetric(transpose(F) * 3 * F)
    @test @inferred !isposdef(-5*transpose(F) * F)
    @test @inferred ishermitian((M * F)' * M * 4 * F)
    @test @inferred transpose(M * F) == @inferred transpose(F) * transpose(M)
    @test @inferred (4*((-3*M)*2)) == @inferred -12M*2
    @test @inferred (4*((3*(-M))*2)*(-5)) == @inferred -12M*(-10)
    L = @inferred 3 * F + 1im * A + F * M' * F
    LF = 3 * Matrix(F) + 1im * A + Matrix(F) * Matrix(M)' * Matrix(F)
    @test Array(L) ≈ LF
    R1 = rand(ComplexF64, 10, 10); L1 = LinearMap(R1)
    R2 = rand(ComplexF64, 10, 10); L2 = LinearMap(R2)
    R3 = rand(ComplexF64, 10, 10); L3 = LinearMap(R3)
    CompositeR = *(R1, R2, R3)
    CompositeL = prod(LinearMap, [R1, R2, R3])
    @test prod([L1, L2, LinearMap(randn(10, 10))]) isa LinearMaps.CompositeMap{ComplexF64,<:LinearMapVector}
    @test (@inferred prod([L1, L2, L3])) isa LinearMaps.CompositeMap{<:Any,<:LinearMapVector}
    @test prod([L1, L2, L3]) == (@inferred L1 * prod([L2, L3])) == (@inferred prod([L1, L2]) * L3)
    @test (@inferred prod((L1, L2, L3))) isa LinearMaps.CompositeMap{<:Any,<:LinearMapTuple}
    @test (@inferred L1 * L2 * L3) == CompositeL == prod([L1, L2, L3])
    @test Matrix(L1 * L2) ≈ sparse(L1 * L2) ≈ R1 * R2
    @test Matrix(@inferred((α * L1) * (L2 * L3))::LinearMaps.ScaledMap) ≈ α * CompositeR
    @test Matrix(@inferred((L1 * L2) * (L3 * α))::LinearMaps.ScaledMap) ≈ α * CompositeR
    @test @inferred transpose(CompositeL) == transpose(L3) * transpose(L2) * transpose(L1)
    @test @inferred adjoint(CompositeL) == L3' * L2' * L1'
    @test @inferred adjoint(adjoint((CompositeL))) == CompositeL
    @test transpose(transpose((CompositeL))) == CompositeL
    Lt = @inferred transpose(LinearMap(CompositeL))
    @test Lt * v ≈ transpose(CompositeR) * v
    Lc = @inferred adjoint(LinearMap(CompositeL))
    @test Lc * v ≈ adjoint(CompositeR) * v

    # convert to AbstractMatrix
    for A in (LinearMap(sprandn(10, 10, 0.3)), LinearMap(rand()*I, 10))
        for B in (LinearMap(sprandn(10, 10, 0.3)), LinearMap(rand()*I, 10))
            AA = convert(AbstractMatrix, A*B)
            if A isa LinearMaps.UniformScalingMap && B isa LinearMaps.UniformScalingMap
                @test isdiag(AA)
            else
                @test issparse(AA)
            end
        end
    end

    # test inplace operations
    w = similar(v)
    mul!(w, L, v)
    @test w ≈ LF * v

    # test composition of several maps with shared data #31
    global sizes = ( (5, 2), (3, 3), (3, 2), (2, 2), (9, 2), (7, 1) )
    N = length(sizes) - 1
    global Lf = []
    global Lt = []
    global Lc = []

    # build list of operators [LN, ..., L2, L1] for each mode
    for (fi, i) in [ (Symbol("f$i"), i) for i in 1:N]
        @eval begin
            function ($fi)(source)
                dest = ones(prod(sizes[$i + 1]))
                tmp = reshape(source, sizes[$i])
                return conj.($i * dest)
            end
            insert!(Lf, 1, LinearMap($fi, prod(sizes[$i + 1]), prod(sizes[$i])))
            insert!(Lt, 1, LinearMap(x -> x, $fi, prod(sizes[$i]), prod(sizes[$i + 1])))
            insert!(Lc, 1, LinearMap{ComplexF64}(x -> x, $fi, prod(sizes[$i]), prod(sizes[$i + 1])))
        end
    end
    @test size(prod(Lf[1:N])) == (prod(sizes[end]), prod(sizes[1]))
    @test isreal(prod(Lf[1:N]))
    # multiply as composition and as recursion
    v1 = ones(prod(sizes[1]))
    u1 = ones(prod(sizes[1]))
    w1 = im.*ones(ComplexF64, prod(sizes[1]))
    for i = N:-1:1
        v2 = prod(Lf[i:N]) * ones(prod(sizes[1]))
        i < N && (y2 = LinearMaps._compositemul!(zero(v2), prod(Lf[i:N]), ones(prod(sizes[1]))))
        u2 = transpose(LinearMap(prod(Lt[N:-1:i]))) * ones(prod(sizes[1]))
        w2 = adjoint(LinearMap(prod(Lc[N:-1:i]))) * ones(prod(sizes[1]))

        v1 = Lf[i] * v1
        u1 = transpose(Lt[i]) * u1
        w1 = adjoint(Lc[i]) * w1

        @test v1 == v2
        i < N && @test v2 == y2
        @test u1 == u2
        @test w1 == w2
    end
    L1 = LinearMap(rand(2,3))
    L2 = LinearMap(rand(4,2))
    L3 = LinearMap(rand(3, 4))
    L4 = LinearMap(rand(5, 3))
    Ls = L4*L3*L2*L1
    X = rand(size(Ls, 2), 10)
    Y = similar(X, (size(Ls, 1), size(X, 2)))
    @test mul!(Y, Ls, X) ≈ L4.lmap * L3.lmap * L2.lmap * L1.lmap * X

    # test isposdef on a case where sufficient conditions work
    B = LinearMap([1 0; 0 1], isposdef=true) # isposdef!
    C = B' * B * B * B * B # no B' at end on purpose
    @test @inferred isposdef(C)
    @test @inferred isposdef(LinearMaps.CompositeMap{Float64}([B, B, B, B, B']))
    @test @inferred isposdef(B * B) # even case for empty tuple test
    @test @inferred isposdef(LinearMaps.CompositeMap{Float64}([B, B]))

    M = LinearMap(cumsum, 3)
    for i in 1:4
        P = prod(fill(M, i))
        @test P isa LinearMaps.CompositeMap{<:Any,<:LinearMapVector}
        @test P * ones(3) == (LowerTriangular(ones(3,3))^i) * ones(3)
    end
end

# test product of 2-arg FunctionMaps
# the following tests don't work when wrapped in a testset
N = 100
function planA()
    y = zeros(N) # workspace
    A = LinearMap{Float64}(x -> (y .= x .+ 1; y), N)
    return A, y
end
function planB()
    y = zeros(N) # workspace
    A = LinearMap{Float64}(x -> (y .= x ./ 2; y), N)
    return A, y
end
A, ya = planA()
B, yb = planB()
x = zeros(N)
C = @inferred A*B; C*x
@test C*x === ya == ones(N)
D = @inferred B*A; D*x
@test D*x === yb == fill(0.5, N)
@test (@allocated C*x) == 0
mul!(deepcopy(ya), C, x)
y = deepcopy(ya)
@test (@allocated mul!(y, C, x)) == 0

struct BlockMap{T,
                As<:LinearMapTupleOrVector,
                Rs<:Tuple{Vararg{Int}}} <: LinearMap{T}
    maps::As
    rows::Rs
    rowranges::Vector{UnitRange{Int}}
    colranges::Vector{UnitRange{Int}}
    function BlockMap{T,As,Rs}(maps::As, rows::Rs) where
                {T, As<:LinearMapTupleOrVector, Rs<:Tuple{Vararg{Int}}}
        for TA in Base.Generator(eltype, maps)
            promote_type(T, TA) == T ||
                error("eltype $TA cannot be promoted to $T in BlockMap constructor")
        end
        rowranges, colranges = rowcolranges(maps, rows)
        return new{T, As, Rs}(maps, rows, rowranges, colranges)
    end
end

BlockMap{T}(maps::As, rows::Rs) where {T, As<:LinearMapTupleOrVector, Rs} =
    BlockMap{T, As, Rs}(maps, rows)
BlockMap(maps::As, rows::Rs) where {As<:LinearMapTupleOrVector, Rs} =
    BlockMap{promote_type(map(eltype, maps)...), As, Rs}(maps, rows)

MulStyle(A::BlockMap) = MulStyle(A.maps...)

function _getranges(maps, dim, inds=1:length(maps))
    ends = map(i -> size(maps[i], dim)::Int, inds)
    cumsum!(ends, ends)
    starts = vcat(1, 1 .+ @views ends[firstindex(ends):lastindex(ends)-1])
    return UnitRange.(starts, ends)
end

# """
#     rowcolranges(maps, rows)

# Determines the range of rows for each block row and the range of columns for each
# map in `maps`, according to its position in a virtual matrix representation of the
# block linear map obtained from `hvcat(rows, maps...)`.
# """
function rowcolranges(maps, rows)
    # find indices of the row-wise first maps
    firstmapinds = vcat(1, Base.front(rows)...)
    cumsum!(firstmapinds, firstmapinds)
    # compute rowranges from first dimension of the row-wise first maps
    rowranges = _getranges(maps, 1, firstmapinds)

    # compute ranges from second dimension as if all in one row
    temp = _getranges(maps, 2)
    # introduce "line breaks"
    colranges = map(1:length(maps)) do i
        # for each map find the index of the respective row-wise first map
        # something-trick just to assure the compiler that the index is an Int
        @inbounds firstmapind = firstmapinds[something(findlast(<=(i), firstmapinds), 1)]
        # shift ranges by the first col-index of the row-wise first map
        return @inbounds temp[i] .- first(temp[firstmapind]) .+ 1
    end
    return rowranges, colranges
end

Base.size(A::BlockMap) = (last(last(A.rowranges)), last(last(A.colranges)))

############
# hcat
############
"""
    hcat(As::Union{LinearMap,UniformScaling,AbstractVecOrMatOrQ}...)::BlockMap

Construct a (lazy) representation of the horizontal concatenation of the arguments.
All arguments are promoted to `LinearMap`s automatically.

# Examples
```jldoctest; setup=(using LinearMaps)
julia> CS = LinearMap{Int}(cumsum, 3)::LinearMaps.FunctionMap;

julia> L = [CS LinearMap(ones(Int, 3, 3))]::LinearMaps.BlockMap;

julia> L * ones(Int, 6)
3-element Vector{Int64}:
 4
 5
 6
```
"""
function Base.hcat(As::Union{LinearMap, UniformScaling, AbstractArray, AbstractQ}...)
    T = promote_type(map(eltype, As)...)
    nbc = length(As)

    # find first non-UniformScaling to detect number of rows
    j = findfirst(A -> !isa(A, UniformScaling), As)
    # this should not happen, function should only be called with at least one LinearMap
    @assert !isnothing(j)
    @inbounds nrows = size(As[j], 1)::Int
    
    return BlockMap{T}(promote_to_lmaps(ntuple(_ -> nrows, Val(nbc)), 1, 1, As...), (nbc,))
end

############
# vcat
############
"""
    vcat(As::Union{LinearMap,UniformScaling,AbstractVecOrMatOrQ}...)::BlockMap

Construct a (lazy) representation of the vertical concatenation of the arguments.
All arguments are promoted to `LinearMap`s automatically.

# Examples
```jldoctest; setup=(using LinearMaps)
julia> CS = LinearMap{Int}(cumsum, 3)::LinearMaps.FunctionMap;

julia> L = [CS; LinearMap(ones(Int, 3, 3))]::LinearMaps.BlockMap;

julia> L * ones(Int, 3)
6-element Vector{Int64}:
 1
 2
 3
 3
 3
 3
```
"""
function Base.vcat(As::Union{LinearMap, UniformScaling, AbstractArray, AbstractQ}...)
    T = promote_type(map(eltype, As)...)
    nbr = length(As)

    # find first non-UniformScaling to detect number of rows
    j = findfirst(A -> !isa(A, UniformScaling), As)
    # this should not happen, function should only be called with at least one LinearMap
    @assert !isnothing(j)
    @inbounds ncols = size(As[j], 2)::Int

    rows = ntuple(_ -> 1, Val(nbr))
    return BlockMap{T}(promote_to_lmaps(ntuple(_ -> ncols, Val(nbr)), 1, 2, As...), rows)
end

############
# hvcat
############
"""
    hvcat(rows::Tuple{Vararg{Int}}, As::Union{LinearMap,UniformScaling,AbstractVecOrMatOrQ}...)::BlockMap

Construct a (lazy) representation of the horizontal-vertical concatenation of the arguments.
The first argument specifies the number of arguments to concatenate in each block row.
All arguments are promoted to `LinearMap`s automatically.

# Examples
```jldoctest; setup=(using LinearMaps)
julia> CS = LinearMap{Int}(cumsum, 3)::LinearMaps.FunctionMap;

julia> L = [CS CS; CS CS]::LinearMaps.BlockMap;

julia> L.rows
(2, 2)

julia> L * ones(Int, 6)
6-element Vector{Int64}:
 2
 4
 6
 2
 4
 6
```
"""
function Base.hvcat(rows::Tuple{Vararg{Int}}, As::Union{LinearMap, UniformScaling, AbstractArray, AbstractQ}...)
    nr = length(rows)
    T = promote_type(map(eltype, As)...)
    sum(rows) == length(As) ||
        throw(ArgumentError("mismatch between row sizes and number of arguments"))
    n = fill(-1, length(As))
    j = 0
    for i in eachindex(rows) # infer UniformScaling sizes from row counts, if possible:
        ni = -1 # number of rows in this block-row, -1 indicates unknown
        for k in 1:rows[i]
            if !isa(As[j+k], UniformScaling)
                na = size(As[j+k], 1)::Int
                ni >= 0 && ni != na &&
                    throw(DimensionMismatch("mismatch in number of rows"))
                ni = na
            end
        end
        if ni >= 0
            n[j .+ (1:rows[i])] .= ni
        end
        j += rows[i]
    end
    # check for consistent total column number
    nc = -1
    j = 0
    for i in eachindex(rows)
        nci = 0
        rows[i] > 0 && n[j+1] == -1 && (j += rows[i]; continue)
        for k in 1:rows[i]
            nci += isa(As[j+k], UniformScaling) ? n[j+k] : size(As[j+k], 2)::Int
        end
        nc >= 0 && nc != nci && throw(DimensionMismatch("mismatch in number of columns"))
        nc = nci
        j += rows[i]
    end
    nc == -1 && throw(ArgumentError("sizes of UniformScalings could not be inferred"))
    j = 0
    for i in eachindex(rows)
        if rows[i] > 0 && n[j+1] == -1 # this row consists entirely of UniformScalings
            nci, r = divrem(nc, rows[i])
            r != 0 && throw(DimensionMismatch("indivisible UniformScaling sizes"))
            for k in 1:rows[i]
                n[j+k] = nci
            end
        end
        j += rows[i]
    end

    return BlockMap{T}(promote_to_lmaps(n, 1, 1, As...), rows)
end

function check_dim(A, dim, n)
    n == size(A, dim) || throw(DimensionMismatch("Expected $n, got $(size(A, dim))"))
    return nothing
end

promote_to_lmaps_(n::Int, dim, A::AbstractVecOrMat) = (check_dim(A, dim, n); LinearMap(A))
promote_to_lmaps_(n::Int, dim, J::UniformScaling) = UniformScalingMap(J.λ, n)
promote_to_lmaps_(n::Int, dim, A::LinearMap) = (check_dim(A, dim, n); A)
promote_to_lmaps(n, k, dim) = ()
promote_to_lmaps(n, k, dim, A) = (promote_to_lmaps_(n[k], dim, A),)
@inline promote_to_lmaps(n, k, dim, A, B, Cs...) =
    (promote_to_lmaps_(n[k], dim, A), promote_to_lmaps_(n[k+1], dim, B), promote_to_lmaps(n, k+2, dim, Cs...)...)

############
# basic methods
############

function isblocksquare(A::BlockMap)
    rows = A.rows
    N = length(rows)
    return all(==(N), rows)
end

symindex(i, N) = ((k, l) = divrem(i-1, N); return k + l * N + 1)

# the following rules are sufficient but not necessary
function LinearAlgebra.issymmetric(A::BlockMap)
    isblocksquare(A) || return false
    N = length(A.rows)
    maps = A.maps
    for i in 1:N*N
        isym = symindex(i, N)
        if (i == isym && !issymmetric(maps[i]))
            return false
        elseif (maps[i] != transpose(maps[isym]))
            return false
        end
    end
    return true
end

function LinearAlgebra.ishermitian(A::BlockMap)
    isblocksquare(A) || return false
    N = length(A.rows)
    maps = A.maps
    for i in 1:N*N
        isym = symindex(i, N)
        if (i == isym && !ishermitian(maps[i]))
            return false
        elseif (maps[i] != adjoint(maps[isym]))
            return false
        end
    end
    return true
end

############
# comparison of BlockMap objects, sufficient but not necessary
############

Base.:(==)(A::BlockMap, B::BlockMap) =
    (eltype(A) == eltype(B) && all(A.maps .== B.maps) && all(A.rows .== B.rows))

############
# multiplication helper functions
############

function _blockmul!(y, A, x, α, β)
    if iszero(α)
        iszero(β) && return fill!(y, zero(eltype(y)))
        isone(β) && return y
        return rmul!(y, β)
    end
    return __blockmul!(MulStyle(A), y, A, x, α, β)
end

__blockmul!(::MulStyle, y, A, x::Number, α, β)  = ___blockmul!(y, A, x, α, β)
function ___blockmul!(y, A, x::Number, α, β)
    maps, rows, yinds, xinds = A.maps, A.rows, A.rowranges, A.colranges
    mapind = 0
    if iszero(β)
        s = x*α
        for (row, yi) in zip(rows, yinds)
            mapind += 1
            _unsafe_mul!(view(y, yi, xinds[mapind]), maps[mapind], s)
            for _ in 2:row
                mapind += 1
                _unsafe_mul!(view(y, yi, xinds[mapind]), maps[mapind], s)
            end
        end
    else
        for (row, yi) in zip(rows, yinds)
            mapind += 1
            _unsafe_mul!(view(y, yi, xinds[mapind]), maps[mapind], x, α, β)
            for _ in 2:row
                mapind += 1
                _unsafe_mul!(view(y, yi, xinds[mapind]), maps[mapind], x, α, β)
            end
        end
    end
    return y
end

# provide one global intermediate storage vector if necessary
__blockmul!(::FiveArg, y, A, x::AbstractVecOrMat, α, β)  = ___blockmul!(y, A, x, α, β, nothing)
__blockmul!(::ThreeArg, y, A, x::AbstractVecOrMat, α, β) = ___blockmul!(y, A, x, α, β, similar(y))
__blockmul!(::TwoArg, y, A, x::AbstractVecOrMat, α, β)  = ___blockmul!(y, A, x, α, β, nothing)
function ___blockmul!(y, A, x, α, β, ::Nothing)
    maps, rows, yinds, xinds = A.maps, A.rows, A.rowranges, A.colranges
    mapind = 0
    for (row, yi) in zip(rows, yinds)
        yrow = selectdim(y, 1, yi)
        mapind += 1
        _unsafe_mul!(yrow, maps[mapind], selectdim(x, 1, xinds[mapind]), α, β)
        for _ in 2:row
            mapind += 1
            _unsafe_mul!(yrow, maps[mapind], selectdim(x, 1, xinds[mapind]), α, true)
        end
    end
    return y
end
function ___blockmul!(y, A, x, α, β, z)
    maps, rows, yinds, xinds = A.maps, A.rows, A.rowranges, A.colranges
    mapind = 0
    for (row, yi) in zip(rows, yinds)
        yrow = selectdim(y, 1, yi)
        zrow = selectdim(z, 1, yi)
        mapind += 1
        xrow = selectdim(x, 1, xinds[mapind])
        if MulStyle(maps[mapind]) === ThreeArg() && !iszero(β)
            !isone(β) && rmul!(yrow, β)
            muladd!(ThreeArg(), yrow, maps[mapind], xrow, α, zrow)
        else
            _unsafe_mul!(yrow, maps[mapind], xrow, α, β)
        end
        for _ in 2:row
            mapind +=1
            xrow = selectdim(x, 1, xinds[mapind])
            muladd!(MulStyle(maps[mapind]), yrow, maps[mapind], xrow, α, zrow)
        end
    end
    return y
end

function _transblockmul!(y, A, x, α, β, transform)
    if iszero(α)
        iszero(β) && return fill!(y, zero(eltype(y)))
        isone(β) && return y
        return rmul!(y, β)
    else
        return __transblockmul!(y, A, x, α, β, transform)
    end
end
function __transblockmul!(y, A, x::Number, α, β, transform)
    maps, rows, xinds, yinds = A.maps, A.rows, A.rowranges, A.colranges
    if iszero(β)
        s = x*α
        # first block row (rowind = 1) of A, meaning first block column of A', fill all of y
        for rowind in 1:first(rows)
            _unsafe_mul!(view(y, yinds[rowind], first(xinds)), transform(maps[rowind]), s)
        end
        mapind = first(rows)
        # subsequent block rows of A (block columns of A')
        @inbounds for i in 2:length(rows), _ in 1:rows[i]
            mapind +=1
            _unsafe_mul!(view(y, yinds[mapind], xinds[i]), transform(maps[mapind]), s)
        end
    else
        # first block row (rowind = 1) of A, meaning first block column of A', fill all of y
        for rowind in 1:first(rows)
            ytile = view(y, yinds[rowind], first(xinds))
            _unsafe_mul!(ytile, transform(maps[rowind]), x, α, β)
        end
        mapind = first(rows)
        # subsequent block rows of A (block columns of A'),
        # add results to corresponding parts of y
        # TODO: think about multithreading
        @inbounds for i in 2:length(rows), _ in 1:rows[i]
            mapind +=1
            ytile = view(y, yinds[mapind], xinds[i])
            _unsafe_mul!(ytile, transform(maps[mapind]), x, α, β)
        end
    end
    return y
end
function __transblockmul!(y, A, x, α, β, transform)
    maps, rows, xinds, yinds = A.maps, A.rows, A.rowranges, A.colranges
    # first block row (rowind = 1) of A, meaning first block column of A', fill all of y
    xrow = selectdim(x, 1, first(xinds))
    for rowind in 1:first(rows)
        yrow = selectdim(y, 1, yinds[rowind])
        _unsafe_mul!(yrow, transform(maps[rowind]), xrow, α, β)
    end
    mapind = first(rows)
    # subsequent block rows of A (block columns of A'),
    # add results to corresponding parts of y
    # TODO: think about multithreading
    @inbounds for i in 2:length(rows)
        xrow = selectdim(x, 1, xinds[i])
        for _ in 1:rows[i]
            mapind +=1
            yrow = selectdim(y, 1, yinds[mapind])
            _unsafe_mul!(yrow, transform(maps[mapind]), xrow, α, true)
        end
    end
    return y
end

############
# multiplication with vectors & matrices
############

for In in (AbstractVector, AbstractMatrix)
    @eval begin
        function _unsafe_mul!(y, A::BlockMap, x::$In)
            require_one_based_indexing(y, x)
            return _blockmul!(y, A, x, true, false)
        end
        function _unsafe_mul!(y, A::BlockMap, x::$In, α, β)
            require_one_based_indexing(y, x)
            return _blockmul!(y, A, x, α, β)
        end
    end

    for (MT, transform) in ((:TransposeMap, :transpose), (:AdjointMap, :adjoint))
        @eval begin
            MapType = $MT{<:Any, <:BlockMap}
            function _unsafe_mul!(y, wrapA::MapType, x::$In)
                require_one_based_indexing(y, x)
                return _transblockmul!(y, wrapA.lmap, x, true, false, $transform)
            end
            function _unsafe_mul!(y, wrapA::MapType, x::$In, α, β)
                require_one_based_indexing(y, x)
                return _transblockmul!(y, wrapA.lmap, x, α, β, $transform)
            end
        end
    end
end

############
# multiplication with a scalar
############

function _unsafe_mul!(Y, A::BlockMap, s::Number, α=true, β=false)
    require_one_based_indexing(Y, s)
    return _blockmul!(Y, A, s, α, β)
end
for (MT, transform) in ((:TransposeMap, :transpose), (:AdjointMap, :adjoint))
    @eval begin
        function _unsafe_mul!(Y, wrapA::$MT{<:Any, <:BlockMap}, s::Number, α=true, β=false)
            require_one_based_indexing(Y)
            return _transblockmul!(Y, wrapA.lmap, s, α, β, $transform)
        end
    end
end

############
# BlockDiagonalMap
############
struct BlockDiagonalMap{T, As<:LinearMapTupleOrVector} <: LinearMap{T}
    maps::As
    rowranges::Vector{UnitRange{Int}}
    colranges::Vector{UnitRange{Int}}
    function BlockDiagonalMap{T, As}(maps::As) where {T, As<:LinearMapTupleOrVector}
        for TA in Base.Generator(eltype, maps)
            promote_type(T, TA) == T ||
                error("eltype $TA cannot be promoted to $T in BlockDiagonalMap constructor")
        end
        rowranges = _getranges(maps, 1)
        colranges = _getranges(maps, 2)
        return new{T, As}(maps, rowranges, colranges)
    end
end

BlockDiagonalMap{T}(maps::As) where {T, As<:LinearMapTupleOrVector} =
    BlockDiagonalMap{T,As}(maps)
BlockDiagonalMap(maps::LinearMap...) =
    BlockDiagonalMap{promote_type(map(eltype, maps)...)}(maps)

# since the below methods are more specific than the Base method,
# they would redefine Base/SparseArrays behavior
for k in 1:8 # is 8 sufficient?
    Is = ntuple(n->:($(Symbol(:A, n))::AbstractVecOrMatOrQ), Val(k-1))
    # yields (:A1, :A2, :A3, ..., :A(k-1))
    L = :($(Symbol(:A, k))::LinearMap)
    # yields :Ak
    mapargs = ntuple(n ->:($(Symbol(:A, n))), Val(k-1))
    # yields (:LinearMap(A1), :LinearMap(A2), ..., :LinearMap(A(k-1)))

    @eval function Base.cat($(Is...), $L, As::MapOrVecOrMat...; dims::Dims{2})
        if dims == (1,2)
            return BlockDiagonalMap(convert_to_lmaps($(mapargs...))...,
                                    $(Symbol(:A, k)),
                                    convert_to_lmaps(As...)...)
        else
            throw(ArgumentError("dims keyword in cat of LinearMaps must be (1,2)"))
        end
    end
end

"""
    cat(As::Union{LinearMap,AbstractVecOrMatOrQ}...; dims=(1,2))::BlockDiagonalMap

Construct a (lazy) representation of the diagonal concatenation of the arguments.
To avoid fallback to the generic `Base.cat`, there must be a `LinearMap`
object among the first 8 arguments.
"""
Base.cat

Base.size(A::BlockDiagonalMap) = (last(last(A.rowranges)), last(last(A.colranges)))

MulStyle(A::BlockDiagonalMap) = MulStyle(A.maps...)

LinearAlgebra.issymmetric(A::BlockDiagonalMap) = all(issymmetric, A.maps)
LinearAlgebra.ishermitian(A::BlockDiagonalMap) = all(ishermitian, A.maps)

LinearAlgebra.adjoint(A::BlockDiagonalMap{T}) where {T} =
    BlockDiagonalMap{T}(map(adjoint, A.maps))
LinearAlgebra.transpose(A::BlockDiagonalMap{T}) where {T} =
    BlockDiagonalMap{T}(map(transpose, A.maps))

Base.:(==)(A::BlockDiagonalMap, B::BlockDiagonalMap) =
    (eltype(A) == eltype(B) && all(A.maps .== B.maps))

for In in (AbstractVector, AbstractMatrix, Number)
    @eval begin
        function _unsafe_mul!(y, A::BlockDiagonalMap, x::$In)
            require_one_based_indexing(y, x)
            return _blockscaling!(y, A, x)
        end
        function _unsafe_mul!(y, A::BlockDiagonalMap, x::$In, α, β)
            require_one_based_indexing(y, x)
            return _blockscaling!(y, A, x, α, β)
        end
    end
end

function _blockscaling!(y, A, x::Number)
    maps, yinds, xinds = A.maps, A.rowranges, A.colranges
    fill!(y, zero(eltype(y)))
    # TODO: think about multi-threading here
    @inbounds for (yind, map, xind) in zip(yinds, maps, xinds)
        _unsafe_mul!(view(y, yind, xind), map, x)
    end
    return y
end
function _blockscaling!(y, A, x::Number, α, β)
    maps, yinds, xinds = A.maps, A.rowranges, A.colranges
    LinearAlgebra._rmul_or_fill!(y, β)
    # TODO: think about multi-threading here
    @inbounds for (yind, map, xind) in zip(yinds, maps, xinds)
        _unsafe_mul!(view(y, yind, xind), map, x, α, true)
    end
    return y
end

function _blockscaling!(y, A, x)
    maps, yinds, xinds = A.maps, A.rowranges, A.colranges
    # TODO: think about multi-threading here
    @inbounds for (yind, map, xind) in zip(yinds, maps, xinds)
        _unsafe_mul!(selectdim(y, 1, yind), map, selectdim(x, 1, xind))
    end
    return y
end
function _blockscaling!(y, A, x, α, β)
    maps, yinds, xinds = A.maps, A.rowranges, A.colranges
    # TODO: think about multi-threading here
    @inbounds for (yind, map, xind) in zip(yinds, maps, xinds)
        _unsafe_mul!(selectdim(y, 1, yind), map, selectdim(x, 1, xind), α, β)
    end
    return y
end

module LinearMapsStatisticsExt

import Statistics: mean

using LinearMaps
using LinearMaps: LinearMapTupleOrVector, LinearCombination

mean(f::F, maps::LinearMapTupleOrVector) where {F} = sum(f, maps) / length(maps)
mean(maps::LinearMapTupleOrVector) = mean(identity, maps)
mean(A::LinearCombination) = mean(A.maps)

end # module ChainRulesCore

using Test, LinearMaps, LinearAlgebra, SparseArrays
using Quaternions: Quaternion

@testset "conversion" begin
    A = 2 * rand(ComplexF64, (20, 10)) .- 1
    v = rand(ComplexF64, 10)
    w = rand(ComplexF64, 20)
    V = rand(ComplexF64, 10, 3)
    W = rand(ComplexF64, 20, 3)
    α = rand()
    β = rand()
    M = @inferred LinearMap(A)
    N = @inferred LinearMap(M)
    U = @inferred LinearMap(v)

    @test Matrix(M) == A
    @test Array(M) == A
    @test convert(AbstractArray, M) == A
    @test convert(AbstractMatrix, M) === A
    @test convert(Matrix, M) === A
    @test convert(Array, M) === A
    @test convert(AbstractMatrix, M) == A
    @test convert(Matrix, M) == A
    @test convert(Array, M) == A
    @test Matrix(M') == A'
    @test Matrix(transpose(M)) == copy(transpose(A))
    @test convert(AbstractMatrix, M') isa Adjoint
    @test convert(Matrix, M*3I) == A*3
    @test convert(Matrix, M+M) == A + A
    @test all(Matrix(U) .== v)
    @test convert(Matrix{ComplexF32}, U) isa Matrix{ComplexF32}

    # UniformScalingMap
    J = LinearMap(α*I, 10)
    JM = convert(AbstractMatrix, J)
    @test JM == Diagonal(fill(α, 10))

    # ScaledMap
    q = rand(ComplexF64)
    A = rand(ComplexF64, 3, 3)
    @test convert(Matrix, q*LinearMap(A)) ≈ q*A
    qAs = convert(SparseMatrixCSC, q*LinearMap(A))
    @test qAs ≈ q*A
    @test qAs isa SparseMatrixCSC

    # CompositeMap of MatrixMap and UniformScalingMap
    q = Quaternion(rand(4)...)
    A = Quaternion.(rand(3,3), rand(3,3), rand(3,3), rand(3,3))
    for mat in (Matrix, SparseMatrixCSC)
        Aqmat = convert(mat, LinearMap(A)*q)
        @test Aqmat ≈ A*q
        @test Aqmat isa mat
        qAmat = convert(mat, q*LinearMap(A))
        @test qAmat ≈ q*A
        @test qAmat isa mat
    end

    # sparse matrix generation/conversion
    @test sparse(M) == sparse(Array(M))
    @test convert(SparseMatrixCSC, M) == sparse(Array(M))

    B = copy(A)
    B[rand(1:length(A), 30)] .= 0
    MS = LinearMap(B)
    @test sparse(MS) == sparse(Array(MS)) == sparse(B)

    J = LinearMap(I, 10)
    @test J isa LinearMap{Bool}
    @test sparse(J) == Matrix{Bool}(I, 10, 10)
    @test nnz(sparse(J)) == 10
end

using Test, LinearMaps, LinearAlgebra, SparseArrays

@testset "transpose/adjoint" begin
    ctr() = LinearMap{ComplexF64}(cumsum, x -> reverse(cumsum(reverse(x))), 10; ismutating=false)
    CS = @inferred ctr()
    for transform in (adjoint, transpose)
        @test transform(CS) != CS
        @test CS != transform(CS)
        @test transform(transform(CS)) == CS
        @test LinearMaps.MulStyle(transform(CS)) === LinearMaps.MulStyle(CS)
    end
    @test occursin("10×10 LinearMaps.TransposeMap{$(eltype(CS))}", sprint((t, s) -> show(t, "text/plain", s), transpose(CS)))
    @test occursin("10×10 LinearMaps.AdjointMap{$(eltype(CS))}", sprint((t, s) -> show(t, "text/plain", s), adjoint(CS)))
    @test !(transpose(CS) == adjoint(CS))
    @test !(adjoint(CS) == transpose(CS))
    M = Matrix(CS)
    @test M == LowerTriangular(ones(10,10)) == mul!(copy(M), CS, 1, true, false)
    x = rand(ComplexF64, 10); w = rand(ComplexF64, 10)
    X = rand(ComplexF64, 10, 3); W = rand(ComplexF64, 10, 3)
    α, β = rand(ComplexF64, 2)
    for transform in (adjoint, transpose)
        @test convert(AbstractMatrix, transform(CS)) == transform(M)
        @test sparse(transform(CS)) == transform(M)
        @test transform(CS) * x ≈ transform(M)*x
        @test mul!(copy(w), transform(CS), x) ≈ transform(M)*x
        @test mul!(copy(W), transform(CS), X) ≈ transform(M)*X
        @test mul!(copy(w), transform(CS), x, α, β) ≈ transform(M)*x*α + w*β
        @test mul!(copy(W), transform(CS), X, α, β) ≈ transform(M)*X*α + W*β
    end
    for transform1 in (adjoint, transpose), transform2 in (identity, adjoint, transpose)
        @test transform1(transform1(CS)) === CS
        @test transform2(transform1(transform2(CS))) === transform1(CS)
        @test transform2(transform1(CS)) * x ≈ transform2(transform1(M))*x
        @test mul!(copy(w), transform2(transform1(CS)), x) ≈ transform2(transform1(M))*x
        @test mul!(copy(W), transform2(transform1(CS)), X) ≈ transform2(transform1(M))*X
        @test mul!(copy(M), transform2(transform1(CS)), 2) ≈ transform2(transform1(M))*2
        @test mul!(copy(w), transform2(transform1(CS)), x, α, β) ≈ transform2(transform1(M))*x*α + w*β
        @test mul!(copy(W), transform2(transform1(CS)), X, α, β) ≈ transform2(transform1(M))*X*α + W*β
        @test mul!(copy(M), transform2(transform1(CS)), 2, α, β) ≈ transform2(transform1(M))*(2*α) + M*β
    end

    id = @inferred FunctionMap{Float64,false}(identity, identity, 10; issymmetric=true, ishermitian=true, isposdef=true)
    for transform in (adjoint, transpose)
        @test transform(id) == id
        @test id == transform(id)
        for prop in (issymmetric, ishermitian, isposdef)
            @test prop(transform(id))
        end
    end
end

# Types and methods

## Types and their constructors

None of the types below need to be constructed directly; they arise from
performing operations between `LinearMap` objects or by calling the `LinearMap`
constructor described next.

### `LinearMap`

Abstract supertype

```@docs
LinearMap
```

### `FunctionMap`

Type for wrapping an arbitrary function that is supposed to implement the
matrix-vector product as a `LinearMap`; see above.

```@docs
FunctionMap
```

### `WrappedMap`

Type for wrapping an `AbstractMatrix` or `LinearMap` and to possible redefine
the properties `isreal`, `issymmetric`, `ishermitian` and `isposdef`. An
`AbstractMatrix` will automatically be converted to a `WrappedMap` when it is
combined with other `LinearMap` objects via linear combination or
composition (multiplication). Note that `WrappedMap(mat1)*WrappedMap(mat2)`
will never evaluate `mat1*mat2`, since this is more costly than evaluating
`mat1*(mat2*x)` and the latter is the only operation that needs to be performed
by `LinearMap` objects anyway. While the cost of matrix addition is comparable
to matrix-vector multiplication, this too is not performed explicitly since
this would require new storage of the same amount as of the original matrices.

### `ScaledMap`

Type for representing a scalar multiple of any `LinearMap` type. A
`ScaledMap` will be automatically constructed if real or complex `LinearMap`
objects are multiplied by real or complex scalars from the left or from the
right.

```@docs
LinearMaps.ScaledMap
```

### `UniformScalingMap`

Type for representing a scalar multiple of the identity map (a.k.a. uniform
scaling) of a certain size `M=N`, obtained simply as `LinearMap(λI, M)`,
where `I` is the `LinearAlgebra.UniformScaling` object.
The type `T` of the resulting `LinearMap` object is inferred from the type of
`λ`. A `UniformScalingMap` of the correct size will be automatically
constructed if `LinearMap` objects are multiplied by scalars from the left
or from the right (respecting the order of multiplication), if the scalar `λ`
is either real or complex.

### `LinearCombination`, `CompositeMap`, `TransposeMap` and `AdjointMap`

Used to add/multiply/transpose/adjoint `LinearMap` objects lazily, don't need to be constructed explicitly.

```@docs
+(::LinearMap,::LinearMap)
*(::LinearMap,::LinearMap)
LinearAlgebra.transpose(::LinearMap)
LinearAlgebra.adjoint(::LinearMap)
```

### `KroneckerMap` and `KroneckerSumMap`

Types for representing Kronecker products and Kronecker sums, resp., lazily.

```@docs
Base.kron(::LinearMap,::LinearMap)
LinearMaps.:⊗
kronsum
LinearMaps.:⊕
```

The common use case of rank-1 matrices/operators with image spanning vector `u` and
projection vector `v` is readily available as `u ⊗ v'` or `u ⊗ transpose(v)`.

There exist alternative constructors of Kronecker products and sums for square factors and
summands, respectively. These are designed for cases of 3 or more arguments, and
benchmarking intended use cases for comparison with `KroneckerMap` and `KroneckerSumMap`
is recommended.

```@docs
squarekron
sumkronsum
```

### `BlockMap` and `BlockDiagonalMap`

Types for representing block (diagonal) maps lazily.

```@docs
Base.hcat
Base.vcat
Base.hvcat
Base.cat
```

With `using SparseArrays`, yet another method is available for creating lazy block-diagonal
maps.

```@docs
SparseArrays.blockdiag
```

### `FillMap`

Type for lazily representing constantly filled matrices.

```@docs
FillMap
```

### `EmbeddedMap`

Type for representing linear maps that are embedded in larger zero maps.

### `InverseMap`

Type for lazy inverse of another linear map.

```@docs
InverseMap
```

### `KhatriRaoMap` and `FaceSplittingMap`

Types for lazy [column-wise](https://en.wikipedia.org/wiki/Khatri%E2%80%93Rao_product#Column-wise_Kronecker_product)
and [row-wise](https://en.wikipedia.org/wiki/Khatri%E2%80%93Rao_product#Face-splitting_product)
Kronecker product, respectively, also referred to
as Khatri-Rao and transposed Khatri-Rao (or face-splitting) product.

```@docs
khatrirao
facesplitting
```

## Methods

### Multiplication methods

```@docs
Base.:*(::LinearMap,::AbstractVector)
Base.:*(::LinearMap,::Union{LinearAlgebra.AbstractQ, AbstractMatrix})
Base.:*(::Union{LinearAlgebra.AbstractQ, AbstractMatrix},::LinearMap)
LinearAlgebra.mul!(::AbstractVecOrMat,::LinearMap,::AbstractVector)
LinearAlgebra.mul!(::AbstractVecOrMat,::LinearMap,::AbstractVector,::Number,::Number)
LinearAlgebra.mul!(::AbstractMatrix,::AbstractMatrix,::LinearMap)
LinearAlgebra.mul!(::AbstractMatrix,::AbstractMatrix,::LinearMap,::Number,::Number)
LinearAlgebra.mul!(::AbstractVecOrMat,::LinearMap,::Number)
LinearAlgebra.mul!(::AbstractMatrix,::LinearMap,::Number,::Number,::Number)
*(::LinearAlgebra.AdjointAbsVec,::LinearMap)
*(::LinearAlgebra.TransposeAbsVec,::LinearMap)
```

Applying the adjoint or transpose of `A` (if defined) to `x` works exactly
as in the usual matrix case: `transpose(A) * x` and `mul!(y, A', x)`, for instance.

### Conversion methods

* `Array`, `Matrix` and associated `convert` methods

  Create a dense matrix representation of the `LinearMap` object, by
  multiplying it with the successive basis vectors. This is mostly for testing
  purposes or if you want to have the explicit matrix representation of a
  linear map for which you only have a function definition (e.g. to be able to
  use its `transpose` or `adjoint`). This way, one may conveniently make `A`
  act on the columns of a matrix `X`, instead of interpreting `A * X` as a
  composed linear map: `Matrix(A * X)`. For generic code, that is supposed to
  handle both `A::AbstractMatrix` and `A::LinearMap`, it is recommended to use
  `convert(Matrix, A*X)`.

* `convert(Abstract[Matrix/Array], A::LinearMap)`

  Create an `AbstractMatrix` representation of the `LinearMap`. This falls
  back to `Matrix(A)`, but avoids explicit construction in case the `LinearMap`
  object is matrix-based.

* `SparseArrays.sparse(A::LinearMap)` and `convert(SparseMatrixCSC, A::LinearMap)`

  Create a sparse matrix representation of the `LinearMap` object, by
  multiplying it with the successive basis vectors. This is mostly for testing
  purposes or if you want to have the explicit sparse matrix representation of
  a linear map for which you only have a function definition (e.g. to be able
  to use its `transpose` or `adjoint`).

!!! note
    In Julia versions v1.9 and higher, conversion to sparse matrices requires loading
    `SparseArrays.jl` by the user in advance.

### Slicing methods

Complete slicing, i.e., `A[:,j]`, `A[:,J]`, `A[i,:]`, `A[I,:]` and `A[:,:]` for `i`, `j`
`Integer` and `I`, `J` `AbstractVector{<:Integer}` is generically available for any
`A::LinearMap` subtype via application of `A` (or `A'` for (predominantly) horizontal
slicing) to standard unit vectors of appropriate length. By complete slicing we refer
two-dimensional Cartesian indexing where at least one of the "indices" is a colon. This is
facilitated by overloads of `Base.getindex`. Partial slicing à la `A[I,J]` and scalar or
linear indexing are _not_ supported.

### Sum, product, mean and trace

Natural function overloads for `Base.sum`, `Base.prod`, `Statistics.mean` and `LinearAlgebra.tr`
exist.

!!! note
    In Julia versions v1.9 and higher, creating the mean linear operator requires loading
    `Statistics.jl` by the user in advance.

# Related open-source packages

The following open-source packages provide similar or even extended functionality as
`LinearMaps.jl`.

* [`Spot`: A linear-operator toolbox for Matlab](https://github.com/mpf/spot),
  which seems to have heavily inspired the Julia package
  [`LinearOperators.jl`](https://github.com/JuliaSmoothOptimizers/LinearOperators.jl)
  and the Python package [`PyLops`](https://github.com/equinor/pylops)
* [`fastmat`: fast linear transforms in Python](https://pypi.org/project/fastmat/)
* [`JOLI.jl`: Julia Operators LIbrary](https://github.com/slimgroup/JOLI.jl)
* [`FunctionOperators.jl`](https://github.com/hakkelt/FunctionOperators.jl)
  and [`LinearMapsAA.jl`](https://github.com/JeffFessler/LinearMapsAA.jl)
  also support mappings between `Array`s, inspired by the `fatrix` object type in the
  [Matlab version of the Michigan Image Reconstruction Toolbox (MIRT)](https://github.com/JeffFessler/mirt).

As for lazy array manipulation (like addition, composition, Kronecker products and concatenation),
there exist further related packages in the Julia ecosystem:

* [`LazyArrays.jl`](https://github.com/JuliaArrays/LazyArrays.jl)
* [`BlockArrays.jl`](https://github.com/JuliaArrays/BlockArrays.jl)
* [`BlockDiagonals.jl`](https://github.com/invenia/BlockDiagonals.jl)
* [`BlockFactorizations.jl`](https://github.com/SebastianAment/BlockFactorizations.jl)
* [`Kronecker.jl`](https://github.com/MichielStock/Kronecker.jl)
* [`FillArrays.jl`](https://github.com/JuliaArrays/FillArrays.jl)
* [`LiftedMaps.jl](https://github.com/krcools/LiftedMaps.jl)

Since these packages provide types that are subtypes of Julia `Base`'s `AbstractMatrix` type,
objects of those types can be wrapped by a `LinearMap` and freely mixed with, for instance,
function-based linear maps. The same applies to custom matrix types as provided, for instance,
by packages maintained by the [`JuliaArrays`](https://github.com/JuliaArrays) github organization.
For any `CustomMatrix{T} <: AbstractMatrix{T}` type, you only need to provide a
`mul!(::AbstractVecOrMat, ::CustomMatrix, ::AbstractVector[, ::Number, ::Number])` method for
seamless integration with `LinearMaps.jl`.

# LinearMaps.jl

*A Julia package for defining and working with linear maps, also known as linear transformations or linear operators acting on vectors. The only requirement for a LinearMap is that it can act on a vector (by multiplication) efficiently.*

## Installation

`LinearMaps.jl` is a registered package and can be installed via

```julia
pkg> add LinearMaps
```

in package mode, which can be entered by typing `]` in the Julia REPL.

## Examples

The examples show how to define `LinearMap`s. For more details refer to the section on
[Types and their constructors](@ref).
A linear map is defined by the way it acts on vectors and by its dimensions, potentially
also by its [adjoint](https://en.wikipedia.org/wiki/Hermitian_adjoint) action on vectors.
Some properties of the linear map can be defined explicitly or implicitly.

Let

```julia
A = LinearMap(rand(10, 10))
B = LinearMap(cumsum, reverse∘cumsum∘reverse, 10)
```

be a matrix- and a function-based linear map, respectively. For `A` all properties are
inferred from the input matrix; for `B` the action, the adjoint action and its dimensions
(for a single number, the dimension is taken as square) are defined explicitly.
Given the above the following code just works, indistinguishably from the case when `A` and
`B` are both `AbstractMatrix`-typed objects, yet giving lazy, `LinearMap`-typed objects
whose action on vectors corresponds to the otherwise expected matrix-vector multiplication.

```julia
3.0A + 2B
A + I
A*B'
[A B; B A]
kron(A, B)
```

The `LinearMap` type and corresponding methods combine well with the following packages:

* [ArnoldiMethods.jl](https://github.com/haampie/ArnoldiMethod.jl)
* [Arpack.jl](https://github.com/JuliaLinearAlgebra/Arpack.jl): iterative eigensolver
  `eigs` and SVD `svds`;
* [IterativeSolvers.jl](https://github.com/JuliaMath/IterativeSolvers.jl): iterative
  solvers, eigensolvers, and SVD;
* [KrylovKit.jl](https://github.com/Jutho/KrylovKit.jl): Krylov-based algorithms for linear
  problems, singular value and eigenvalue problems
* [TSVD.jl](https://github.com/andreasnoack/TSVD.jl): truncated SVD `tsvd`.

```julia
using LinearMaps
import Arpack, IterativeSolvers, KrylovKit, TSVD, ArnoldiMethod

# Example 1, 1-dimensional Laplacian with periodic boundary conditions
function leftdiff!(y::AbstractVector, x::AbstractVector) # left difference assuming periodic boundary conditions
    N = length(x)
    axes(y) == axes(x) || throw(DimensionMismatch())
    @inbounds for i in eachindex(x, y)
        y[i] = x[i] - x[mod1(i-1, N)]
    end
    return y
end

function mrightdiff!(y::AbstractVector, x::AbstractVector) # minus right difference
    N = length(x)
    axes(y) == axes(x) || throw(DimensionMismatch())
    @inbounds for i in eachindex(x, y)
        y[i] = x[i] - x[mod1(i+1, N)]
    end
    return y
end

D = LinearMap(leftdiff!, mrightdiff!, 100; ismutating=true) # by default has eltype(D) = Float64

Arpack.eigs(D'D; nev=3, which=:SR) # note that D'D is recognized as symmetric => real eigenfact
Arpack.svds(D; nsv=3)

ArnoldiMethod.partialschur(D'D; nev=3, which=ArnoldiMethod.SR())

KrylovKit.eigsolve(D'D, 100, 3, :SR)

Σ, L = IterativeSolvers.svdl(D; nsv=3)

TSVD.tsvd(D, 3)

# Example 2, 3 smallest eigenvalues of 1-dimensional Laplacian
A = LinearMap(100; issymmetric=true, ismutating=true) do C, B
    C[1] = -2B[1] + B[2]
    for i in 2:length(B)-1
        C[i] = B[i-1] - 2B[i] + B[i+1]
    end
    C[end] = B[end-1] - 2B[end]
    return C
end

Arpack.eigs(-A; nev=3, which=:SR)

ArnoldiMethod.partialschur(-A; nev=3, which=ArnoldiMethod.SR())

KrylovKit.eigsolve(-A, size(A, 1), 3, :SR)

# Example 3, 2-dimensional Laplacian
Δ = kronsum(A, A)

Arpack.eigs(Δ; nev=3, which=:LR)
ArnoldiMethod.partialeigen(ArnoldiMethod.partialschur(Δ; nev=3, which=ArnoldiMethod.LR())[1])
KrylovKit.eigsolve(Δ, size(Δ, 1), 3, :LR)
```

In the last line above we leverage the fact that objects of type `L <: LinearMap` are callable.

### Inverse map with conjugate gradient

The `InverseMap` type can be used to lazily represent the inverse of an operator.
When this map acts on a vector the linear system is solved. This can be used to solve a
system of the form ``Sx = (C A^{-1} B) x = b`` without explicitly computing ``A^{-1}``
(see for example solving a linear system using the
[Schur complement](https://en.wikipedia.org/wiki/Schur_complement#Application_to_solving_linear_equations)).

```julia
using LinearMaps, IterativeSolvers

A = [2.0 1.5 0.0
     1.5 3.0 0.0
     0.0 0.0 4.0]
B = [2.0 0.0
     0.0 1.0
     0.0 0.0]
C = B'
b = [2.0, 3.0]

# Use IterativeSolvers.cg! to solve the system with 0 as the initial guess
linsolve = (x, A, b) -> IterativeSolvers.cg!(fill!(x, 0), A, b)

# Construct the linear map S
S = C * InverseMap(A; solver=linsolve) * B

# Solve the system
IterativeSolvers.cg(S, b)
```

In every CG iteration the linear map `S` will act on a vector `v`. Since `S` is a composed
linear map, `S * v` is roughly equivalent to

```julia
# Apply first linear map B to v
tmp1 = B * v
# Apply second linear map: solve linear system with vector tmp1 as RHS
tmp2 = A \ tmp1
# Apply third linear map C to tmp2
result = C * tmp2
```

i.e. inside the CG solver for solving `Sx = b` we use CG to solve another inner linear
system.

## Philosophy

Several iterative linear algebra methods such as linear solvers or eigensolvers
only require an efficient evaluation of the matrix-vector product, where the
concept of a matrix can be formalized / generalized to a linear map (or linear
operator in the special case of a square matrix).

The LinearMaps package provides the following functionality:

1. A `LinearMap` type that shares with the `AbstractMatrix` type that it
   responds to the functions `size`, `eltype`, `isreal`, `issymmetric`,
   `ishermitian` and `isposdef`, `transpose` and `adjoint` and multiplication
   with a vector using both `*` or the in-place version `mul!`. Linear algebra
   functions that use duck-typing for their arguments can handle `LinearMap`
   objects similar to `AbstractMatrix` objects, provided that they can be
   written using the above methods. Unlike `AbstractMatrix` types, `LinearMap`
   objects cannot be indexed, neither using `getindex` or `setindex!`.

2. A single function `LinearMap` that acts as a general purpose
   constructor (though it is only an abstract type) and allows to construct
   linear map objects from functions, or to wrap objects of type
   `AbstractMatrix` or `LinearMap`. The latter functionality is useful to
   (re)define the properties (`isreal`, `issymmetric`, `ishermitian`,
   `isposdef`) of the existing matrix or linear map.

3. A framework for combining objects of type `LinearMap` and of type
   `AbstractMatrix` using linear combinations, transposition, composition,
   concatenation and Kronecker product/sums,
   where the linear map resulting from these operations is never explicitly
   evaluated but only its matrix-vector product is defined (i.e. lazy
   evaluation). The matrix-vector product is written to minimize memory
   allocation by using a minimal number of temporary vectors. There is full
   support for the in-place version `mul!`, which should be preferred for
   higher efficiency in critical algorithms. In addition, it tries to recognize
   the properties of combinations of linear maps. In particular, compositions
   such as `A'*A` for arbitrary `A` or even `A'*B*C*B'*A` with arbitrary `A`
   and `B` and positive definite `C` are recognized as being positive definite
   and hermitian. In case a certain property of the resulting `LinearMap`
   object is not correctly inferred, the `LinearMap` method can be called to
   redefine the properties.
